	CREATE TABLE `objects` (
	  `objectid` int (20) NOT NULL auto_increment,
	  `title` varchar(200) NOT NULL,
	  `description` varchar(1000) default NULL,
	  `url` varchar(2048) default NULL,
	  `saved` int(20) default NULL,
	  `trackedpermission` int(1) default 0,
	  `trackable` int(1) default 1,
	  `pluginid` int(20) default -1,
	  `objecttype` varchar(20) default "",
	  `format` varchar(20) default NULL,
	  `method` varchar(20) default NULL,
	  `concept` mediumtext default NULL,
	  `implementation` mediumtext default NULL,
	  `creatorid` varchar(100) default "",
	  `timestamp` int(20) default 0,
	  `version` varchar(20) default "1.0",
	  `lifetime` int(20) default 0,
      `uuid` char(36) NOT NULL,
	  PRIMARY KEY  (`objectid`)
	) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=3;
	
	CREATE TABLE `associations` (
	  `id` int(20) NOT NULL auto_increment,
	  `objectid0` int(20) NOT NULL,
	  `objectid1` int(20) NOT NULL,
	  `creatorid` varchar(100) default "",
	  `timestamp` int(20) default 0,
	  `version` varchar(20) default "1.0",
	  PRIMARY KEY  (`id`),
	  FOREIGN KEY (`objectid0`) REFERENCES objects(`objectid`) ON DELETE CASCADE,
	  FOREIGN KEY (`objectid1`) REFERENCES objects(`objectid`) ON DELETE CASCADE
	) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;

	CREATE TABLE `categories` (
	  `id` int (20) NOT NULL auto_increment,
	  `categoryid` int(20) NOT NULL,
	  `objectid` int(20) NOT NULL,
	  `creatorid` varchar(100) default "",
	  `timestamp` int(20) default 0,
	  `version` varchar(20) default "1.0",
	  PRIMARY KEY  (`id`),
	  FOREIGN KEY (`objectid`) REFERENCES objects(`objectid`) ON DELETE CASCADE
	) ENGINE=MyISAM  DEFAULT CHARSET=utf8;

	CREATE TABLE `categorynames` (
	  `categoryid` int(11) NOT NULL auto_increment,
	  `categoryname` varchar(100) default NULL,
	  `timestamp` int(20) default 0,
	  `version` varchar(20) default "1.0",
	  PRIMARY KEY  (`categoryid`)
	) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=5;

	CREATE TABLE `comments` (
	  `id` int(20) NOT NULL auto_increment,
	  `objectid` int(20) default NULL,
	  `commenttitle` varchar(200) default NULL,
	  `commenttext` varchar(1000) default NULL,
	  `creatorid` varchar(100) default "",
	  `timestamp` int(20) default 0,
	  `version` varchar(20) default "1.0",
	  PRIMARY KEY  (`id`),
	  FOREIGN KEY (`objectid`) REFERENCES objects(`objectid`) ON DELETE CASCADE
	) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

	CREATE TABLE `acls` (
	  `id` int(20) NOT NULL auto_increment,
	  `objectid` int(20) default 0,
	  `username` varchar(100) default NULL,
	  `groupname` varchar(100) default NULL,
	  `r` int(1) default 0,
	  `e` int(1) default 0,
	  PRIMARY KEY  (`id`),
	  FOREIGN KEY (`objectid`) REFERENCES objects(`objectid`) ON DELETE CASCADE
	) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=3;

	CREATE TABLE `objectdata` (
	  `objectid` int (20) NOT NULL,
	  `totalvotes` int(20) default 0,
	  `totalvoters` int(20) default 0,
	  `rating` float default 0,
	  `hits` int(20) default 0,
	  `numcomments` int(20) default 0,
	  PRIMARY KEY  (`objectid`),
	  FOREIGN KEY (`objectid`) REFERENCES objects(`objectid`) ON DELETE CASCADE
	) ENGINE=MyISAM DEFAULT CHARSET=utf8;

	CREATE TABLE `sessions` (
	  `id` int(20) NOT NULL auto_increment,
	  `expiration` int(20) NOT NULL,
	  `context` text NOT NULL,
	  `creatorid` varchar(100) default "",
	  `timestamp` int(20) default 0,
	  `version` varchar(20) default "1.0",
	  PRIMARY KEY  (`id`)
	) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=3;

	CREATE TABLE `plugins` (
	  `pluginid` int(11) NOT NULL auto_increment,
	  `name` varchar(32) NOT NULL,
	  `dir` varchar(100) NOT NULL,
	  `editor` varchar(32) NOT NULL,
	  `generator` varchar(32) NOT NULL,
	  `collection` varchar(32) default NULL,
	  `collectionname` varchar(32) default NULL,
      `objecttype` varchar(20) default NULL,
	  `description` varchar(255) NOT NULL,
	  `icon16path` varchar(255) NOT NULL,
	  `icon32path` varchar(255) NOT NULL,
	  `icon64path` varchar(255) NOT NULL,
	  `creatorid` varchar(100) default "",
	  `category` varchar(32) NOT NULL,
	  `timestamp` int(20) default 0,
	  `version` varchar(20) default "1.0",
	  PRIMARY KEY  (`pluginid`)
	) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=3;

	CREATE TABLE `plugindata` (
	  `id` int(20) NOT NULL auto_increment,
	  `objectid` int(20) NOT NULL,
	  `pluginid` int(20) NOT NULL,
	  `name` varchar(100) NOT NULL,
	  `value` mediumtext default NULL,
	  `creatorid` varchar(100) default "",
	  `timestamp` int(20) default 0,
	  `version` varchar(20) default "1.0",
	  PRIMARY KEY  (`id`),
	  FOREIGN KEY (`objectid`) REFERENCES objects(`objectid`) ON DELETE CASCADE,
	  FOREIGN KEY (`pluginid`) REFERENCES plugins(`pluginid`) ON DELETE CASCADE
	) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=3;

	CREATE TABLE `favorites` (
	  `id` int(20) NOT NULL auto_increment,
	  `objectid` int(20) NOT NULL,
	  `creatorid` varchar(100) default "",
	  `timestamp` int(20) default 0,
	  `version` varchar(20) default "1.0",
	  PRIMARY KEY  (`id`),
	  FOREIGN KEY (`objectid`) REFERENCES objects(`objectid`) ON DELETE CASCADE
	) ENGINE=MyISAM DEFAULT CHARSET=utf8;

	CREATE TABLE `params` (
	  `id` int(20) NOT NULL auto_increment,
	  `objectid` int(20) NOT NULL,
	  `parametername` varchar(100) NOT NULL,
	  `parametertype` varchar(20) default NULL,
	  `defaultvalue` text default NULL,
	  `creatorid` varchar(100) default "",
	  `timestamp` int(20) default 0,
	  `version` varchar(20) default "1.0",
	  `helptext` varchar(256) default '',
	  `prompt` varchar(256) default NULL,
	  `parameterorder` INTEGER default NULL,
	  `optional` char,
	  `displayname` varchar(256) default '',
	  PRIMARY KEY  (`id`),
	  FOREIGN KEY (`objectid`) REFERENCES objects(`objectid`) ON DELETE CASCADE
	) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=3;

	CREATE TABLE `purexmldata` (
	  `id` int(20) NOT NULL auto_increment,
	  `feedid` int(20) NOT NULL,
	  `db2datasource` varchar(100) default NULL,
	  `db2table` varchar(255) default NULL,
	  `db2column` varchar(255) default NULL,
	  `db2row` varchar(255) default NULL,
	  `db2exists` int(20) default NULL,
	  `db2title` varchar(255) default NULL,
	  `db2summary` varchar(255) default NULL,
	  `db2creator` varchar(255) default NULL,
	  `db2rows` varchar(255) default NULL,
	   PRIMARY KEY  (`id`)
	) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=3;

	CREATE TABLE `ratings` (
	  `id` int(20) NOT NULL auto_increment,
	  `objectid` int(20) NOT NULL,
	  `ratingvalue` int(20) NOT NULL,
	  `creatorid` varchar(100) default "",
	  `timestamp` int(20) default 0,
	  `version` varchar(20) default "1.0",
	  PRIMARY KEY  (`id`),
	  FOREIGN KEY (`objectid`) REFERENCES objects(`objectid`) ON DELETE CASCADE
	) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=8 ;

	CREATE TABLE `sqldata` (
	  `id` int(20) NOT NULL auto_increment,
	  `feedid` int(11) default NULL,
	  `sqlstatement` varchar(500) default NULL,
	  `sqldb` varchar(100) default NULL,
	  PRIMARY KEY (`id`)
	) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=3;

	CREATE TABLE `tags` (
	  `id` int(20) NOT NULL auto_increment,
	  `tagname` varchar(50) NOT NULL,
	  `objectid` int(20) NOT NULL,
	  `creatorid` varchar(100) default "",
	  `timestamp` int(20) default 0,
	  `version` varchar(20) default "1.0",
	  PRIMARY KEY  (`id`),
	  FOREIGN KEY (`objectid`) REFERENCES objects(`objectid`) ON DELETE CASCADE
	) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=5 ;

	CREATE TABLE `users` (
	  `username` varchar(60) BINARY NOT NULL,
	  `fullname` varchar(100) NOT NULL,
	  `password` varchar(60) NOT NULL,
	  `email` varchar(128) default NULL,
	  `permissions` int(20) NOT NULL,
	  `reportemail` int(1) default 0,
	  `creatorid` varchar(100) default "",
	  `timestamp` int(20) default 0,
	  `version` varchar(20) default "1.0",
	  PRIMARY KEY  (`username`)
	) ENGINE=MyISAM  DEFAULT CHARSET=utf8;

	CREATE TABLE `groups` (
	  `id` int(20) NOT NULL auto_increment,
	  `groupname` varchar(50) default NULL,
	  `query` varchar(1024) default NULL,
	  PRIMARY KEY  (`id`)
	) ENGINE=MyISAM  DEFAULT CHARSET=utf8;

	CREATE TABLE `keywords` (
	  `id` int(20) NOT NULL auto_increment,
	  `keywords` mediumtext NOT NULL,
	  `objectid` int(20) NOT NULL,
	  `creatorid` varchar(100) default "",
	  `timestamp` int(20) default 0,
	  `version` varchar(20) default "1.0",
	  PRIMARY KEY  (`id`),
	  FOREIGN KEY (`objectid`) REFERENCES objects(`objectid`) ON DELETE CASCADE
	) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=3;

	CREATE TABLE `urlinfo` (
	  `id` int(20) NOT NULL auto_increment,
	  `url` varchar(2048) NOT NULL,
	  `hourlycount` int(20) default '1',
	  `lasttime` timestamp default 0,
	  `creatorid` varchar(100) default "",
	  `timestamp` int(20) default 0,
	  `version` varchar(20) default "1.0",
	  PRIMARY KEY  (`id`)
	) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=3;

	CREATE TABLE `trackingconfig` (
	  `id` int(11) NOT NULL auto_increment,
	  `type` int(1) NOT NULL default '0',
	  `host` varchar(255) default NULL,
	  `vname` varchar(255) default NULL,
	  `vpk`  varchar(255) default NULL,
	  `creatorid` varchar(100) default "",
	  `timestamp` int(20) default 0,
	  `version` varchar(20) default "1.0",
	  PRIMARY KEY  (`id`)
	) ENGINE=MyISAM DEFAULT CHARSET=utf8;

	CREATE TABLE `trackedexternal` (
	  `id` int(11) NOT NULL auto_increment,
	  `objectid` int(11) NOT NULL default '0',
	  `pluginid` int(11) NOT NULL default '0',
	  `serviceid` varchar(255) default NULL,
	  `parameters` varchar(255) default NULL,
	  `endpoint`  varchar(255) default NULL,
	  `creatorid` varchar(100) default "",
	  `timestamp` int(20) default 0,
	  `version` varchar(20) default "1.0",
	  PRIMARY KEY (`id`),
	  FOREIGN KEY (`objectid`) REFERENCES objects(`objectid`) ON DELETE CASCADE
	) ENGINE=MyISAM DEFAULT CHARSET=utf8;

	CREATE TABLE `trackedlocal` (
	  `id` int(11) NOT NULL auto_increment,
	  `objectid` int(11) NOT NULL default '0',
	  `pluginid` int(11) NOT NULL default '0',
	  `ip` varchar(255) default NULL,
	  `username` varchar(255) default NULL,
	  `executiontime` int(11) default NULL,
	  `creatorid` varchar(100) default "",
	  `timestamp` int(20) default 0,
	  `version` varchar(20) default "1.0",
	  PRIMARY KEY  (`id`),
	  FOREIGN KEY (`objectid`) REFERENCES objects(`objectid`) ON DELETE CASCADE
	) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;

	CREATE TABLE `resources` (
	  `id` int(20) NOT NULL auto_increment,
	  `objectid` int(20) NOT NULL,
	  `content` longblob NOT NULL,
	  `mimetype` varchar(30) NOT NULL,
	  `filename` varchar(60) NOT NULL,
	  `timestamp` int(20) default 0,
	   PRIMARY KEY  (`id`),
	   FOREIGN KEY (`objectid`) REFERENCES objects(`objectid`) ON DELETE CASCADE
	) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;

	CREATE TABLE `events` (
	  `id` int(20) NOT NULL auto_increment,
	  `objectid` int(20) NOT NULL,
	  `action` varchar(60) default NULL,
	  `description` mediumtext NOT NULL,
	  `creatorid` varchar(100) default "",
	  `timestamp` int(20) default 0,
	  `version` varchar(20) default "1.0",
	  PRIMARY KEY  (`id`),
	  FOREIGN KEY (`objectid`) REFERENCES objects(`objectid`) ON DELETE CASCADE
	) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;

	CREATE TABLE `log` (
	  `id` int(20) NOT NULL auto_increment,
	  `level` varchar(2) NOT NULL,
	  `component` varchar(30) NOT NULL,
	  `error` mediumtext NOT NULL,
	  `creatorid` varchar(100) default "",
	  `timestamp` int(20) default 0,
	  `version` varchar(20) default "1.0",
	  PRIMARY KEY  (`id`)
	) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;

	CREATE TABLE `db_conns` (
	  `id` int(20) NOT NULL auto_increment,
	  `creatorid` varchar(100) default "",
	  `name` varchar(1024) NOT NULL,
	  `dbtype` varchar(20) default NULL,
	  `dbname` varchar(1024) default NULL,
	  `dbhost` varchar(100) default NULL,
	  `dbport` varchar(100) default NULL,
	  `dbusr` varchar(100) default NULL,
	  `dbpwd` varchar(100) default NULL,
	  `dbsrv` varchar(100) default NULL,
	  `timestamp` int(20) default 0,
	  `version` varchar(20) default "1.0",
	  PRIMARY KEY  (`id`)
	) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;

	CREATE TABLE `connections` (
	  `id` int(20) NOT NULL auto_increment,
	  `creatorid` varchar(100) default "",
	  `cname` varchar(100) NOT NULL,
	  `username` varchar(1024) NOT NULL,
	  `password` varchar(1024) NOT NULL,
	  `data` mediumtext default NULL,
	  `timestamp` int(20) default 0,
	  PRIMARY KEY  (`id`)
	) ENGINE=MyISAM DEFAULT CHARSET=utf8;

	CREATE TABLE `tmpobjects` (
	  `objectid` int (20) NOT NULL auto_increment,
	  `creatorid` varchar(100) default "",
	  `startedit` int(20) default 0,
	  PRIMARY KEY  (`objectid`)
	) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=3;

	CREATE TABLE `tmpresources` (
	  `id` int(20) NOT NULL auto_increment,
	  `objectid` int(20) NOT NULL,
	  `content` longblob NOT NULL,
	  `mimetype` varchar(30) NOT NULL,
	  `filename` varchar(60) NOT NULL,
	  `timestamp` int(20) default 0,
	   PRIMARY KEY  (`id`)
	) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1;

	CREATE TABLE `tmpparams` (
	  `id` int(20) NOT NULL auto_increment,
	  `objectid` int(20) NOT NULL,
	  `parametername` varchar(100) NOT NULL,
	  `parametertype` varchar(20) default NULL,
	  `defaultvalue` text default NULL,
	  `creatorid` varchar(100) default "",
	  `timestamp` int(20) default 0,
	  `version` varchar(20) default "1.0",
	  `helptext` varchar(256) default '',
	  `prompt` varchar(256) default NULL,
	  `parameterorder` INTEGER default NULL,
	  `optional` char,
	  `displayname` varchar(256) default '',
	  PRIMARY KEY  (`id`)
	) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=3;

	CREATE TABLE `tmpplugindata` (
	  `id` int(20) NOT NULL auto_increment,
	  `objectid` int(20) NOT NULL,
	  `pluginid` int(20) NOT NULL,
	  `name` varchar(100) NOT NULL,
	  `value` mediumtext default NULL,
	  `creatorid` varchar(100) default "",
	  `timestamp` int(20) default 0,
	  `version` varchar(20) default "1.0",
	  PRIMARY KEY  (`id`)
	) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=3;

	CREATE TABLE `db_conns_use` (
	  `dbconnid` int(20) NOT NULL,
	  `objectid` int(20) NOT NULL,
	  `timestamp` int(20) default 0
	) ENGINE=MyISAM  DEFAULT CHARSET=utf8;

	CREATE TABLE `connections_use` (
	  `connectionid` int(20) NOT NULL,
	  `objectid` int(20) NOT NULL,
	  `timestamp` int(20) default 0
	) ENGINE=MyISAM  DEFAULT CHARSET=utf8;

	CREATE TABLE `tmpdb_conns_use` (
	  `dbconnid` int(20) NOT NULL,
	  `objectid` int(20) NOT NULL,
	  `timestamp` int(20) default 0
	) ENGINE=MyISAM  DEFAULT CHARSET=utf8;

	CREATE TABLE `tmpconnections_use` (
	  `connectionid` int(20) NOT NULL,
	  `objectid` int(20) NOT NULL,
	  `timestamp` int(20) default 0
	) ENGINE=MyISAM  DEFAULT CHARSET=utf8;
	
	CREATE TABLE `tmprc` (
	  `id` int(20) NOT NULL
	) ENGINE=MyISAM  DEFAULT CHARSET=utf8;