/*
	Copyright (c) 2007-2008, IBM Corp.
*/
dojo.provide("flow.dijit.Palette");

dojo.require("dijit._Widget");
dojo.require("dijit._Container");

dojo.require("flow.dijit.PaletteItem");
dojo.require("btp.dnd.DragSource");
dojo.require("btp.widget._PaletteBase");
dojo.require("dijit.layout.AccordionContainer");

dojo.declare(
  "flow.dijit.Palette",
  [btp.widget._PaletteBase],
  {
    accordion: null,
    "class": "flowPalette",

    //defaultClickHandler: "flow.hale.CreationTool",
    defaultDropHandler: "flow.hale.CreationTool",

    postCreate: function() {
      this.postProcess();
      dojo.setSelectable(this.domNode, false);
    },

    resize: function(args) {
      // pass resize to accordion
      this.accordion.resize(args);
    },

    createPalette: function(modelId) {
      var div = document.createElement("div");
      div.style.height = "400px";
      div.style.width = "100%";
      this.domNode.appendChild(div);
			this.accordion = new dijit.layout.AccordionContainer({}, div);

      var model = dijit.byId(modelId);
		  var selectedNode = model.selectSingleNodeFromJson(".");
      var categoryNodes = btp.getChildNodes(selectedNode, "category");

      for (var i = 0; i < categoryNodes.length; i++) {
        var folderNode = categoryNodes[i];
        //var desc = folderNode["description"];
        var i18n = dojo.i18n.getLocalization("flow", "labels");
        var desc = i18n.CATEGORY_DEFAULT;

        var div = document.createElement("div");
        div.style.height = "100%";
        div.style.width = "100%";
        this.accordion.domNode.appendChild(div)
        var container = new dijit.layout.AccordionPane({title: desc, selected: i == 1}, div);

        var componentNodes = btp.getChildNodes(folderNode, "component");
        for (var j = 0; j < componentNodes.length; j++) {
          var component = componentNodes[j];

          if (!component["dropTargets"] || component["operatortype"] == "publish") {
            continue;
          }

          var div = document.createElement("div");
          container.containerNode.appendChild(div);

          var clickHandler = component["clickHandler"];
          var dropHandler = component["dropHandler"];
          if (!clickHandler){
            clickHandler = this.defaultClickHandler;
          }
          if (!dropHandler){
            dropHandler = this.defaultDropHandler;
          }

          var item = new flow.dijit.PaletteItem({palette: this, name: component["name"], operatortype: component["operatortype"], clickHandler: clickHandler, dropHandler: dropHandler}, div);
          var ds = new btp.dnd.DragSource(item.domNode, "component", item);
          ds.targetShouldShowCaret = true;
          dojo.connect(ds, "onDragStart", this, "onDragStart");
          dojo.connect(ds, "onDragEnd", this, "onDragEnd");
          ds.offsetParent = dojo.doc.body;
          this.dragSources.push(ds);
        }

        this.accordion.addChild(container);
      }

      this.accordion.resize();
      this.accordion.startup();
    },

    createOperator: function(type) {
      var model = dijit.byId("flowcanvas").model;
      model.createItem(type);
    }
  }
);
