/*
	Copyright (c) 2007-2008, IBM Corp.
*/
dojo.provide("flow.dijit.PaletteItem");

dojo.require("dojo.dnd.Source");
dojo.require("dijit._Widget");
dojo.require("dijit._Container");
dojo.require("dijit._Templated");

dojo.require("btp.dnd.DragSource");
dojo.require("btp.widget._PaletteBase");

dojo.require("dojo.i18n");
dojo.requireLocalization("flow", "labels");

dojo.declare(
  "flow.dijit.PaletteItem",
  [btp.widget._PaletteItemBase, dijit._Templated],
  {
    // attach points
    node: null,

    // passed in data
    label: "",
    operatortype: "",

    dragSource: null,

    operatorTitle: null,
    templateString: "<div class='flowPaletteItem' dndType='operator' dojoAttachPoint='node' title='${operatorTitle}'><div class='flowPaletteItemIcon'></div><div class='flowPaletteItemText'><a href='javascript:void(0)'>${label}</a></div></div>",

    buildRendering: function() {
      var i18n = dojo.i18n.getLocalization("flow", "labels");
      this.label = i18n["OPERATOR_"+this.operatortype.toUpperCase()];
      this.operatorTitle = i18n["OPERATOR_"+this.operatortype.toUpperCase()+"_TOOLTIP"];

      dijit._Templated.prototype.buildRendering.apply(this);

      this.domNode.componentClassName = this.name;

      var imgurl = dojo.moduleUrl("flow.dijit", "templates/images") + "/op-icon-"+this.operatortype+".png";
      var div = document.createElement("div");
      div.className = "flowPaletteItemTypeIcon";

      if (dojo.isIE == 6) {
        div.runtimeStyle.filter = "progid:DXImageTransform.Microsoft.AlphaImageLoader(enabled=true, sizingMethod=fixed src='"+imgurl+"');"
        div.style.backgroundImage = "none";
        // position the image
        div.style.marginLeft = "5px";
        div.style.marginTop = "4px";
      } else {
        div.style.backgroundImage = "url('"+imgurl+"')";
      }

      this.node.firstChild.appendChild(div);
    },

    postCreate: function() {
      this.inherited("postCreate", arguments);
      this._connects.push(dojo.connect(this.domNode, "ondblclick", this, "itemDoubleClickHander"));
    },

    // for double click and create
    itemDoubleClickHander: function(e){
      var editor = btp.getEditors()[0];
      if (this.palette.pushedItem == this) {
        var model = dijit.byId("flowcanvas").model;
        model.createItem(this.operatortype);
      }
      this.palette.pushedItem = null;
      editor.getEditDomain().loadDefaultTool();
    },

    itemMouseUpHander: function(e){
    },

    flat: function(div) {
      dojo.removeClass(this.domNode, "flowPaletteItemHover")
    },

    raised: function(div) {
      // mouse over
      dojo.addClass(this.domNode, "flowPaletteItemHover")
    },

    sunken: function(div) {
    }
  }
);
