/*
	Copyright (c) 2007-2008, IBM Corp.
*/
dojo.provide("flow.dijit.RuntimeParameterInputSelection");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("dojo.i18n");
dojo.requireLocalization("flow", "propertyeditor");

dojo.declare(
	"flow.dijit.RuntimeParameterInputSelection",
	[dijit._Widget, dijit._Templated],
  {
    // attach points
    labelNodeName: null,
    nameNode: null,
    labelNodeDefault: null,
    defaultValueNode: null,

    // arguments
    operator: null,
    data: null,

    templatePath: dojo.moduleUrl("flow.dijit", "templates/RuntimeParameterInputSelection.html"),

    postMixInProperties: function() {
      this.i18n = {};
      this.i18n.propertyeditor = dojo.i18n.getLocalization("flow", "propertyeditor");
    },

    postCreate: function() {
      // TODO: If type of data is text, use caption.  This is when we convert text
      // to dynamic.  Probably needs to be fixed at some point
      if (this.data.type == "text") {
        this.nameNode.value = (this.data && this.data.caption) ? this.data.caption : "";
      } else {
        this.nameNode.value = (this.data && this.data.name) ? this.data.name : "";
      }
      this.defaultValueNode.value = (this.data && this.data.value) ? this.data.value : "";
    },

    getData: function() {
      if (this.nameNode.value.replace(/^\s+|\s+$/g,"")=="") {
        alert(this.operator.i18n.RUNTIMEPARAMSELCTIONDIALOG_NAME_MISSING);
        return null;
      }

      var data = flow.operator.Data.create("dynamic");

      if (this.nameNode.value) {
        data.name = this.nameNode.value;
      }

      if (this.defaultValueNode.value) {
        data.value = this.defaultValueNode.value;
      }

      return data;
    }
  }
);
