/*
	Copyright (c) 2007-2008, IBM Corp.
*/
dojo.provide("flow.dijit.ShowModel");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dijit._Container");
dojo.require("dijit.layout.TabContainer");
dojo.require("dojox.data.dom");
dojo.require("flow.dijit.Dialog");
dojo.require("flow.dijit.XMLViewTree");
dojo.require("dijit.layout.TabContainer");

dojo.require("dojo.i18n");
dojo.requireLocalization("flow", "labels");

dojo.declare(
  "flow.dijit.ShowModel",
  [dijit._Widget, dijit._Container, dijit._Templated],
  {
    // arguments
    model: null,

    // attach points
    tabcontainerNode: null,
    treeContainerNode: null,
    sourceTextAreaNode: null,

    // localization
    i18n: null,

    widgetsInTemplate: true,

    // impl
    templatePath: dojo.moduleUrl("flow.dijit", "templates/ShowModel.html"),

    postMixInProperties: function() {
      this.i18n = {};
      this.i18n.labels = dojo.i18n.getLocalization("flow", "labels");
    },

    postCreate: function() {
      var tab = this.tabcontainerNode;
      tab.startup();
      tab.resize();

      // setup textarea
      this.sourceTextAreaNode.value = dojox.data.dom.innerXML(this.model.xmlModel);

      new flow.dijit.XMLViewTree({xmlRootNode: this.model.xmlModel.documentElement}, this.treeContainerNode);
    },
    onModelChanged: function()
    {
		this.model.xmlModel= flow.xml.loadDocument(this.sourceTextAreaNode.value);
		var masupnode = flow.xml.loadDocument(this.sourceTextAreaNode.value);
    	var flownode=masupnode.firstChild.childNodes[0];
    	var data=masupnode.firstChild.childNodes[1];
		this.model.load(flownode);
		this.model.removeNodes(".//flow:input[@timestamp='']", this.model.flowNode);
    }
  }
);

