/*
	Copyright (c) 2007-2008, IBM Corp.
*/
dojo.provide("flow.dijit.VariableInputSelection");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

dojo.require("dojo.i18n");
dojo.requireLocalization("flow", "propertyeditor");

dojo.declare(
	"flow.dijit.VariableInputSelection",
	[dijit._Widget, dijit._Templated],
  {
    // attach points
    labelNode: null,
    selectNode: null,

    // arguments
    operator: null,
    defaultValue: null,

    // impl
    templatePath: dojo.moduleUrl("flow.dijit", "templates/VariableInputSelection.html"),

    postMixInProperties: function() {
      this.i18n = {};
      this.i18n.propertyeditor = dojo.i18n.getLocalization("flow", "propertyeditor");
    },

    postCreate: function() {
      this.operator.generateVariableListBox(this.selectNode, "//flow:param[@type='dynamic']");
    },

    getData: function() {
      var data = flow.operator.Data.create("variable");

      if (this.selectNode.value) {
        data.value = this.selectNode.value;
      }

      return data;
    }
  }
);
