/*
	Copyright (c) 2007-2008, IBM Corp.
*/
dojo.provide("flow.dijit.XMLInputSelection");

dojo.require("dijit._Widget");
dojo.require("dijit._Container");
dojo.require("dijit._Templated");
dojo.require("flow.dijit.XMLTypeTree");

dojo.require("dojo.i18n");
dojo.requireLocalization("flow", "propertyeditor");

dojo.declare(
	"flow.dijit.XMLInputSelection",
	[dijit._Widget, dijit._Templated, dijit._Container],
  {
    // attach points
    labelNode: null,
    xmlTreeNode: null,

    // arguments
    data: null,
    operator: null,
    chain: null,

    // impl
    xmltree: null,
    treeid: null,

    templatePath: dojo.moduleUrl("flow.dijit", "templates/XMLInputSelection.html"),

    postMixInProperties: function() {
      this.i18n = {};
      this.i18n.propertyeditor = dojo.i18n.getLocalization("flow", "propertyeditor");
    },

    postCreate: function() {
      var div = document.createElement("div");
      this.xmlTreeNode.appendChild(div);

      // setup the tree
      var treedata = this.operator.getTree(0);
      if (treedata) {
        this.operator.model.setValue("flow:input[@position='0']/@timestamp",this.operator.node,treedata.timestamp);
      }
      this.treeid = treedata.id;
      this.xmltree = new flow.dijit.XMLTypeTree({xmlRootNode: treedata.root, path: treedata.path, getLabelClass: dojo.hitch(this, this.onTreeGetLabelClass), operator: this.operator, chain: this.chain}, div);
    },

    onTreeGetLabelClass: function(item) {
      var value = this.data ? this.data.value : null;

      if (item && value && item.store.buildXPath(item.store.getNode(item), true) == value) {
        return "xmlviewtreeselected";
      }

      return "";
    },

    getData: function() {
      var data = flow.operator.Data.create("xpath");

      if (this.xmltree.selectedItem) {
        var store = this.xmltree.store;
        data.value = "./"+this.xmltree.getXPathForTreeItem(this.xmltree.selectedItem);
        data.inputid = this.treeid;
      }

      return data;
    }
  }
);
