/*
	Copyright (c) 2007-2008, IBM Corp.
*/
dojo.provide("flow.operator.Data");

/*
  Data class passed around between operators and other UI components
*/

dojo.declare("flow.operator.BaseParameterData", null, {
  // required
  id: null,
  type: null,

  // optional
  position: null,
  comments: null,
  caption: null,
  inputid: null
});

dojo.declare("flow.operator.ParameterData", flow.operator.BaseParameterData, {
  type: "text",
  value: null,

  constructor: function(type, id) {
    this.id = id;

    if (type) {
      this.type = type;
    }
  }
});

dojo.declare("flow.operator.DynamicParameterData", flow.operator.BaseParameterData, {
  type: "dynamic",
  value: null,
  name: null,

  constructor: function(id) {
    this.id = id;
  }
});

dojo.declare("flow.operator.FunctionParameterData", flow.operator.BaseParameterData, {
  type: "function",

  name: null,
  parameters: null,

  constructor: function(id) {
    this.id = id;
  }
});

flow.operator.Data = {
  create: function(type, id) {
    if (type == "function") {
      return new flow.operator.FunctionParameterData(id);
    } else if (type == "dynamic") {
      return new flow.operator.DynamicParameterData(id);
    } else {
      return new flow.operator.ParameterData(type, id);
    }
  }
}
