/*
	Copyright (c) 2007-2008, IBM Corp.
*/
dojo.provide("fed.widget.decoration.DraggableImageDecoration");

// Summary:
//		A decorative Figure intended to be placed on a gfx line.
//		Note that this is not a widget.
dojo.require("gdc._base.shape");
dojo.require("gdc.widget.decoration.AbstractDecoration");

dojo.declare(
	"fed.widget.decoration.DraggableImageDecoration",
	gdc.widget.decoration.AbstractDecoration,
{
//	src: "gdc/tests/fish.gif",
//	src: "btp/widget/templates/EditArea/handle.gif",
	src: "gdc/widget/templates/PlugNode/plug.gif",
	width: 27,
	height: 38,
	offsetX: -28,
	offsetY: -19,

	constructor: function(owner, props){
	},

	createTargetShape: function(parent){
		var shape = this.shape = parent.createGdcImage({width:this.width, height:this.height, src:dojo.moduleUrl("hale", "../"+this.src)+""});
		var _this = this;
		shape.rawNode.getDragTracker = function(){
			_this.owner.__editArea.setFocus(_this.owner);
			return "gdl.widget.tool.ReconnectTracker";
		};

		// assign the owner of this decoration to the top level dom node
		// so that the owner widget can be found from dom node. (See btp._base.utils.getWidgetByElement)
		shape.rawNode.widget = this.owner; // [custom property]
		return shape;
	},

	update: function(props){
		var shape = this.shape;
		if(!shape){ return; }
		shape.setShape({width:this.width, height:this.height, src:dojo.moduleUrl("gdc", "../"+this.src)+""});
	},

	removeShape: function(){
		this.owner.__editArea.extensions["gdl.widget.ext.connectionEndpoints"].removeConnectionEndpoints(this.owner);
	},

	// Returns dimensions of this decoration.
	// cf. gdl.widget.ext.connectionEndpoints#addConnectionEndpoints
	getDimensions: function(){
		if(!this.shape){ return null; }
		var transform = this.shape.getTransform();
		return {
			width: this.width,
			height: this.height,
			top: transform.dy,
			left: transform.dx
		};
	},

	setLocation: function(/*{x:#,y:#}*/pt){
		this.shape.setTransform({dx:pt.x + this.offsetX, dy:pt.y + this.offsetY});
		this.owner.__editArea.extensions["gdl.widget.ext.connectionEndpoints"].addConnectionEndpoints(this.owner);
	},

	setRotation: function(/*float*/angle){
//		var rotate = dojox.gfx.matrix.rotategAt(angle, 0, 0);
//		this.shape.applyTransform(rotate);
	}
});
