/*
	Copyright (c) 2007-2008, IBM Corp.
*/
dojo.provide("led.widget.EditArea");

dojo.require("btp.widget.EditArea");

dojo.declare(
	"led.widget.EditArea",
	btp.widget.EditArea,
{
	constructor: function(){
		this.defaultHelperClasses = [
			"btp.widget.helper.baseHelper",
			"btp.widget.helper.focusHelper",
			"btp.widget.helper.styleHelper",
			"btp.widget.helper.dropHelper",
			"btp.widget.propsrc.componentPropertySource"
		];
		this.actionClasses = [
			"btp.widget.action.Actions"
		];
		this.loaderClass = "btp.widget.data.htmlLoader";
		this.generatorClass = "btp.widget.data.htmlGenerator";
		this.contentOutlinePageClass = "btp.widget.outline.TreeContentOutlinePage";
//		this.contentOutlinePageClass = "btp.widget.outline.CloneContentOutlinePage";
		this.contentProviderClass = "btp.widget.provider.WidgetTreeContentProvider";
	},

	postCreate: function(){
		led.widget.EditArea.superclass.postCreate.apply(this, arguments);
		if(window.location.href.indexOf("http") == 0){
			this.ioClass = "btp.widget.io.RestIO";
		}else {
			this.ioClass = "btp.widget.io.FileIO";
		}
		this.resizeConn = dojo.connect(this, "onEaMouseOverHandler", this, "loadResizeExt");
		this.setOutlineMode("outlineMode");
	},

	loadResizeExt: function(){
		dojo.disconnect(this.resizeConn);
		btp.loadExtension(this, "btp.widget.ext.selectionHandles");
		this.selectionKnobType = "whiteCircle"; // "whiteCircle" or "blackSquare"(default)
	},

	// override
	getContentOutlinePageClass: function(){
		var mode = this.getOutlineMode();
		if(mode == "outlineMode"){
			this.contentOutlinePageClass = "btp.widget.outline.TreeContentOutlinePage";
			this.contentProviderClass = "btp.widget.provider.WidgetTreeContentProvider";
		}else if(mode == "overviewMode"){
			this.contentOutlinePageClass = "btp.widget.outline.CloneContentOutlinePage";
			this.contentProviderClass = "btp.widget.provider.WidgetTreeContentProvider";
		}else{
			alert("EditArea: unknown mode: "+mode);
		}
		return this.contentOutlinePageClass;
	},

	getOutlineToolbarConf: function(){
		var json = {
		    toolBar: {
		      item: [{
		        "@command": "changeOutlineMode",
		        "@arg": "outlineMode",
		        "@tooltip": "Outline Mode",
		        "@radio": "true",
		        "@name": "outline1",
		        "@selected": "true",
		        "@iconPath": "widget/templates/OutlineView/outline.gif"
		      },
		      {
		        "@command": "changeOutlineMode",
		        "@arg": "overviewMode",
		        "@tooltip": "Overview Mode",
		        "@radio": "true",
		        "@name": "outline1",
		        "@iconPath": "widget/templates/OutlineView/overview.gif"
		      }]
		    }
		};
		return json;
	}
});
