/*
	Copyright (c) 2007-2008, IBM Corp.
*/
dojo.provide("btp._base.dom");

// summary:
//		Utility functions for html/dom manipulation.

dojo.mixin(btp,
{
	getEventCoords: function(e){
		var y = 0, x = 0;
		if(e.pageX){
			y = e.pageY;
			x = e.pageX;
		}else{
			x = e.clientX + dojo.doc.body.scrollLeft - dojo.doc.body.clientLeft;
			y = e.clientY + dojo.doc.body.scrollTop - dojo.doc.body.clientTop;
			if(dojo.doc.body.parentElement && dojo.doc.body.parentElement.clientLeft){
				var parent = dojo.doc.body.parentElement;
				x += parent.scrollLeft - parent.clientLeft;
				y += parent.scrollTop - parent.clientTop;
			}
		}
		return {x:x, y:y};
	},

	getDimensions: function(elem, parent){
		if(!elem.tagName){ alert("btp.getDimensions: internal error"); }
		var top = 0, left = 0;
		var width = elem.offsetWidth; 
		var height = elem.offsetHeight;
		for(; elem != null; elem = elem.offsetParent){
			if(typeof(parent) == "object" && elem == parent
				|| typeof(parent) == "string" && elem.className == parent)
				break;
			top += elem.offsetTop;
			left += elem.offsetLeft;
		}
		return {top:top, left:left, width:width, height:height};
	},

	getChildNodes: function(node, name){
		if(node.nodeName){ // XML
			return node.childNodes;
		}
		var val = node[name];
		if(!val){
			return [];
		}
		if(val.length != undefined){ // array
			return val;
		}else{
			return [val];
		}
	}
});
