/*
	Copyright (c) 2007-2008, IBM Corp.
*/
dojo.provide("btp._base.impl");

// summary:
//		Load the implementation and call its method.

dojo.mixin(btp,
{
	loadImpl: function(instance, className, method, args, ret){
		if(!className){ return null; }
		var name = className.replace(/.*\./, ""); // Ex. btp.sub.focus -> focus
		var flagName = "use"+name.charAt(0).toUpperCase() + name.substring(1); // Ex. useFocus
		if(btpConfig[flagName] == false){ return ret; }
		dojo["require"](className);
		var props = dojo.getObject(className);
		dojo.mixin(instance, props);
		if(props[method]){ // method was replaced successfully
			return instance[method].apply(instance, args);
		}
		return ret;
	},

	callImpl: function _1_btp__base_impl_callImpl(instance, className, method, args, ret){
		if(!className){ return null; }
		if(!btp._cacheFlags){ btp._cacheFlags = []; }
		var flag = btp._cacheFlags[className];
		if(flag == undefined){
			var name = className.replace(/.*\./, ""); // Ex. btp.sub.focus -> focus
			var flagName = "use"+name.charAt(0).toUpperCase() + name.substring(1); // Ex. useFocus
			flag = btp._cacheFlags[className] = btpConfig[flagName];
		}
		if(flag == false){ return ret; }
		if(!dojo._loadedModules[className]){
			dojo["require"](className);
		}

		if(!btp._cacheLoadedModules){ btp._cacheLoadedModules = []; }
		var module = btp._cacheLoadedModules[className];
		if(module == undefined){
			module = btp._cacheLoadedModules[className] = dojo.getObject(className);
		}
		return module[method].apply(instance, args);
	},

	mixinExtension: function(owner, moduleName){
		var pos = moduleName.lastIndexOf(".");
		var name = (pos == -1) ? moduleName : moduleName.substring(pos + 1);
		if(owner[name]){ return; } // already loaded
		dojo["require"](moduleName);
		var props = dojo.getObject(moduleName);
		dojo.mixin(owner, props);
		if(owner[name]){
			owner[name]();
		}
	},

	loadExtension: function(owner, moduleName){
		if(!owner.extensions){
			owner.extensions = {};
		}
		if(owner.extensions[moduleName]){ return; } // already loaded
		dojo["require"](moduleName);
		var impl = dojo.getObject(moduleName);
		return owner.extensions[moduleName] = new impl(owner);
	}
});
