/*
	Copyright (c) 2007-2008, IBM Corp.
*/
dojo.provide("btp._base.url");

// summary:
//		Utility functions for url manipulation.

dojo.mixin(btp,
{
	// See also RepositoryService.java
	splitUrl: function(url){
		// url: http://localhost:8080/btp/repos/kami/led/clock;edit
		var map = {};
		if(!url) //TODO: Do not omit curly braces, '{' and '}'.
			return map;
		if(url.indexOf(';') != -1){
			var frag = url.split(";");
			url = frag[0];
			map["action"] = frag[1];
		}
		else
			map["action"] = "";
		map["url"] = url;
		var pos = url.indexOf("://");
		if(pos == -1) //TODO: Do not omit curly braces, '{' and '}'.
			return map;
		var pos = url.indexOf("/", pos + 3);
		if(pos == -1) //TODO: Do not omit curly braces, '{' and '}'.
			return map;
		map["base"] = url.substring(0, pos + 1); // http://localhost:8080/
		var path = map["path"] = url.substring(pos + 1); // btp/repos/kami/led/clock
		var arr = path.split("/", 5); // Ex. "btp", "repos", "kami", "led", "clock"
		map["contextRoot"] = arr[0]; // btp
		map["pattern"] = arr[1]; // repos
		map["spaceId"] = arr[2]; // kami
		map["applicationId"] = arr[3]; // led
		map["resourceId"] = arr[4]; // clock
		map["key"] = arr[2]+"/"+arr[3]+"/"+arr[4];
		if(map["resourceId"]){
			var suffix = "";
			var idx = map["resourceId"].lastIndexOf('.');
			if(idx != -1){
				suffix = map["resourceId"].substring(idx + 1);
			}
			map["suffix"] = suffix;
		}
		map["list"] = map["base"]+arr[0]+"/"+arr[1]+"/"+arr[2]+"/"+arr[3];
		return map;
	},

	createLabelStringFromUrl: function(url){
		var idx = url.lastIndexOf("/");
		var basename = idx == -1 ? url : url.substring(idx + 1);
		idx = basename.lastIndexOf("=");
		basename = idx == -1 ? basename : basename.substring(idx + 1);
		if(basename.length > 18)
			basename.substring(0, 15)+"...";
		return basename;
	}
});
