/*
	Copyright (c) 2007-2008, IBM Corp.
*/
dojo.provide("btp.dnd.DragGhostMoveSource");
dojo.require("btp.dnd.DragSource");

dojo.declare("btp.dnd.DragGhostMoveSource", btp.dnd.DragSource, {
	ghost: null,

	// override
	onDragMove: function(e){
		var dx = e.pageX - this.pageX + this.offsetParent.scrollLeft;
		var dy = e.pageY - this.pageY + this.offsetParent.scrollTop;
		this.dragClone.style.top = this.dragStartPosition.y - this.offsetParentCoords.y + dy + "px";
		this.dragClone.style.left = this.dragStartPosition.x - this.offsetParentCoords.x + dx + "px";
		if(this.positioning == "absolute"){
			this.dragClone.style.display = "";
			this.globalChangeCursor(null);
		}else{
			this.dragClone.style.display = "none";
			this.globalChangeCursor("move");
		}
	},
	
	// override
	onDragEnd: function(e){
		if(this.positioning == "absolute"){
			this.removeClone();
		}else{
			this.globalChangeCursor(null);
		}
	},

	// override
	createDragClone: function(e){
		this.createGhost(e);
		this.dragClone = this.ghost; // this.ghost is cached, while this.dragClone is cleared on drag end.
		this.dragClone.style.display = "none";
		this.offsetParent.appendChild(this.dragClone);
	},

	// Create a dashed rectangle (ghost)
	createGhost: function(e){
		if(!this.ghost){
			var line = this.ghost = dojo.doc.createElement("DIV");
			line.className = "btpGhostFrame";
			line.style.zIndex = 1000;
			line.style.position = "absolute";
			line.style.fontSize = "1px";
			line.style.borderWidth = "1px";
			line.style.borderStyle = "dashed";
			var line2 = line.cloneNode(false);
			var line3 = line.cloneNode(false);
			var line4 = line.cloneNode(false);
			line.appendChild(line2);
			line.appendChild(line3);
			line.appendChild(line4);
		}
		var topLine = this.ghost;
		var bottomLine = topLine.childNodes[0];
		var leftLine = topLine.childNodes[1];
		var rightLine = topLine.childNodes[2];

		// Top Line
		topLine.style.width = this.refNode.offsetWidth + "px";
		topLine.style.height = "1px";
		topLine.style.borderWidth = "0px 0px 1px 0px";

		// Bottom Line
		bottomLine.style.top = this.refNode.offsetHeight + "px";
		bottomLine.style.left = "0px";
		bottomLine.style.width = this.refNode.offsetWidth + "px";
		bottomLine.style.height = "1px";
		bottomLine.style.borderWidth = "1px 0px 0px 0px";

		// Left Line
		leftLine.style.top = "1px";
		leftLine.style.left = "-1px";
		leftLine.style.width = "1px";
		leftLine.style.height = this.refNode.offsetHeight + "px";
		leftLine.style.borderWidth = "0px 1px 0px 0px";

		// Right Line
		rightLine.style.top = "1px";
		rightLine.style.left = this.refNode.offsetWidth - 1 + "px";
		rightLine.style.width = "1px";
		rightLine.style.height = this.refNode.offsetHeight + "px";
		rightLine.style.borderWidth = "0px 0px 0px 1px";
	}
});
