/*
	Copyright (c) 2007-2008, IBM Corp.
*/
dojo.provide("btp.dnd.DragMoveSource");
dojo.require("btp.dnd.DragSource");

dojo.declare("btp.dnd.DragMoveSource", btp.dnd.DragSource, {
	constrained: false,
	constraintBox: null,
	constraintMarginTop: 0,
	constraintMarginLeft: 0,
	
	// override
	onDragMove: function(e){
		var dx = e.pageX - this.pageX;
		var dy = e.pageY - this.pageY;
		var left = this.dragStartCssPosition.x + dx;
		var top = this.dragStartCssPosition.y + dy;

		if(this.constrained) {
			var box = this.constraintBox;
			if(top < box.offsetTop - this.constraintMarginTop){
				top = box.offsetTop - this.constraintMarginTop;
			}
			if(left < box.offsetLeft - this.constraintMarginLeft){
				left = box.offsetLeft - this.constraintMarginLeft;
			}
			var diffTop = box.offsetTop + box.offsetHeight - this.domNode.clientHeight;
			if(top > diffTop - this.constraintMarginTop) {
				top = diffTop - this.constraintMarginTop;
			}
			var diffLeft = box.offsetLeft + box.offsetWidth - this.domNode.clientWidth;
			if(left > diffLeft - this.constraintMarginLeft) {
				left = diffLeft - this.constraintMarginLeft;
			}
		} else {
			//@knitta@ temporary implementation...must fix later
			if(top < 0) {
				top = 0;
			}
			if(left < 0) {
				left = 0;
			}			
		}
		this.dragClone.style.left = left + "px";
		this.dragClone.style.top = top + "px";

		// The following code is equivalent to the above.
		// this.dragClone.style.top = e.pageY - this.offsetParentCoords.y - this.layerY + "px";
		// this.dragClone.style.left = e.pageX - this.offsetParentCoords.x - this.layerX + "px";
	},

	// override
	onDragEnd: function(e){
	},

	// override
	createDragClone: function(e){
		this.dragClone = this.dragObject;
	},
	
	constrainTo: function(div) {
		this.constrained = true;
		if(div){
			this.constraintBox = div;
		} else {
			this.constraintBox = this.domNode.parentNode;
		}
		
	},
	
	setOffsetX: function(diff){
		this.constraintMarginLeft = diff;
	},
	
	setOffsetY: function(diff){
		this.constraintMarginTop = diff;
	}
});
