/*
	Copyright (c) 2007-2008, IBM Corp.
*/
dojo.provide("btp.i18nImpl");

dojo.require("dojo.i18n");

btp.i18nImpl = {
	loadBundle: function(bundleName){
		// ex. "led.widget.LiveEditor" //TODO:
		if (!bundleName){ return null; }
		var pos = bundleName.lastIndexOf(".");
		var packageName = bundleName.substring(0, pos); // "led.widget"
		var name = bundleName.substring(pos + 1); // "LiveEditor"
		dojo["requireLocalization"](packageName, name);
		var bundle = dojo.i18n.getLocalization(packageName, name);
		if(!btp.i18n.bundle){
			btp.i18n.bundle = bundle;
		}else{
			dojo.mixin(btp.i18n.bundle, bundle);
		}
		return btp.i18n.bundle;
	},

	gets: function(s, prefix){
		if(!s){ return s; }
		var bundle = btp.i18n.bundle;
		if(bundle){
			if(s.charAt(0) == '$' && s.charAt(1) == '{' && s.charAt(s.length - 1) == '}'){
				var key = s.substring(2, s.length - 1);
				if (bundle[key]){
					return bundle[key];
				}
				return s;
			}
			if(bundle[prefix+s]){
				return bundle[prefix+s];
			}
			if(bundle[s]){
				return bundle[s];
			}
		}
		return s;
	}
};
