/*
	Copyright (c) 2007-2008, IBM Corp.
*/
dojo.provide("btp.widget.Console");

var btpConsoleMsg = "";
if(!djConfig["isDebug"]){
	var _btpConsoleConnector = dojo.connect(console, "debug", function(msg){
		if(btpConsoleMsg){ 
			btpConsoleMsg += "\n";
		}
		btpConsoleMsg += msg;
	});
}

dojo.require("dijit._Widget");
dojo.require("dijit._Container");
dojo.require("btp.widget.ext.localToolbar");

dojo.declare(
	"btp.widget.Console",
	[dijit._Widget, dijit._Contained],
{
	_localToolbar: null,

	postCreate: function(){
		this.domNode.className = "btpConsole btpSimplePane";
		if(djConfig["isDebug"]){ return; }
		dojo.disconnect(_btpConsoleConnector);
		var lines = btpConsoleMsg.split("\n");
		for(var i = 0, len = lines.length; i < len; i++){
			this.debug(lines[i]);
		}
		btpConsoleMsg = null;
		this.connect(console, "debug", "debug");
	},

	show: function(){
		if(!this._localToolbar){
			var ext = btp.loadExtension(this, "btp.widget.ext.localToolbar");
			var json = {
			    toolBar: {
			      item: [{
			        "@command": "clearConsole",
			        "@tooltip": "Clear Console",
			        "@iconPath": "widget/templates/Console/clear_co.gif"
			      }]
			    }
			};
			this._localToolbar = ext.createLocalToolbar(json);
			ext.attachLocalToolbar(this._localToolbar);
		}
	},

	debug: function(message){
		var node = dojo.doc.createTextNode(message);
		this.domNode.appendChild(node);
		this.domNode.appendChild(dojo.doc.createElement("BR"));
		this.domNode.scrollTop = this.domNode.scrollHeight;
	},

	clearConsole: function(){
		this.domNode.innerHTML = "";
	}
});
