/*
	Copyright (c) 2007-2008, IBM Corp.
*/
dojo.provide("btp.widget.DataSourceView");

dojo.require("dijit._Container");
dojo.require("btp.dnd.DragSource");
dojo.require("btp.widget.XmlTree");

dojo.declare(
	"btp.widget.DataSourceView",
	[dijit._Widget, dijit._Contained, dijit._Container],
{
	modelId: '',
	nodeset: '.',
	label: '',

	tree: null,
	tmpModel: null,

	
	postCreate: function(){
		this.domNode.className = "btpDataSourceView btpSimplePane";

		this._topics = [
			dojo.subscribe("btp:TreeNodeAdded", this, "onAfterAddChild"),
//			dojo.subscribe("btp:ActiveViewChanged", this, "activeViewChanged"),
//			dojo.subscribe("btp:TreeNodeSelected", this, "treeNodeSelected"),
//			dojo.subscribe("btp:TreeNodeDblSelected", this, "treeNodeDblSelected")
		];

		// tree		
		this.tree = new btp.widget.XmlTree({modelId:this.modelId, nodeset:this.nodeset});
		this.addChild(this.tree);

		this.connect(this.tree, "onBeforeExpand", "onBeforeExpand");
	},

	destroy: function(){
		dojo.forEach(this._topics, dojo.unsubscribe);
		this.inherited("destroy", arguments);
	},


	onBeforeExpand: function(/*SimpleTreeNode*/node){
		if(!node.isExpandable || node.getChildren().length > 0){ return; }
		if(node.jsonObj && node.jsonObj["@data"]){
			if(!this.tmpModel){
				this.tmpModel = new btp.widget.Model();
			}
			var model = this.tmpModel;
			model.setSrc(node.jsonObj["@data"]);
			var root = model.selectSingleNode(".");
			var child = this.createNodeFromXmlNode(root);
			node.addChild(child);
		}else if(node.xmlNode){
			var elem = node.xmlNode;
			for(var i = 0, len = elem.childNodes.length; i < len; i++){
				var childElem = elem.childNodes[i];
				if(childElem.nodeType != 1){
					continue;
				}
				var child = this.createNodeFromXmlNode(childElem);
				node.addChild(child);
			}
		}
	},

	createNodeFromXmlNode: function(elem){
		var label = elem.nodeName;
		var tooltip = ""; // @TODO
		var isFolder = elem.childNodes.length > 0;
		var iconImage = dojo.moduleUrl("btp", "widget/templates/SimpleTree/xml_image.gif")+"";

		var props = {
			label: label,
			tooltip: tooltip,
			iconImage: iconImage,
			isExpandable: isFolder
		};
		var node = new btp.widget.SimpleTreeNode(props);
		node.xmlNode = elem;
		return node;
	},

	onAfterAddChild: function(message){
		var node = message.node;
		var ds = new btp.dnd.DragSource(node.contentNode, this.id);
		ds.treeNode = node;
	}
});
