/*
	Copyright (c) 2007-2008, IBM Corp.
*/
dojo.provide("btp.widget.OutlineViewEx");

dojo.require("btp.widget.OutlineView");
dojo.require("btp.widget.ext.localToolbar");

dojo.declare(
	"btp.widget.OutlineViewEx",
	btp.widget.OutlineView,
{
	_toolbars: null,
	_activeToolbar: null,

	postCreate: function(){
		btp.widget.OutlineViewEx.superclass.postCreate.apply(this, arguments);
		btp.loadExtension(this, "btp.widget.ext.localToolbar");
		this._toolbars = {};
	},

	changeOutlineMode: function(message){
		var oldPage = this.editArea.getContentOutlinePage();
		if(oldPage){ oldPage.detachOutline(); }

		this.editArea.setOutlineMode(message.arg);

		var newPage = this.editArea.getContentOutlinePage();
		if(newPage){
			newPage.attachOutline();
			newPage.refreshOutline();
		}else{
			this.loadContentOutlinePage();
		}
	},

	// override
	editorActivated: function(message){
		btp.widget.OutlineViewEx.superclass.editorActivated.apply(this, arguments);
		if(message.type == "ActiveEditorChangedNotification"){
			var ext = this.extensions["btp.widget.ext.localToolbar"];
			var toolbar = this._toolbars[this.editArea.declaredClass];
			if(!toolbar){
				var json = this.editArea.getOutlineToolbarConf();
				if(!json){ return; }
				toolbar = this._toolbars[this.editArea.declaredClass] = ext.createLocalToolbar(json);
			}
			ext.attachLocalToolbar(toolbar);
			var mode = this.editArea.getOutlineMode();
			var item;
			for(var i = 0, len = toolbar.items.length; i < len; i++){
				item = toolbar.items[i];
				if(item.arg == mode){
					break;
				}
			}
			toolbar.selectRadioButton(item);
		}
	}
});
