/*
	Copyright (c) 2007-2008, IBM Corp.
*/
dojo.provide("btp.widget.Palette");
dojo.provide("btp.widget.PaletteFolder");
dojo.provide("btp.widget.PaletteItem");

dojo.require("btp.widget._PaletteBase");

dojo.declare(
	"btp.widget.Palette",
	btp.widget._PaletteBase,
{
	postCreate: function(){
		this.inherited("postCreate", arguments);
		dojo.setSelectable(this.domNode, false);
	},
	
	makeFolderTemplate: function(){
		// <DIV class="btpPaletteFolder">
		//     <A href="javascript:void(0)"><IMG src="a.gif">label</A>
		// </DIV>
		var div = this.folderTemplate = dojo.doc.createElement("DIV");
		div.className = "btpPaletteCommon btpPaletteFolder btpPaletteFolderLow";
		div.style.whiteSpace = "nowrap";
		var a = dojo.doc.createElement("A");
		a.href = "javascript:void(0)";
		var img = dojo.doc.createElement("IMG");
		img.border = "0";
		a.appendChild(img);
		div.appendChild(a);
	},

	makeItemTemplate: function(){
		var div = this.itemTemplate = dojo.doc.createElement("DIV");
		div.className = "btpPaletteCommon btpPaletteItem";
		div.style.whiteSpace = "nowrap";
		var a = dojo.doc.createElement("A");
		a.href = "javascript:void(0)";
		var img = dojo.doc.createElement("IMG");
		img.border = "0";
		a.appendChild(img);
		div.appendChild(a);
	}
});

dojo.declare(
	"btp.widget.PaletteFolder",
	btp.widget._PaletteFolderBase,
{
});

dojo.declare(
	"btp.widget.PaletteItem",
	btp.widget._PaletteItemBase,
{
	// for click and create
	itemMouseUpHander: function(e){
//		if(this.name looks like a line widget){ return; }
		var editor = btp.getEditors()[0];
		if(this.palette.pushedItem == this){
			var widget = editor.createComponent(this.name);
			dojo["require"]("btp.widget.command.EditCommand");
			var command = new btp.widget.command.EditCommand.AppendChildCommand(editor, widget);
			editor.getEditDomain().executeCommand(command);
			editor.setFocus(widget);
		}
		this.raised(this.domNode);
		this.palette.pushedItem = null;
		editor.getEditDomain().loadDefaultTool();
	}	
});
