/*
	Copyright (c) 2007-2008, IBM Corp.
*/
dojo.provide("btp.widget.PropertiesView");

dojo.require("dijit._Container");

dojo.declare(
	"btp.widget.PropertiesView",
	[dijit._Widget, dijit._Contained, dijit._Container],
{
	label: '',
	target: '',
	propertyChangedFilter: '',
	selectionChangedFilter: '',

	i18nPrefix: "PropertiesView_",

	postCreate: function(){
		this.domNode.className = "btpPropertiesView btpSimplePane";

		this.propPageMap = {};
		if(this.target){
			this.propertyChangedFilter = this.target;
			this.selectionChangedFilter = this.target;
		}

		this._topics = [
			dojo.subscribe("btp:PropertyChanged", this, "propertyChangedStub"),
			dojo.subscribe("btp:SelectionChanged", this, "selectionChangedStub")
		];
	},

	destroy: function(){
		dojo.forEach(this._topics, dojo.unsubscribe);
		this.inherited("destroy", arguments);
	},

	_loadImplementation: function(){
		var subModules = ["update", "event"];
		for(var i = 0, len = subModules.length; i < len; i++){
			var subModuleName = "btp.widget._propertiesView." + subModules[i];
			dojo["require"](subModuleName);
			var props = dojo.getObject(subModuleName);
			dojo.mixin(this, props);
		}
	},

	_changeSubscribers: function(){
		var _this = this;
		setTimeout(function(){
			dojo.forEach(_this._topics, dojo.unsubscribe);
			_this._topics = [
				dojo.subscribe("btp:PropertyChanged", _this, "propertyChanged"),
				dojo.subscribe("btp:SelectionChanged", _this, "selectionChanged")
			];
		});
	},

	propertyChangedStub: function(message){
		this._loadImplementation();
		this.propertyChanged(message);
		this._changeSubscribers();
	},

	selectionChangedStub: function(message){
		this._loadImplementation();
		this.selectionChanged(message);
		this._changeSubscribers();
	}
});
