/*
	Copyright (c) 2007-2008, IBM Corp.
*/
dojo.provide("btp.widget.SourceView");

dojo.require("dijit._Container");

dojo.declare(
	"btp.widget.SourceView",
	[dijit._Widget, dijit._Contained],
{
	modelId: '',
	ref: '',
	label: '',
	target: '',

	editAreaWidget: null,
	_topics: null,

	constructor: function(){
		this._topics = [];
	},

	postCreate: function(){
		this.domNode.className = "btpSourceView btpSimplePane";
		this._topics.push(dojo.subscribe("btp:InputChanged", this, "loadCompleted"));
	},

	destroy: function(){
		dojo.forEach(this._topics, dojo.unsubscribe);
		this.inherited("destroy", arguments);
	},

	show: function(){
		if(!this.editAreaWidget){
			this.editAreaWidget = dijit.byId(this.target);
		}
		this.updateView();
	},

	updateView: function(){
		if(!this.editAreaWidget){ return; }
		var ml = this.editAreaWidget.generate(this.editAreaWidget);
		if(!ml){ return; }
		ml = ml.replace(/(<\/?\w+[^>]+>)/g, "\f$1\b");
		ml = ml.replace(/&/g, '&amp;');
		ml = ml.replace(/>/g, '&gt;');
		ml = ml.replace(/</g, '&lt;');
		ml = ml.replace(/ /g, '&nbsp;');
		ml = ml.replace(/\t/g, '&nbsp;&nbsp;');
		ml = ml.replace(/\n/g, '<BR>');
		while(true){
			var idx = ml.indexOf("\f");
			if(idx == -1){
				break;
			}
			var idx2 = ml.indexOf("\b");
			var s = ml.substring(idx + 1, idx2);
			var spc = s.indexOf("&nbsp;");
			if(spc != -1){
				s = s.replace(/(\w+)=(\"[^\"]*\")/g, "<font color=\"#7B007B\">$1</font>=<font color=\"#2900FF\">$2</font>");
			}
			ml = ml.substring(0, idx)
				+ '<font color="#397D7B">' + s + '</font>'
				+ ml.substring(idx2 + 1);
		}
		this.domNode.innerHTML = ml;
	},

	loadCompleted: function(){
		if(btp.isShowing(this)){
			this.updateView();
		}
	}
});
