/*
	Copyright (c) 2007-2008, IBM Corp.
*/
dojo.provide("btp.widget.StatusBar");

dojo.require("dijit._Widget");
dojo.require("dijit._Templated");
dojo.require("dijit.layout.ContentPane");

dojo.declare(
	"btp.widget.StatusBar",
	[dijit.layout.ContentPane, dijit._Templated],
{
	timeout: '7000',
	target: '',
	messagePostedFilter: '',

	postCreate: function(){
		btp.widget.StatusBar.superclass.postCreate.apply(this, arguments);
		this.domNode.className = "statusBar";
		if(this.target){
			this.messagePostedFilter = this.target;
		}
		dojo.subscribe("btp:MessagePosted", this, "showMessage");
	},

	destroy: function(){
		dojo.unsubscribe("btp:MessagePosted", this, "showMessage");
		this.inherited("destroy", arguments);
	},

	showMessage: function(message){
		if(!btp.matchFilter(message, this.messagePostedFilter)){
			return; // filter out the message
		}
		
		this.setContent(message.text);
		var _this = this;
		window.setTimeout(function(){
			_this.setContent("");
		}, this.timeout - 0);
	}
});
