/*
	Copyright (c) 2007-2008, IBM Corp.
*/
dojo.provide("btp.widget.StickyToaster");

dojo.require("btp.dnd.DragMoveSource");
dojo.require("dijit._Widget");
dojo.require("dijit._Container");
dojo.require("dijit._Templated");
dojo.require("dojox.fx.style");
dojo.require("btp._base.dom");

dojo.declare(
	"btp.widget.StickyToaster",
	[dijit._Widget, dijit._Container, dijit._Contained, dijit._Templated],
{
	target: "",	// id which this widget sticks to
	
	templateString: '<div dojoAttachPoint="containerNode" class="btpStickyToaster btpSimplePane"><img class="btpStickyToasterHandleImg" dojoAttachPoint="handleImg" dojoAttachEvent="onclick:_onHandleImgClick" src="${handleImgSrc}" width="16" height="16" /></div>',
	
	handleImgSrc: dojo.moduleUrl("btp", "widget/templates/EditArea/handle.gif"),
	
	postCreate: function(){
	},
	
	startup: function() {
		var targetWidget = dijit.byId(this.target);
		if(!targetWidget){ return;}
		if(targetWidget.getParent) {
			var parent = targetWidget.getParent();
			if(parent && parent.layout) {
				dojo.connect(parent, "layout", this, "_placeClip");
			}
		}
	},
	
	_placeClip: function() {
		var targetWidget = dijit.byId(this.target);
		if(!targetWidget){ return; }
		var targetNode = targetWidget.domNode;
		
		var dim = btp.getDimensions(targetNode, this.domNode.offsetParent);
		var left =  dim.left + 2;
		var bottom = 18;
		this.domNode.style.left = left + "px";
		this.domNode.style.top = "auto";
		this.domNode.style.bottom = bottom + "px";
	},
	
	_onHandleImgClick: function(e) {
		var animation = dojox.fx.toggleClass(this.domNode, "btpStickyToasterMinimize");
		dojo.addClass(this.domNode, "btpStickyToasterResizing");
		dojo.connect(animation, "onEnd", dojo.hitch(this, function() {
			dojo.removeClass(this.domNode, "btpStickyToasterResizing");
		}));
		animation.play();
	}
});
