/*
	Copyright (c) 2007-2008, IBM Corp.
*/
dojo.provide("btp.widget._editArea.canvas");

// summary:
//		Canvas size adjustment.
//		'this' points to the EditArea.

btp.widget._editArea.canvas = {
	// stub: subclass must override
	adjustCanvasWidth: function(widget){
	},
	
	// stub: subclass must override
	adjustCanvasHeight: function(widget){
	},

	adjustCanvasSize: function(widget){
		var _this = this;
		if(!widget){
			widget = this;
		}
		var children = widget.getChildren ? widget.getChildren() : null;
		if(children){
			for(var i = 0, len = children.length; i < len; i++){
				var child = children[i];
				this.adjustCanvasWidth(child);
				this.adjustCanvasHeight(child);
				this.adjustCanvasSize(child);
			}
		}
	}
};
