/*
	Copyright (c) 2007-2008, IBM Corp.
*/
dojo.provide("btp.widget._editArea.componentInfo");

// summary:
//		Handles component definition files.
//		'this' points to the EditArea.

btp.widget._editArea.componentInfo = {
	loadComponentInfo: function(/*String*/componentInfoId){
		if(!this._componentInfo){
			this._componentInfo = {};
		}
		var arr = componentInfoId.split(",");
		for(var i = 0, len = arr.length; i < len; i++){
			var model = dijit.byId(arr[i]);
			if(!model){
				alert("Model '"+arr[i]+"' not found.");
				continue;
			}
			var selectedNode = model.selectSingleNodeFromJson("."); // <components>
			this._loadComponentInfo_1.call(this, selectedNode);
		}
	},

	_loadComponentInfo_1: function(/*Object*/selectedNode){
		var categoryNodes = btp.getChildNodes(selectedNode, "category");
		for(var i = 0, len = categoryNodes.length; i < len; i++){
			var categoryNode = categoryNodes[i]; // <category>
			var componentNodes = btp.getChildNodes(categoryNode, "component");
			for(var j = 0, len2 = componentNodes.length; j < len2; j++){
				var componentNode = componentNodes[j]; // </component>
				var name = componentNode["name"];
				if(this._componentInfo[name]){
					var k;
					for(k = 2; this._componentInfo[name+":"+k]; k++){
						;
					}
					name = name+":"+k;
				}
				if(!componentNode.attribute){
					componentNode.attribute = [];
				}else if(!dojo.isArray(componentNode.attribute)){
					componentNode.attribute = [componentNode.attribute]; // make it an array
				}
				if(componentNode.helper && !dojo.isArray(componentNode.helper)){
					componentNode.helper = [componentNode.helper]; // make it an array
				}
				this._componentInfo[name] = componentNode;
			}
		}
	},

	getComponentInfo: function(widget){
		if(!this._componentInfo){
			this.loadComponentInfo(this.componentInfoId);
		}
		var name;
		if(widget instanceof dijit._Widget){
			if(widget.__component_info){
				return widget.__component_info;
			}
			name = widget.declaredClass;
		}else if(typeof(widget) == "string"){
			name = widget;
		}
		var info = this._componentInfo[name] ? this._componentInfo[name] : {};
		if(widget instanceof dijit._Widget){
			widget.__component_info = info;
		}
		return info;
	},

	getAttributeInfo: function(widget, attrName){
		var info = widget.__component_info;
		if(!info){ return null; }
		var attrs = info.attribute;
		for(var i = 0, len = attrs.length; i < len; i++){
			if(attrs[i].name == attrName){
				return attrs[i];
			}
		}
		return null;
	},

	getAttributes: function(widget){
		var info = widget.__component_info;
		if(!info){ return null; }
		return info.attribute;
	}
};
