/*
	Copyright (c) 2007-2008, IBM Corp.
*/
dojo.provide("btp.widget._editArea.outline");

// summary:
//		Get or create a ContentOutlinePage
//		'this' points to the EditArea.

btp.widget._editArea.outline = {
	contentOutlinePageClass: null, // class name
	_contentOutlinePages: null, // array of ContentOutlinePage instance
	_outlineMode: "default",

	// subclass may want to override this
	getContentOutlinePageClass: function(){
		return this.contentOutlinePageClass;
	},

	getContentOutlinePage: function(){
		return this._contentOutlinePages[this._outlineMode];
	},

	createContentOutlinePage: function(){
		var mode = this._outlineMode;
		if(this._contentOutlinePages[mode]){
			return this._contentOutlinePages[mode];
		}
		var widgetName = this.getContentOutlinePageClass();
		if(!widgetName){ return null; } // no ContentOutlinePage support
		if(!dojo._loadedModules[widgetName]){
			dojo["require"](widgetName);
		}
		impl = dojo.getObject(widgetName);
		this._contentOutlinePages[mode] = new impl(this);
		return this._contentOutlinePages[mode];
	},

	getOutlineToolbarConf: function(){
		return null;
	},

	getOutlineMode: function(){
		return this._outlineMode;
	},

	setOutlineMode: function(mode){
		this._outlineMode = mode;
	}
};
