/*
	Copyright (c) 2007-2008, IBM Corp.
*/
dojo.provide("btp.widget._editArea.provider");

// summary:
//		Get or create a ContentProvider
//		'this' points to the EditArea.

btp.widget._editArea.provider = {
	contentProviderClass: null, // class name
	_contentProviders: null, // array of ContentProvider instance

	// subclass may want to override this
	getContentProviderClass: function(/*String?*/mode){
		return this.contentProviderClass;
	},

	getContentProvider: function(/*String?*/mode){
		if(!mode){ mode = "default"; }
		return this._contentProviders[mode];
	},

	createContentProvider: function(/*String?*/mode){
		if(!mode){ mode = "default"; }
		if(this._contentProviders[mode]){
			return this._contentProviders[mode];
		}
		var widgetName = this.getContentProviderClass(mode);
		if(!widgetName){ return null; } // no ContentProvider support
		if(!dojo._loadedModules[widgetName]){
			dojo["require"](widgetName);
		}
		impl = dojo.getObject(widgetName);
		this._contentProviders[mode] = new impl(this);
		return this._contentProviders[mode];
	}
};
