/*
	Copyright (c) 2007-2008, IBM Corp.
*/
dojo.provide("btp.widget._propertiesView.fromWidget");

// summary:
//		Creates a property page from Widget
//		'this' points to the PropertiesView.

btp.widget._propertiesView.fromWidget = {
	createPropPageFromWidget: function(widgetName, name, sel){
		// KLUGE: First, create a placeholder div and use it as a ref node for createWidget.
		// Then remove it from the DOM tree. Subsequent addChild append it to the DOM again.
		// This is because DataGridPropPage has subwidgets and the rendering must be
		// performed online. Otherwise, we see strange rendering on both IE and FF.
		// In addition to that, the view must be visible when the rendering is performed.
		// So, we need to temporarily clear the display property if it is set to "none".

		var disp = this.domNode.style.display;
		if(disp == "none"){
			this.domNode.style.display = "";
		}

		var div = dojo.doc.createElement("DIV");
		this.domNode.appendChild(div);
		var widget = dojo.widget.createWidget(widgetName, {propViewId: this.id}, div); //TODO: createWidget -> new
		this.domNode.removeChild(widget.domNode);
		this.addChild(widget);
		this.onResized();

		if(widget.useDefaultHandler){
			this.setOnChangeHandler(widget.domNode);
		}
		this.createElementsMap(widget.domNode); // elements map
		widget.domNode.name = name; // key to cache

		if(disp == "none"){
			this.domNode.style.display = disp;
		}

		return widget;
	}
};
