/*
	Copyright (c) 2007-2008, IBM Corp.
*/
dojo.provide("btp.widget.action.Actions");

// summary:
//		EditArea actions that are usually invoked from toolbar, menubar, etc.
//		'this' points to the EditArea.

btp.widget.action.Actions = {
	clear: function(){
		function deleteRecursively(w){
			dojo.forEach(w.getChildren(),
				function(widget){
					if(widget.getChildren){
						deleteRecursively(widget);
					}
					dijit._Contained.prototype.getParent.call(widget).removeChild(widget);
					widget.destroy();
				});
		}
		this.removeFocus();
		deleteRecursively(this);
		this.firePropertyChanged("@RemoveChild");
		this.getEditDomain().clear();
	},

	urlToBeOpenedAfterSave: function(){
		return this.getViewUrl();
	},
	save: function(){
		alert("save");
		var ml = this.generate(this);
	alert(ml);
	return;


		var url = this.getResourceUrl(null);
		if(!url){
			var props = {
				title: "Save As",
				labels: ["Name"],
				onOk: "_onSaveOk"
			};
			this.dialog = this.createInputDialog(props);
			return;
		}
		var ml = this.generate(this);
		if(!this.sendSaveRequest(ml)){ return; }
		//this.commandProcessor.clear();
		this.getEditDomain().clear();
		this.undirtied();
		if(typeof(btpConfig) != "undefined" && btpConfig.closeOnSave){
			setTimeout("window.location.href = '"+this.urlToBeOpenedAfterSave()+"';", 0);
		}else{
			this.fireMessagePosted(url+" saved.");
		}
	},

	_onSaveOk: function(){
		var resourceId = this.dialog.inputFields[0].value;
		if(!resourceId){ return; }
		this.closeDialog(this.dialog);
		var frag = btp.splitUrl(window.location.href);
		var url = frag["list"] + "/" + resourceId;
		var model = dijit.byId(this.modelId);
		model.src = url;
		this.save();
		this.setTabTitle();
	},

	urlToBeOpenedOnCancel: function(){
		var url = this.getViewUrl();
		if(!url){
			var frag = btp.splitUrl(window.location.href);
			url = frag["base"] + "/" + frag["contextRoot"] + "/";
		}
		return url;
	},
	cancel: function(){
		// Your application should implement this.
		setTimeout("window.location.href = '"+this.urlToBeOpenedOnCancel()+"';", 0);
	},

	del: function(){
		this.deleteFocusWidget();
	},

	undo: function(){
		if(this.moveImg){
			this.moveImg.style.display = "none";
		}
		//this.commandProcessor.undo_it();
		this.getEditDomain().undo();

		this.removeFocus();
	},

	redo: function(){
		if(this.moveImg){
			this.moveImg.style.display = "none";
		}
		//this.commandProcessor.execute_it();
		this.getEditDomain().redo();

		this.removeFocus();
	},

	freeLayout: function(message){
		this.freeLayoutMode = message.item.toggleOn;
	},
	
	showPreference: function(){
		var widget = dojo.widget.byType("btp:preferences")[0];
		widget.showPreferences();
	},
	
	bringFront: function(){
		if(!this.focusWidgets || !this.focusWidgets[0]){ return; }
		var parent = this.focusWidgets[0].getParent();
		var children = parent.getChildren();
		var cur;
		var len = children.length;
		if(len < 2){ return; }
		for(var i=0; i<len; i++){
			cur = children[i];
			if(cur == this.focusWidgets[0]){
				if(i == len-1){ return; }
				var ref = len-2 == i ? null : children[i+2];
				var compoundCommand = new btp.widget.command.CompoundCommand();
				compoundCommand.append(new btp.widget.command.EditCommand.RemoveChildCommand(cur));
				if(ref){
					compoundCommand.append(new btp.widget.command.EditCommand.InsertBeforeCommand(parent, cur, ref));
				}else{
					compoundCommand.append(new btp.widget.command.EditCommand.AppendChildCommand(parent, cur));
				}
				this.getEditDomain().executeCommand(compoundCommand);
				return;
			}
		}
	},
	
	bringBack: function(){
		if(!this.focusWidgets || !this.focusWidgets[0]){ return; }
		var parent = this.focusWidgets[0].getParent();
		var children = parent.getChildren();
		var cur;
		var len = children.length;
		if(len < 2){ return; }
		for(var i=0; i<len; i++){
			cur = children[i];
			if(cur == this.focusWidget){
				if(i==0){ return; }
				var ref = children[i-1];
				var compoundCommand = new btp.widget.command.CompoundCommand();
				compoundCommand.append(new btp.widget.command.EditCommand.RemoveChildCommand(cur));
				compoundCommand.append(new btp.widget.command.EditCommand.InsertBeforeCommand(parent, cur, ref));
				this.getEditDomain().executeCommand(compoundCommand);
				return;
			}
		}
	}
};
