/*
	Copyright (c) 2007-2008, IBM Corp.
*/
dojo.provide("btp.widget.command.CommandProcessor");

// ----------------------------------------------------------------------------
// Manage Command instances
// ----------------------------------------------------------------------------

//  0 1 2           0 1 2
// --------        --------
// | | | |         |x| | |
// --------        --------
//  ^_top=0           ^_top=1
// (empty stack)   (one command)

btp.widget.command.CommandProcessor = function(){
	this._stack = new Array();
	this._top = 0;     // stack top position
	this._current = 0; // current position

	this.push = function(cmd){
		this._stack[this._current] = cmd;
		this._top = this._current + 1;
		for(var i = this._top; i < this._stack.length; i++){
			this._stack[i] = null;
		}
	}

	this.pop = function(cmd){
		if(this._top == 0){
			return;
		}
		this._stack[--this._top] = null;
		this._current = this._top;
	}

	this.clear = function(cmd){
		this._top = 0;
		this._current = 0;
		for(var i = 0; i < this._stack.length; i++){
			this._stack[i] = null;
		}
	}

	this.execute_it = function(){
		if(!this._stack[this._current]){ return; }
		var cmd = this._stack[this._current++];
		cmd.execute();
		if(this._current == 1){
			this.dirtied();
		}
	}

	this.undo_it = function(){
		if(this._current == 0){
			window.status = "No further undo information";
			window.setTimeout("window.status='';", 5000);
			return;
		}
		var cmd = this._stack[--this._current];
		cmd.undo();
		if(this._current == 0){
			this.undirtied();
		}
	}

	this.dirtied = function(){
	}

	this.undirtied = function(){
	}
};
