/*
	Copyright (c) 2007-2008, IBM Corp.
*/
dojo.provide("btp.widget.command.CompoundCommand");

// ----------------------------------------------------------------------------
// Compose multiple commands into a single command
// ----------------------------------------------------------------------------

btp.widget.command.CompoundCommand = function(){
	this._commands = [];

	this.execute = function(){
		for(var i = 0; i < this._commands.length; i++){
			var cmd = this._commands[i];
			cmd.execute();
		}
	}

	this.undo = function(){
		for(var i = this._commands.length - 1; i >= 0; i--){
			var cmd = this._commands[i];
			cmd.undo();
		}
	}

	this.append = function(cmd){
		this._commands[this._commands.length] = cmd;
	}
}
