/*
	Copyright (c) 2007-2008, IBM Corp.
*/
dojo.provide("btp.widget.data.htmlGenerator");

btp.widget.data.htmlGenerator = {
	generate: function(widget){
		var ml =
			 '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"\n'
			+'  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">\n'
			+'<html xmlns="http://www.w3.org/1999/xhtml">\n'
			+'<head>\n</head>\n<body>\n';
		var children = widget.getChildren ? widget.getChildren() : null;
		if(children){
			for(var i = 0, len = children.length; i < len; i++){
				ml += this.generate_1(children[i], 0);
			}
		}
		ml += '</body>\n</html>\n';
		return ml;
	},

	generate_1: function(widget, indent){
		var ml = "";
		for(var i = 0; i < indent; i++){
			ml += "  ";
		}
		var dojoType = widget.declaredClass;

		// begin tag
		if(widget.encodeBegin){
			ml += widget.encodeBegin();
		}else{
			ml += "<div dojoType=\""+dojoType+"\"";
			var attrs = this.getAttributes(widget);
			if(attrs){
				for(var j = 0, len2 = attrs.length; j < len2; j++){
					var attr = attrs[j];
					var name = attr.name;
					var value = widget.ps_getPropertyValue(name);
					if(value != null && value != "" && typeof(value) != "undefined"){ // if(!value) doesn't work. value can be a number.
						if(typeof(value) == "string"){
							value = value.replace(/&/gm, "&amp;").replace(/</gm, "&lt;").replace(/>/gm, "&gt;").replace(/"/gm, "&quot;");
						}
						ml += " "+name+"=\""+value+"\"";
					}
				}
			}
			var s = widget.hlp_generateStyleValues();
			if(s){
				ml += " style=\""+s+"\"";
			}
			ml += ">";
		}

		// children
		if(widget.encodeChildren){
			ml += widget.encodeChildren();
		}else{
			var ml2 = "";
			var children = widget.getChildren ? widget.getChildren() : null;
			if(children){
				for(var i = 0, len = children.length; i < len; i++){
					ml2 += this.generate_1(children[i], indent + 1);
				}
			}
			if(ml2){
				ml += "\n" + ml2;
				for(var i = 0; i < indent; i++){
					ml += "  ";
				}
			}
		}

		// end tag
		if(widget.encodeEnd){
			var s = widget.encodeEnd();
			if(s){
				ml += s + "\n";
			}
		}else{
			ml += "</div>\n";
		}
		return ml;
	}
};
