/*
	Copyright (c) 2007-2008, IBM Corp.
*/
dojo.provide("btp.widget.ext.localToolbar");

dojo.declare(
	"btp.widget.ext.localToolbar",
	null,
{
	owner: null,
	currentToolbarWidget: null,

	// initializer
	constructor: function(owner){
		this.owner = owner;
		this._connectors = [];
		if(this.show){
			this._connectors.push(dojo.connect(owner, "show", this, "_show"));
		}else{
			this.show = this._show;
		}

		if(this.hide){
			this._connectors.push(dojo.connect(owner, "hide", this, "_hide"));
		}else{
			this.hide = this._hide;
		}
		dojo.subscribe("btp:ActionInvoked", this, "dispatchCommand");
	},

	destroy: function(){
		dojo.forEach(this._connectors, dojo.disconnect);
	},

	createLocalToolbar: function(json){
		var widget = new btp.widget.Toolbar();
		widget.domNode.style.padding = "2px 0px 0px 0px";
		widget.domNode.style.styleFloat = "right"; // IE
		widget.domNode.style.cssFloat = "right";   // Mozilla
		widget.updateToolbar(json);
		return widget;
	},

	attachLocalToolbar: function(toolbarWidget){
		if(this.currentToolbarWidget == toolbarWidget){ return; }
		this._hide(); // hide the previous toolbar
		var parentWidget = this.owner.getParent();
		if(!toolbarWidget.domNode.parentNode || toolbarWidget.domNode.parentNode != parentWidget.localToolbarArea){
			if(!parentWidget.localToolbarArea){ return; }
			parentWidget.localToolbarArea.appendChild(toolbarWidget.domNode);
		}
		this.currentToolbarWidget = toolbarWidget;
		if(btp.isShowing(this.owner)){
			this._show(); // show the new toolbar
		}else{
			this._hide(); // hide the new toolbar
		}
	},

	dispatchCommand: function(message){
		if(!this.currentToolbarWidget
			|| !btp.matchFilter(message, this.currentToolbarWidget.domNode.getAttribute("widgetId"))){
			return; // filter out the message
		}
		this.owner[message.command](message);
	},
	
	_show: function(){
		if(this.currentToolbarWidget){
			this.currentToolbarWidget.domNode.style.display = "";
		}
	},
	
	_hide: function(){
		if(this.currentToolbarWidget){
			this.currentToolbarWidget.domNode.style.display = "none";
		}
	}
});
