/*
	Copyright (c) 2007-2008, IBM Corp.
*/
dojo.provide("btp.widget.helper.baseHelper");

btp.widget.helper.baseHelper = {
	hlp_getEditArea: function(){
		return this.__editArea;
	},

	hlp_setEditArea: function(editArea){
		this.__editArea = editArea;
	},

	hlp_getComponentInfo: function(){
		return this.__component_info;
	},

	hlp_initLiveWidget: function(editArea){
		var info = this.hlp_getComponentInfo();
		if(info && info.dropTargets){
			if(this.hlp_dropTargets){
				this.hlp_dropTargets = this.hlp_dropTargets.concat(info.dropTargets.split(","));
			}else{
				this.hlp_dropTargets = info.dropTargets.split(",");
			}
		}
		if(this.hlp_setupDropTarget){
			this.hlp_setupDropTarget();
		}
	},

	hlp_beforeAddChild: function(parent, widget){
		// Your widget may want to override this.
	},

	hlp_afterAddChild: function(parent, widget){
		// Your widget may want to override this.
	},

	hlp_beforeRemoveChild: function(parent, widget){
		// Your widget may want to override this.
	},

	hlp_afterRemoveChild: function(parent, widget){
		// Your widget may want to override this.
	},

	hlp_addChild: function(/*Widget*/widget, /*int|Widget?*/insertIndex){
		if(insertIndex && typeof(insertIndex) != "number"){ // convert refWidget to insertIndex 
			insertIndex = dojo.indexOf(this.getChildren(), insertIndex);
			if(insertIndex == -1){ alert("btp.widget.helper.baseHelper#hlp_addChild: internal error: refWidget not found"); } // TODO: remove this code later
		}
		widget.hlp_beforeAddChild(this, widget);
		this.addChild(widget, insertIndex);
		if(!btp.isOrphan(widget.domNode)){
			var hint = {
				parent: this,
				widget: widget,
				insertIndex: insertIndex
			};
			this.hlp_getEditArea().firePropertyChanged("@AddChild", null, null, hint);
			this.hlp_getEditArea().adjustCanvasWidth(widget);
			this.hlp_getEditArea().adjustCanvasHeight(widget);
		}
		widget.hlp_afterAddChild(this, widget);
	},

	hlp_removeChild: function(/*Widget*/widget){
		widget.hlp_beforeRemoveChild(this, widget);
		var isOrphan = btp.isOrphan(widget.domNode);
		this.removeChild(widget);
		if(!isOrphan){
			var hint = {
				parent: this,
				widget: widget
			};
			this.hlp_getEditArea().firePropertyChanged("@RemoveChild", null, null, hint);
		}
		widget.hlp_afterRemoveChild(this, widget);
	}
};
