/*
	Copyright (c) 2007-2008, IBM Corp.
*/
dojo.provide("btp.widget.helper.focusHelper");

btp.widget.helper.focusHelper = {
	// ------------- Focus Frame ----------------------------
	hlp_setFocusFrame: function(){
		if(this.__component_info.visible == "false"){ return; }
		this.hlp_showComponentFrame("focus");
	},

	hlp_removeFocusFrame: function(){
		if(this.__component_info.visible == "false"){ return; }
		this.hlp_hideComponentFrame("focus");
	},

	hlp_refreshFocusFrame: function(){
		this.hlp_removeFocusFrame();
		this.hlp_setFocusFrame();
	},

	// ------------- Feedback Frame ----------------------------
	hlp_showAllowDropFeedback: function(){
		this.hlp_showComponentFrame("feedback");
	},

	hlp_hideAllowDropFeedback: function(){
		this.hlp_hideComponentFrame("feedback");
	},

	// -------- Show/Hide a frame around the component ----------
	hlp_showComponentFrame: function(type){
		// 'type' must be "focus" or "feedback"

		function __createFrame(color, zIndex){
			var line = dojo.doc.createElement("DIV");
			line.style.zIndex = zIndex;
			line.style.position = "absolute";
			line.style.fontSize = "1px";
			line.style.borderStyle = "solid";
			line.style.borderColor = color;
			var line2 = line.cloneNode(false);
			var line3 = line.cloneNode(false);
			var line4 = line.cloneNode(false);
			line.appendChild(line2);
			line.appendChild(line3);
			line.appendChild(line4);
			return line;
		}

		if(this == this.__editArea){ return; }
		var topLine;
		if(type == "focus"){
			if(!this.__focusFrame){
				this.__focusFrame = __createFrame("black", 1000);
			}
			topLine = this.__focusFrame;
		}else if(type == "feedback"){
			if(!this.__feedbackFrame){
				this.__feedbackFrame = __createFrame("yellow", 1001);
			}
			topLine = this.__feedbackFrame;
		}else{
			return; // never reached
		}
		var bottomLine = topLine.childNodes[0];
		var leftLine = topLine.childNodes[1];
		var rightLine = topLine.childNodes[2];

		var dim = btp.getStyleDimensions(this, this.__editArea);

		// Top Line
		topLine.style.top = dim.top - 2 + "px";
		topLine.style.left = dim.left - 1 + "px";
		topLine.style.width = dim.width + 2 + "px";
		topLine.style.height = "1px";
		topLine.style.borderWidth = "0px 0px 1px 0px";

		// Bottom Line
		bottomLine.style.top = dim.height + 2 + "px";
		bottomLine.style.left = "0px";
		bottomLine.style.width = dim.width + 2 + "px";
		bottomLine.style.height = "1px";
		bottomLine.style.borderWidth = "1px 0px 0px 0px";

		// Left Line
		leftLine.style.top = "1px";
		leftLine.style.left = "-1px";
		leftLine.style.width = "1px";
		leftLine.style.height = dim.height + 2 + "px";
		leftLine.style.borderWidth = "0px 1px 0px 0px";

		// Right Line
		rightLine.style.top = "1px";
		rightLine.style.left = dim.width + 1 + "px";
		rightLine.style.width = "1px";
		rightLine.style.height = dim.height + 2 + "px";
		rightLine.style.borderWidth = "0px 0px 0px 1px";

		this.__editArea.domNode.appendChild(topLine);
	},

	hlp_hideComponentFrame: function(type){
		if(this == this.__editArea){ return; }
		if(type == "focus"){
			this.__focusFrame.parentNode.removeChild(this.__focusFrame);
		}else if(type == "feedback"){
			this.__feedbackFrame.parentNode.removeChild(this.__feedbackFrame);
		}
	}
};
