/*
	Copyright (c) 2007-2008, IBM Corp.
*/
dojo.provide("btp.widget.helper.styleHelper");

btp.widget.helper.styleHelper = {
	// property: "top", "left", "width", "height", or "borderWidth"
	// return: integer value
	hlp_getStyle: function(property){
		return btp.getStyleValue(this, property);
	},

	// property: "top", "left", etc.
	// value: string value with "px". (Ex. "100px")
	hlp_setStyle: function(property, value){
		var props = {};
		props[property] = value;
		this.hlp_setStyles(props);
	},

	hlp_setStyles: function(props){
		var property, value;
		for(property in props){
			value = props[property];
			btp.setStyleValue(this, property, value);
		}
		if(value == undefined){ return; }
		var info = this.__component_info;
		if(info.resizable && info.resizable.refreshMethod){
			this[info.resizable.refreshMethod]();
		}
		if(this.__editArea.adjustCanvasWidth){
			this.__editArea.adjustCanvasWidth(this);
		}
		if(this.__editArea.adjustCanvasHeight){
			this.__editArea.adjustCanvasHeight(this);
		}
		if(btp.isGfxWidget(this)){
			this.update();
		}		
		if(this.__editArea.firePropertyChanged){
			this.__editArea.firePropertyChanged("@SetStyles", null, null, {widget:this,props:props});
		}

	},

	// summary: generates value for the style attribute.
	//   Ex. "position:absolute;top:25px;left:19px;width:429px;height:289px;"
	hlp_generateStyleValues: function(){
		var hasAccessor = btp.hasAccessor;
		var isResizableHorizontally = btp.isResizableHorizontally;
		var isResizableVertically = btp.isResizableVertically;

		var s = "";
		var info = this.hlp_getComponentInfo();
		var position = dojo.style(this.domNode, "position");
		if(position && (position == "absolute" || position == "relative")){
			s += "position:"+position+";";

			// Top
			if(!hasAccessor(this, "top")){
				var val = btp.getStyleValue(this, "top");
				if(val && val != "auto") //TODO: Do not omit curly braces, '{' and '}'.
					s += "top:" + val + "px;";
			}

			// Left
			if(!hasAccessor(this, "left")){
				var val = btp.getStyleValue(this, "left");
				if(val && val != "auto") //TODO: Do not omit curly braces, '{' and '}'.
					s += "left:" + val + "px;";
			}
		}
		
		if(info.resizable){
			// Width
			if(!hasAccessor(this, "width") && isResizableHorizontally(this)){
				var val = this.domNode.style.width;
				if(val && val != "auto") //TODO: Do not omit curly braces, '{' and '}'.
					s += "width:" + val + ";";
			}

			// Height
			if(!hasAccessor(this, "height") && isResizableVertically(this)){
				var val = this.domNode.style.height;
				if(val && val != "auto") //TODO: Do not omit curly braces, '{' and '}'.
					s += "height:" + val + ";";
			}
		}
		return s;
	}
};
