/*
	Copyright (c) 2007-2008, IBM Corp.
*/
dojo.provide("btp.widget.provider.DomTreeContentProvider");

dojo.declare("btp.widget.provider.DomTreeContentProvider", null,
{
	input: null,
	viewer: null,
	view: null,

	// public Object[] getElements(Object inputElement);
	getElements: function(/*EditArea*/inputElement){
		var input = this.input = inputElement; // input should be EditArea
		return this.getChildren({targetNode:input.domNode});
	},

	// public void inputChanged(Viewer viewer, Object oldInput, Object newInput);
	inputChanged: function(viewer, oldInput, newInput){
		this.viewer = viewer;
		this.input = newInput;
	},

	// public Object[] getChildren(Object parentElement);
	getChildren: function(/*Object*/parentElement){
		var parentNode = parentElement.targetNode;
		var arr = [];
		var len = parentNode.childNodes.length;
		for(var i = 0; i < len; i++){
			var child = parentNode.childNodes[i];
			if(parentNode == this.input.domNode && !dijit.byNode(child)){ continue; }
			if(child.nodeType != 1){ continue; }
			var obj = child.outlineObj;
			if(!obj){
				var title = child.tagName;
				obj = {
					// required fields
					label: title,
					icon: null,
					tooltip: child.outerHTML,
	
					// additional fields
					targetNode: child
				};
				child.outlineObj = obj;
				var widget = dijit.byNode(child);
				if(widget){
					widget.outlineObj = obj;
				}
			}
			obj.parentElement = parentElement;
			arr.push(obj);
		}
		return arr;
	},

	// public Object getParent(Object element);
	getParent: function(element){
		return element.parentElement;
	},

	// public boolean hasChildren(Object element);
	hasChildren: function(element){
	},

	getInput: function(){
		return this.input;
	}
});
