/*
	Copyright (c) 2007-2008, IBM Corp.
*/
dojo.provide("btp.widget.provider.GfxNodeTreeContentProvider");

dojo.declare("btp.widget.provider.GfxNodeTreeContentProvider", null,
{
	input: null,
	viewer: null,
	view: null,

	// public Object[] getElements(Object inputElement);
	getElements: function(/*EditArea*/inputElement){
		var input = this.input = inputElement; // input should be EditArea
		return this.getChildren({targetNode:input});
	},

	// public void inputChanged(Viewer viewer, Object oldInput, Object newInput);
	inputChanged: function(viewer, oldInput, newInput){
		this.viewer = viewer;
		this.input = newInput;
	},

	// public Object[] getChildren(Object parentElement);
	getChildren: function(/*Object*/parentElement){
		var parentWidget = parentElement.targetNode;
		var arr = [];
		var surface;
		if(parentWidget.surface) surface = parentWidget.surface;
		else surface = parentWidget;
		var len = 0;
		if(surface && surface.children) len = surface.children.length;
		for(var i = 0; i < len; i++){
			var child = surface.children[i];
			var obj = child.outlineObj;
			if(!obj){
				var title = child.elementName ? child.elementName : child.declaredClass.replace(/.*\./, "");
				obj = {
					// required fields
					label: title,
					icon: null,

					// additional fields
					targetNode: child
				};
				child.outlineObj = obj;
			}
			obj.parentElement = parentElement;
			arr.push(obj);
		}
		return arr;
	},

	// public Object getParent(Object element);
	getParent: function(element){
		return element.parentElement;
	},

	// public boolean hasChildren(Object element);
	hasChildren: function(element){
	},

	getInput: function(){
		return this.input;
	}
});
