/*
	Copyright (c) 2007-2008, IBM Corp.
*/
dojo.provide("btp.widget.tool.DefaultCreationTool");
dojo.require("btp.widget.tool.AbstractTool");

dojo.declare(
	"btp.widget.tool.DefaultCreationTool",
	btp.widget.tool.AbstractTool,
{
	handleClick: function(e, editPartViewer){
		this.setEditPartViewer(editPartViewer);
		if(editPartViewer.selectedPaletteItem){
			if(editPartViewer.selectedPaletteItem.deselect){
				editPartViewer.selectedPaletteItem.deselect();
			}
		}
		var refWidget = this.findRefWidget(e);
		this.insertComponent(e, refWidget);
		this._editDomain.loadDefaultTool();
	},

	handleDrop: function(e, editPartViewer){
		this.setEditPartViewer(editPartViewer);
		var targetWidget = this.getDropTargetWidget(e);
		var ret;
		if(targetWidget.componentDropHandler){
			ret = targetWidget.componentDropHandler(e, editPartViewer);
		}else{
			ret = this.componentDropHandler(e, editPartViewer);
		}
		this._editDomain.loadDefaultTool();
		e.dragStatus = ret ? "dropSuccess" : "dropFailure"; // See DragManager.onMouseUp()
		editPartViewer.domNode.style.cursor = "auto";
	},

	handleMouseOver: function(e, editPartViewer){
		editPartViewer.domNode.style.cursor = "pointer";
	},


	componentDropHandler: function(e, editPartViewer){
		// this: drop target widget
		var srcElem = this.getDragSourceDomNode(e);
		var ret;
		if(srcElem.componentClassName){
			var refWidget = this.findRefWidget(e);
			ret = this.insertComponent(e, refWidget);
		}
		return ret;
	}
});
