/*
	Copyright (c) 2007-2008, IBM Corp.
*/
dojo.provide("btp.widget.tool.ResizeCreationTool");
dojo.require("btp.widget.tool.AbstractDragTool");
dojo.require("btp.dnd.DragManager");

dojo.declare(
	"btp.widget.tool.ResizeCreationTool",
	btp.widget.tool.AbstractDragTool,
{
	_rubberBand: null,

	handleMouseDown: function(e, editPartViewer){
		this.inherited("handleMouseDown", arguments);
		var rubberBand = this._rubberBand;
		if(!rubberBand){
			rubberBand = this._rubberBand = dojo.doc.createElement("DIV");
			rubberBand.style.fontSize = "1px";
			rubberBand.style.position = "absolute";
			rubberBand.style.border = "1px dashed black";
		}
		editPartViewer.domNode.appendChild(rubberBand);
		rubberBand.style.top = e.layerY + "px";
		rubberBand.style.left = e.layerX + "px";
		rubberBand.style.width = "0px";
		rubberBand.style.height = "0px";
	},
	
	onMouseMove: function(e){
		this.inherited("onMouseMove", arguments);
		var dy = e.pageY - this.pageY;
		var dx = e.pageX - this.pageX;
		var rubberBand = this._rubberBand;
		var top, left, width, height; // string
		if(dx > 0 && dy > 0){
			width = e.pageX - this.pageX + "px";
			height = e.pageY - this.pageY + "px";
		}

		if(top){ rubberBand.style.top = top; }
		if(left){ rubberBand.style.left = left; }
		if(width){ rubberBand.style.width = width; }
		if(height){ rubberBand.style.height = height; }
	},

	handleMouseUp: function(e, editPartViewer){
		this.inherited("handleMouseUp", arguments);
		if(dojo.isMozilla){
			// For some reason, FF starts auto scrolling after the resize creation.
			// I don't know why, but anyway this solves the problem. Very weird.
			var _this = this;
			setTimeout(function(){
				editPartViewer.domNode.removeChild(_this._rubberBand);
			}, 0);
		}else{
			editPartViewer.domNode.removeChild(this._rubberBand);
		}
		var srcElem = this.getDragSourceDomNode(e);
		var width = Math.abs(e.pageX - this.pageX);
		var height = Math.abs(e.pageY - this.pageY);
		srcElem.props = {};
		srcElem.props.coords = this.coords;
		srcElem.props.__style = {};
		if(width > 0){ srcElem.props.__style["width"] = width + "px"; }
		if(height > 0){ srcElem.props.__style["height"] = height + "px"; }
		this.insertComponent(e, editPartViewer);
	}
});
