/*
	Copyright (c) 2007-2008, IBM Corp.
*/
dojo.provide("gdc.widget.Curvyline");

dojo.require("gdc.widget.AbstractLine");

dojo.declare(
	"gdc.widget.Curvyline",
	gdc.widget.AbstractLine,
{
	createTargetShape: function(parent){
		var shape = parent.createPath();
		this.onPointsChanged();
		var pathStr = this._points2PathStr();
		if(pathStr){
			shape.setShape(pathStr);
		}
		this.inherited("createTargetShape", arguments);
		return shape;
	},

	update: function(props){
		if(!this.shape || this.points.length < 2){ return; }
		this.inherited("update", arguments);

		if(this._comparePoints(this.points, this.shape.shape.points) != 0){
			this.onPointsChanged();
			var pathStr = this._points2PathStr();
			if(pathStr){
				this.shape.setShape(pathStr);
			}
		}
	},
	
	_points2PathStr: function(){
		var pathStr = null;
		var str_M = "M";
		var str_Q = " Q";
		var str_T = " T";
		var strDelimiter = " ";
		var len = this.points.length;
		for(var i=0; i<len; i++){
			if(i==0){
				pathStr = str_M;
			}else if(i == len-1){
				pathStr += str_T;
			}else{
				pathStr += str_Q;
			}
			pathStr += this.points[i].x + strDelimiter + this.points[i].y;
			if(i > 0 && i < len-1){
			 	pathStr += strDelimiter + (this.points[i].x+this.points[i+1].x)/2 + strDelimiter
				+ (this.points[i].y+this.points[i+1].y)/2 + strDelimiter;
			}
		}
		return pathStr;
	}
});
