/*
	Copyright (c) 2007-2008, IBM Corp.
*/
dojo.provide("gdc.widget.CurvylineConnection");

dojo.require("gdc.widget.Curvyline");
dojo.require("gdc.widget.support.connection");

dojo.declare(
	"gdc.widget.CurvylineConnection",
	gdc.widget.Curvyline,
{
	startup: function(){
		this.processParams();
	},

	update: function(){
		if(!this.shape || this.points.length < 2){ return; }
		this.inherited("update", arguments);
		if(this.targetDecoration && typeof(this.targetDecoration) != "string"){
			var pt = this.getEnd();
			this.targetDecoration.setLocation(pt);

			var pt0 = this.points[this.points.length - 2];
			var dx = Math.abs(pt.x - pt0.x);
			var dy = pt.y - pt0.y;
			var angle = Math.atan(dy/dx)/Math.PI*180;
			if(pt.x - pt0.x < 0){
				angle = 180 - angle;
			}
			this.targetDecoration.setRotation(angle);
		}
	}
});
dojo.extend(gdc.widget.CurvylineConnection, gdc.widget.support.connection);
