/*
	Copyright (c) 2007-2008, IBM Corp.
*/
dojo.provide("gdc.widget.Ellipse");
dojo.require("gdc.widget.AbstractNode");
dojo.require("gdc.widget.GfxContainer");
dojo.require("dojox.color");

dojo.declare(
	"gdc.widget.Ellipse",
	[gdc.widget.AbstractNode, gdc.widget.GfxContainer],
{
	backgroundColor: 'white', // default value
	borderColor: 'black', // default value
	
	createTargetShape: function(parent){
		var shape = parent.createEllipse({
			cx:this.getWidth() / 2,
			cy:this.getHeight() / 2,
			rx:this.getWidth() / 2,
			ry:this.getHeight() / 2				
		});
		this.createConnectionAnchors();
		return shape;
	},

	// Override gdc.widget.AbstractNode
	getShapeInfo: function(){
		return { type:'ellipse',
			cx:this.getWidth()/2, cy:this.getHeight()/2,
			rx:this.getWidth()/2, ry:this.getHeight()/2
		};
	},
	
	update: function(){
		this.inherited("update", arguments);		
		this.setBgColor(this.backgroundColor);
		this.setBorderColor(this.borderColor);
	},

	getBgColor: function(){
		return this.backgroundColor;
	},
	
	setBgColor: function(color){
		this.backgroundColor = color;
		this.shape.setFill(new dojo.Color(this.backgroundColor)); // incorrect
	},
	
	getBorderColor: function(){
		return this.borderColor;
	},
	
	setBorderColor: function(color){
		this.borderColor = color;
		this.shape.setStroke(this.borderColor);
	}
});
