/*
	Copyright (c) 2007-2008, IBM Corp.
*/
dojo.provide("gdc.widget.GfxContainer");
dojo.require("dijit._Container");

// Summary:
//		This class is intended to be used by container-type gfx widgets.
//		(GfxWidget cannot have addChild/removeChild since it does not
//		 inherit from dijit._Container. That's why this class exists.)

dojo.declare(
	"gdc.widget.GfxContainer",
	dijit._Container,
{
	// override
	addChild: function(/*Widget*/widget, /*int?*/insertIndex){
		this.inherited("addChild", arguments);
		if(widget instanceof gdc.widget.GfxWidget && this.groupBox){
			widget.createShape(this.groupBox); // subclass must prepare "this.groupBox"
			widget.updateRecursively();
		}
	},

	// override
	removeChild: function(/*Widget*/widget){
		this.inherited("removeChild", arguments);
		if(widget instanceof gdc.widget.GfxWidget){
			widget.removeShape();
		}
	}
});
