/*
	Copyright (c) 2007-2008, IBM Corp.
*/
dojo.provide("gdc.widget.Image");
dojo.require("gdc.widget.AbstractNode");
dojo.require("gdc.widget.GfxContainer");

dojo.declare(
	"gdc.widget.Image",
	[gdc.widget.AbstractNode, gdc.widget.GfxContainer],
{
	src: '',
	
	postCreate: function(){
		this.inherited("postCreate", arguments);
		if(dojo.isIE) {
			this.domNode.style.backgroundColor = "#FFF";
			this.domNode.style.filter = "Alpha(opacity=0)";
		}
	},
	
	createTargetShape: function(parent){
		var shape = parent.createImage({width:this.getWidth(), height:this.getHeight(), src:dojo.moduleUrl("hale", "../"+this.src)+""});
		return shape;
	},
	
	// Override gdc.widget.AbstractNode
	getShapeInfo: function(){
		return { type:"image",
			width:this.getWidth(), height:this.getHeight(),
			src:dojo.moduleUrl("hale", "../"+this.src)+""
		}
	},
	
	getSrc: function(){
		return this.src;
	},

	setSrc: function(src){
		this.src = src;
		this.update();
	},
	
	// TODO : need to transform
	setWidth: function(width){
		var temp = parseInt(width);
		if(isNaN(temp)){ return; }
		this.width = temp;
		this.update();
	},
	
	// TODO : need to transform
	setHeight: function(height){
		var temp = parseInt(height);
		if(isNaN(temp)){ return; }
		this.height = temp;
		this.update();
	}	
});