/*
	Copyright (c) 2007-2008, IBM Corp.
*/
dojo.provide("gdc.widget.Polyline");

dojo.require("gdc.widget.AbstractLine");

dojo.declare(
	"gdc.widget.Polyline",
	gdc.widget.AbstractLine,
{
	createTargetShape: function(parent){
		this.onPointsChanged();
		var shape = parent.createPolyline(this.points);
		this.inherited("createTargetShape", arguments);
		return shape;
	},

	update: function(props){
		if(!this.shape || this.points.length < 2){ return; }
		this.inherited("update", arguments);

		// setShape is not low cost especially on IE, so compare the points first to see if something has really changed.
		if(this._comparePoints(this.points, this.shape.shape.points) != 0){
			this.onPointsChanged();
			this.shape.setShape(this.points);
		}
	},

	calculateAngle: function(pt0, pt1){
		var dx = Math.abs(pt1.x - pt0.x);
		var dy = pt1.y - pt0.y;
		if(dx == 0 && dy == 0){ return 0; }
		var angle = Math.atan(dy/dx)/Math.PI*180;
		if(pt1.x - pt0.x < 0){
			angle = 180 - angle;
		}
		return angle;
	}
});
