/*
	Copyright (c) 2007-2008, IBM Corp.
*/
dojo.provide("gdc.widget.Rect");

dojo.require("gdc.widget.AbstractNode");
dojo.require("gdc.widget.GfxContainer");

dojo.declare(
	"gdc.widget.Rect",
	[gdc.widget.AbstractNode, gdc.widget.GfxContainer],
{
	backgroundColor: 'white', // default value
	borderColor: 'black', // default value

	createTargetShape: function(parent){
		var shape = parent.createRect({width:this.getWidth(), height:this.getHeight()});
		this.createConnectionAnchors();
		return shape;
	},

	// Override gdc.widget.AbstractNode
	getShapeInfo: function(){
		return { type:'rect',
			width:this.getWidth(), height:this.getHeight()
		};
	},

	// Override gdc.widget.AbstractNode
	update: function(){
		this.inherited("update", arguments);
		this.setBackgroundColor(this.backgroundColor);
		this.setBorderColor(this.borderColor);
	},

// ======================= Setters/Getters =================================
	getBackgroundColor: function(){
		return this.backgroundColor;
	},
	
	setBackgroundColor: function(color){
		if(this._backgroundColorDone && this.backgroundColor == color){ return; }
		this.backgroundColor = color;
		if(!this.shape){ return; }
		this.shape.setFill(new dojo.Color(this.backgroundColor));
		this._backgroundColorDone = true;
	},
	
	getBorderColor: function(){
		return this.borderColor;
	},
	
	setBorderColor: function(color){
		if(this._borderColorDone && this.borderColor == color){ return; }
		this.borderColor = color;
		if(!this.shape){ return; }
		this.shape.setStroke(this.borderColor);
		this._borderColorDone = true;
	}
});
