/*
	Copyright (c) 2007-2008, IBM Corp.
*/
dojo.provide("gdc.widget.Surface");

dojo.require("dijit._Widget");
dojo.require("dijit._Container");
dojo.require("dojox.gfx");
dojo.require("gdc.widget.GfxContainer");

dojo.declare(
	"gdc.widget.Surface",
	[dijit._Widget, dijit._Contained, gdc.widget.GfxContainer],
{
	width: 800, // Integer
	height: 600, // Integer
	surface: null,
	groupBox: null, // GfxContainer uses this
	_started: true, // By doing this, startup() of dynamically added child will be called.

	postCreate: function(){
		this.domNode.className = "gdlSurface";
		this.domNode.style.position = "relative";
		this.domNode.style.width = this.width + "px";
		this.domNode.style.height = this.height + "px";
		this.domNode.style.backgroundColor = "Window";
		this.surface = dojox.gfx.createSurface(this.domNode, this.width, this.height);
		this.rootGroup = this.groupBox = this.surface.createGroup();
	},

	startup: function(){
		dojo.forEach(this.getChildren(), function(child){if(child.startup){child.startup();}});
	},

	getShape: function(){
		return this.groupBox;
	}
});
