/*
	Copyright (c) 2007-2008, IBM Corp.
*/
dojo.provide("gdc.widget.Text");
dojo.require("gdc.widget.AbstractNode");
dojo.require("dojox.color");

dojo.declare(
	"gdc.widget.Text",
	gdc.widget.AbstractNode,
{
	text: 'text', // default value
	color: 'black', // default value
	size: '18pt', // default value
	width: 100, // default value
	height: 20, // default value

	createTargetShape: function(parent){
		var shape = parent.createText({width:this.getWidth(), height:this.getHeight(), text: this.getText()});
		return shape;
	},

	// Override gdc.widget.AbstractNode
	getShapeInfo: function(){
		return { type:'text',
			y:this.getHeight(),
			text:this.getText()
		};
	},

	// Override gdc.widget.AbstractNode
	update: function(){
		this.inherited("update", arguments);
		this.setColor(this.color);
		this.setSize(this.size);
	},

	getText: function(){
		return this.text;
	},
	
	setText: function(text){
		this.text = text;
		this.update();
	},
	
	getColor: function(){
		return this.color;
	},
	
	setColor: function(color){
		this.color = color;
		this.shape.setFill(new dojo.Color(this.color));
	},
	
	getSize: function(){
		return this.size;
	},
	
	setSize: function(size){
		this.size = size;
		this.shape.setFont({ size:this.size });
	}
});