/*
	Copyright (c) 2007-2008, IBM Corp.
*/
dojo.provide("gdc.widget.anchor.AbstractConnectionAnchor");

dojo.declare(
	"gdc.widget.anchor.AbstractConnectionAnchor",
	null,
{
	owner: null,
	listeners: null, // Array

	constructor: function(owner){
		this.owner = owner;
		this._connector = dojo.connect(owner, "nodeMoved", this, "anchorMoved");
	},

	destroy: function(){
		dojo.disconnect(this._connector);
	},

	addAnchorListener: function(/*ConnectionWidget*/listener){
		if(!this.listeners){ this.listeners = []; }
		if(dojo.indexOf(this.listeners, listener) != -1){//TODO: remove this code later
			alert("gdc.widget.anchor.AbstractConnectionAnchor#addAnchorListener: internal error: already registered");
		}
		this.listeners.push(listener);
	},

	removeAnchorListener: function(/*ConnectionWidget*/listener){
		var idx = dojo.indexOf(this.listeners, listener);
		if(idx != -1){
			this.listeners.splice(idx, 1);
		}
	},

	anchorMoved: function(/*Widget*/widget){
		if(!this.listeners){ return; }
		for(var i = 0, len = this.listeners.length; i < len; i++){
			this.listeners[i].anchorMoved(widget);
		}
	},

	getLocation: function(/*{x:#,y:#}*/ref){
		// subclass must implement
	},

	// Returns direction of connection
	// pt is coordinate calculated by getLocation
	// subclass may override
	getDirection: function(/*{x:#,y:#}*/pt){
		if(!pt){ return; }
		var owner = this.owner;
		
		// lm1 and rm corrsponds to left-/right-hand member of line1, respectively :
		// 		y = (owner.height/owner.width)*(x - owner.left) + owner.top
		var lm1 = owner.width*(pt.y - owner.top);
		var rm = owner.height*(pt.x - owner.left);
		
		// lm2 corrsponds to left-hand member of line2 :
		// y = -(owner.height/owner.width)*(x - owner.left) + (owner.top + owner.height)
		var lm2 = owner.width*(pt.y - owner.top - owner.height);
		
		if((lm1 < rm) && (lm2 >= -rm)){
			return "right";
		}else if((lm1 >= rm) && (lm2 >= -rm)){
			return "bottom";
		}else if((lm1 < rm) && (lm2 < -rm)){
			return "top";
		}else{
			return "left";
		}
	}, 

	getReferencePoint: function(){
		// subclass must implement
	}
});
