/*
	Copyright (c) 2007-2008, IBM Corp.
*/
dojo.provide("gdc.widget.anchor.ChopboxAnchor");

dojo.require("gdc.widget.anchor.AbstractConnectionAnchor");

// Summary:
//		The ChopboxAnchor's location is found by calculating the intersection of a line drawn
//		from the center point of its owner's box to a reference point on that box.

dojo.declare(
	"gdc.widget.anchor.ChopboxAnchor",
	gdc.widget.anchor.AbstractConnectionAnchor,
{
	getLocation: function(/*{x:#,y:#}*/ref){
		var owner = this.owner;
		var cx = owner.left + owner.width/2;
		var cy = owner.top + owner.height/2;
		var dx = (ref && ref.x) - cx;
		var dy = (ref && ref.y) - cy;
		var ratioX = (owner.width/2) / Math.abs(dx);
		var ratioY = (owner.height/2) / Math.abs(dy);
		var ratio = Math.min(ratioX, ratioY);
		var x = Math.round(cx + ratio * dx);
		var y = Math.round(cy + ratio * dy);
		return {x:x, y:y};
	},

	getReferencePoint: function(){
		var owner = this.owner;
		var x = owner.left + owner.width/2;
		var y = owner.top + owner.height/2;
		return {x:x, y:y}; // center of the bounding box
	}
});
