/*
	Copyright (c) 2007-2008, IBM Corp.
*/
dojo.provide("gdc.widget.anchor.EllipseAnchor");

dojo.require("gdc.widget.anchor.AbstractConnectionAnchor");

// Summary:
//		The EllipseAnchor's location is found by calculating the intersection of a line drawn
//		from the center point of ellipse to a reference point on that box.

dojo.declare(
	"gdc.widget.anchor.EllipseAnchor",
	gdc.widget.anchor.AbstractConnectionAnchor,
{
	getLocation: function(/*{x:#,y:#}*/ref){
		var owner = this.owner;
		var cx = owner.left + owner.width/2;
		var cy = owner.top + owner.height/2;
		var dx = owner.height*((ref && ref.x) - cx);
		var dy = owner.width*((ref && ref.y) - cy);
		var r = Math.sqrt(Math.pow(dx, 2) + Math.pow(dy, 2));
		return {
			x: Math.round(cx + owner.width/2*dx/r),
			y: Math.round(cy + owner.height/2*dy/r)
		};
	},

	getReferencePoint: function(){
		var owner = this.owner;
		var x = owner.left + owner.width/2;
		var y = owner.top + owner.height/2;
		return {x:x, y:y}; // center of the bounding box
	}
});
