/*
	Copyright (c) 2007-2008, IBM Corp.
*/
dojo.provide("gdc.widget.anchor.FixedAnchor");

dojo.require("gdc.widget.anchor.AbstractConnectionAnchor");

// Summary:
//		The FixedAnchor's location is the center of the owner's box.

dojo.declare(
	"gdc.widget.anchor.FixedAnchor",
	gdc.widget.anchor.AbstractConnectionAnchor,
{
	endPointDomNode: null,
	endPointShape: null,
	
	offsetH: 0,
	offsetV: 0,
	centerOrigin: true,

	getLocation: function(/*{x:#,y:#}*/ref){
		var owner = this.owner;
		var matrix = this.endPointShape.getTransform();
		var bb = this.endPointShape.getBoundingBox();
		var x = owner.left + matrix.dx + bb.x + (this.centerOrigin ? bb.width/2 : 0) + this.offsetH;
		var y = owner.top + matrix.dy + bb.y + (this.centerOrigin ? bb.height/2 : 0) + this.offsetV;
		return {x:x, y:y}; // center of the bounding box
	},

	getReferencePoint: function(){
		var owner = this.owner;
		var x = owner.left + owner.width/2;
		var y = owner.top + owner.height/2;
		return {x:x, y:y}; // center of the bounding box
	}
});
