/*
	Copyright (c) 2007-2008, IBM Corp.
*/
dojo.provide("gdc.widget.samples.ConnectableRect");

// summary:
//		A sample gfx node widget that has a ChopboxAnchor.

dojo.require("gdc.widget.Rect");
dojo.require("gdc.widget.support.connectable");

dojo.declare(
	"gdc.widget.samples.ConnectableRect",
	gdc.widget.Rect,
{
	anchor: "gdc.widget.anchor.ChopboxAnchor",

	createTargetShape: function(parent){
		var shape = this.inherited("createTargetShape", arguments);
		this.createConnectionAnchors();
		return shape;
	},

	createConnectionAnchors: function(){
		dojo["require"](this.anchor);
		var anchorImpl = dojo.getObject(this.anchor);
		var anchorName = "base";
		this.registerSourceConnectionAnchor(this.getShape().rawNode, anchorName, new anchorImpl(this));
		this.registerTargetConnectionAnchor(this.getShape().rawNode, anchorName, new anchorImpl(this));
	}
});
dojo.extend(gdc.widget.samples.ConnectableRect, gdc.widget.support.connectable);
