/*
	Copyright (c) 2007-2008, IBM Corp.
*/
dojo.provide("gdl._base.utils");

// summary:
//		Utility functions.

dojo.mixin(gdl,
{
	// Return nearest parent widget that has both widget1 and widget2 as ancestors
	getOffsetParent: function(widget1, widget2){
		// first pass through the widget tree
		var temp1 = widget1;
		var temp2 = widget2;
		while(temp1){
			temp2 = widget2;
			while(temp2){
				if(temp1 == temp2){
					return temp1;
				}
				temp2 = temp2.getParent();
			}
			temp1 = temp1.getParent();
		}
		
		// second pass through the widget tree
		temp1 = widget1;
		temp2 = widget2;
		while(temp2){
			temp1 = widget1;
			while(temp1){
				if(temp1 == temp2){
					return temp1;
				}
				temp1 = temp1.getParent();
			}
			temp2 = temp2.getParent();
		}
		
		return null;
	}
});
