/*
	Copyright (c) 2007-2008, IBM Corp.
*/
dojo.provide("gdl.widget.EditArea");

dojo.require("dojox.gfx");
dojo.require("btp.widget.EditArea");
dojo.require("gdl._base");
dojo.require("gdl.widget._editArea.canvas");
dojo.require("gdl.widget._editArea.focus");
dojo.require("gdc.widget.GfxWidget");

dojo.declare(
	"gdl.widget.EditArea",
	btp.widget.EditArea,
{
	surface: null, // surface to add gfx shapes
	rootGroup: null, // Group object for zoom-in/out

	reconnectTrackerClass: "gdl.widget.tool.ReconnectTracker",

	// override
	freeLayoutMode: true,

	// override
	initCanvas: function(){
		this.inherited("initCanvas", arguments);
		this.initSurface();
	},

	initSurface: function(){
		this.surface = dojox.gfx.createSurface(this.domNode, "1px", "1px");
		this.rootGroup = this.groupBox = this.surface.createGroup();
	},

	getShape: function(){
		return this.groupBox;
	},

	// override
	addChild: function(/*Widget*/widget, /*int?*/insertIndex){
		this.inherited("addChild", arguments);
		if(window.gdc && widget instanceof gdc.widget.GfxWidget && this.groupBox){
			widget.createShape(this.groupBox); // subclass must prepare "this.groupBox"
			widget.updateRecursively();
		}
	},

	// override
	removeChild: function(/*Widget*/widget){
		this.inherited("removeChild", arguments);
		if(widget instanceof gdc.widget.GfxWidget){
			widget.removeShape();
		}
	}
});
dojo.extend(gdl.widget.EditArea, gdl.widget._editArea.canvas);
dojo.extend(gdl.widget.EditArea, gdl.widget._editArea.focus);
