/*
	Copyright (c) 2007-2008, IBM Corp.
*/
dojo.provide("gdl.widget._editArea.canvas");

// summary:
//		Canvas size adjustment.
//		'this' points to the EditArea.

gdl.widget._editArea.canvas = {

	_getCanvasMarginH: function() {
		//to remove unnecessary scrollbar
		return dojo.isIE ? 2:0;
	},
	
	_getCanvasMarginV: function() {
		//to remove unnecessary scrollbar
		return dojo.isIE ? 2:7;
	},
	
	_getMostDistantPositionFromOrigin: function(/*"vertical"|"horizontal"*/direction) {
		var isHorizontal = true;
		if(direction == "vertical") isHorizontal = false;
		
		var max = 0;
		var children = this.getChildren();
		for(var i=0; i<children.length; i++){
			var w = children[i];
			var pos = isHorizontal ? w.domNode.offsetLeft : w.domNode.offsetTop;
			var most = pos + (isHorizontal ? w.domNode.offsetWidth : w.domNode.offsetHeight);
			max = Math.max(most,max);
		}
		return max;
	},
	
	// override hale.widget.EditArea
	// so that it resize surface when canvas is extended
	// TODO : this resizes only when node is dropped to different position
	//		should also resize while resizing connection
	adjustCanvasWidth: function(widget){
		var diff = this._getCanvasMarginH();		
		var rightMost = this._getMostDistantPositionFromOrigin("horizontal");
		var editAreaRight = Math.max(rightMost, this.domNode.clientWidth);
		var dim = this.surface.getDimensions();
		if(editAreaRight != parseInt(dim.width-diff)){
			this.surface.setDimensions(editAreaRight-diff, dim.height);
		}
	},

	// override hale.widget.EditArea
	// so that it resize surface when canvas is extended
	// TODO : this resizes only when node is dropped to different position
	//		should also resize while resizing connection
	adjustCanvasHeight: function(widget){
		var diff = this._getCanvasMarginV();
		var bottomMost = this._getMostDistantPositionFromOrigin("vertical");
		
		var editAreaBottom = Math.max(bottomMost, this.domNode.clientHeight);
		var dim = this.surface.getDimensions();
		if(editAreaBottom != parseInt(dim.height-diff)){
			this.surface.setDimensions(dim.width, editAreaBottom-diff);
		}
	}
};
