/*
	Copyright (c) 2007-2008, IBM Corp.
*/
dojo.provide("gdl.widget._editArea.focus");

// summary:
//		Handles focus for components on EditArea.
//		'this' points to the EditArea.

gdl.widget._editArea.focus = {
	// override btp.widget._editArea.focus.deleteFocusWidget
	deleteFocusWidget: function(){
		if(!this.focusWidgets || this.focusWidgets.length == 0){ return; }

		var focusWidgets = this.focusWidgets;
		this.removeFocus();

		// TODO: What if two widgets have parent-child relationship?
		var compoundCommand = new btp.widget.command.CompoundCommand();
		for(var i = 0, len = focusWidgets.length; i < len; i++){
			var focusWidget = focusWidgets[i];
			var parent = focusWidget.getParent();
			if(parent.update){
				compoundCommand.append(new btp.widget.command.EditCommand.UpdateCommand(parent));
				compoundCommand.append(new btp.widget.command.EditCommand.RemoveChildCommand(focusWidget));
				compoundCommand.append(new btp.widget.command.EditCommand.UpdateCommand(parent));
			}else{
				compoundCommand.append(new btp.widget.command.EditCommand.RemoveChildCommand(focusWidget));
			}

			// remove connections
			for(var j = 0; j < 2; j++){
				var anchors = (j == 0) ? focusWidget.sourceConnectionAnchors : focusWidget.targetConnectionAnchors;
				if(!anchors){ return; }
				for(var anchorName in anchors){
					var listeners = anchors[anchorName].listeners;
					if(!listeners){ continue; }
					for(var k = 0, len2 = listeners.length; k < len2; k++){
						var connectionWidget = listeners[k];
						compoundCommand.append(new btp.widget.command.EditCommand.RemoveChildCommand(connectionWidget));
					}
				}
			}
		}
		this.getEditDomain().executeCommand(compoundCommand);
	}
};
