/*
	Copyright (c) 2007-2008, IBM Corp.
*/
dojo.provide("gdl.widget.command.ConnectionCommand");

gdl.widget.command.ConnectionCommand = {
	AddConnectionCommand: function(parent, connection) {
		this._parent = parent;
		this._connection = connection;
	
		this.execute = function(){
			this._parent.hlp_addChild(this._connection);
			this._connection.getSource().onSourceConnectionAdded(this._connection);
			this._connection.getTarget().onTargetConnectionAdded(this._connection);
		}
	
		this.undo = function(){
			this._connection.getSource().onRemovingSourceConnection(this._connection);
			this._connection.getTarget().onRemovingTargetConnection(this._connection);
			this._parent.hlp_removeChild(this._connection);
		}
	},		
	
	RemoveConnectionCommand: function(connection) {
		this._connection = connection;
	
		this.execute = function(){
			this._connection.getSource().onRemovingSourceConnection(this._connection);
			this._connection.getTarget().onRemovingTargetConnection(this._connection);
			this._parent = this._connection.getParent();
			this._refChild = this._connection.getNextSibling();
			this._parent.hlp_removeChild(this._connection);
		}
	
		this.undo = function(){
			if(this._refChild){
				this._parent.hlp_addChild(this._connection, this._refChild);
			}else{
				this._parent.hlp_addChild(this._connection);
			}
			this._connection.getSource().onSourceConnectionAdded(this._connection);
			this._connection.getTarget().onTargetConnectionAdded(this._connection);
		}
	}
	
}