/*
	Copyright (c) 2007-2008, IBM Corp.
*/
dojo.provide("gdl.widget.ext.disconnectPopup");

dojo.require("gdl.widget.command.ConnectionCommand");
dojo.require("dojox.color");
dojo.require("btp.i18n");

dojo.declare(
"gdl.widget.disconnectPopup",
null,
{
	domNode: null,	//div
	
	_iconImgSrc: "widget/templates/Toolbar/delete.gif",
	
	iconWidth: 18,
	iconHeight: 18,
	
	popupArea: null, // div(EditArea)
	
	connection: null,
			
	constructor: function(div) {
		var bundle = btp.i18n.loadBundle("gdl.widget.common");
		this.domNode = div;
		this.domNode.title = btp.i18n.gets("deleteIconTooltip");
		dojo.addClass(this.domNode, "gdlDisconnectPopup");
		this.domNode.style.cssText = "display: none;position: absolute;width: 22px;height: 22px;top: 0px;left: 0px;border-width: 1px;border-color: black;border-style: solid;background-color: white;z-index: 10000;";
		var imgsrc =  dojo.moduleUrl("btp", this._iconImgSrc)+"";
		this.domNode.style.backgroundRepeat = "no-repeat";
		this.domNode.style.backgroundImage = "url(" + imgsrc +  ")";
		dojo.connect(this.domNode, "onmouseout", this, "_onMouseOut");
		dojo.connect(this.domNode, "onclick", this, "_onClick");
	},
	
	_onMouseOut: function(e){
		if(this.connection && this.connection.origStroke){
			this.connection.shape.setStroke(this.connection.origStroke);
		}
		this.domNode.style.display = "none";
		this.connection = null;
	},
	
	_onClick: function(e){
		var command = new gdl.widget.command.ConnectionCommand.RemoveConnectionCommand(this.connection);
		var editArea = btp.getEditors()[0];
		if(editArea){
			editArea.getEditDomain().executeCommand(command);
		}
		this.domNode.style.display = "none";
	},
	
	_changeConnectionColor: function(){
		var orig = this.connection.shape.getStroke();
		var newStroke = dojo.clone(orig);
		newStroke.color = this.connection.mouseOverColor;
		this.connection.shape.setStroke(newStroke);
		return orig;
	},
		
	showPopup: function(e, connection){
		this.connection = connection;
		var points = connection.points;
		var x = (points[0].x + points[points.length-1].x) / 2;
		var y = (points[0].y + points[points.length-1].y) / 2;		
		var editArea = this.domNode.parentNode;
		var coords = dojo.coords(editArea);		
//		x+= editArea.scrollLeft - coords.x;
//		y+= editArea.scrollTop - coords.y;
		this.domNode.style.left = x -  this.iconWidth/2 + "px";
		this.domNode.style.top = y - this.iconHeight/2 + "px";
		this.domNode.style.display = "";
		
		if(connection.mouseOverColor && connection.mouseOverColor != ""){
			var origStroke = this._changeConnectionColor();
			if(!this.connection.origStroke){
				this.connection.origStroke = origStroke;
			}			
		}
	},
	
	hide: function(){
		this.domNode.style.display = "none";
		if(this.connection && this.connection.origStroke){
			this.connection.shape.setStroke(this.connection.origStroke);
		}
		this.connection = null;
	}
	
});
