/*
	Copyright (c) 2007-2008, IBM Corp.
*/
dojo.provide("gdl.widget.helper.lineFocusHelper");

// Summary:
//		This class is mixed into gfx line widgets such as Polyline
//		and overrides btp.widget.helper.focusHelper.
//		'this' points to a gfx line widget. EditArea can be accessed via this.__editArea.

gdl.widget.helper.lineFocusHelper = {
	// ------------- Focus Frame ----------------------------
	hlp_setFocusFrame: function(){
		this.shape.setStroke({color: "yellow"}); // TODO: should not hard-code the color
		if(this.sourceDecorationObj){
			var dec = this.sourceDecorationObj;
			dec.shape.setStroke({color: "yellow"}); // TODO: should not hard-code the color
			if(dec.fillColor){
				dec.shape.setFill("yellow"); // TODO: should not hard-code the color
			}
		}
		if(this.targetDecorationObj){
			var dec = this.targetDecorationObj;
			dec.shape.setStroke({color: "yellow"}); // TODO: should not hard-code the color
			if(dec.fillColor){
				dec.shape.setFill("yellow"); // TODO: should not hard-code the color
			}
		}
	},

	hlp_removeFocusFrame: function(){
		this.update({forceUpdate:true});
		if(this.sourceDecorationObj){
			this.sourceDecorationObj.update({forceUpdate:true});
		}
		if(this.targetDecorationObj){
			this.targetDecorationObj.update({forceUpdate:true});
		}
	},

	hlp_refreshFocusFrame: function(){
		alert("hlp_refreshFocusFrame");
	},

	// ------------- Feedback Frame ----------------------------
	hlp_showAllowDropFeedback: function(){
		alert("hlp_showAllowDropFeedback");
	},

	hlp_hideAllowDropFeedback: function(){
		alert("hlp_hideAllowDropFeedback");
	},

	// -------- Show/Hide a frame around the component ----------
	hlp_showComponentFrame: function(type){
		alert("hlp_showComponentFrame");
	},

	hlp_hideComponentFrame: function(type){
		alert("hlp_hideComponentFrame");
	}
};
