/*
	Copyright (c) 2007-2008, IBM Corp.
*/
dojo.provide("gdl.widget.tool.ConnectionCreationTool");

dojo.require("gdl.widget.tool.AbstractConnectionCreationTool");

dojo.declare(
	"gdl.widget.tool.ConnectionCreationTool",
	gdl.widget.tool.AbstractConnectionCreationTool,
{
	_ds: null,
	_type: "connection",

	handleMouseDown: function(e, editPartViewer){
		this.setEditPartViewer(editPartViewer);
		if (this._operationStarted){
			this._operationStarted = false;
			var ret = this.handleCreateConnection(e, editPartViewer);
			this.targetWidget.__dt.hideFeedback();
			this.finishCreateConnection(e, editPartViewer);
			return ret;
		}
		if (!this.inherited("handleMouseDown", arguments)){ return false; }
		this._operationStarted = true;
		this.createGhostLine(e, editPartViewer);
		return true;
	},

	// Updates ghost line
	handleMouseMove: function(e, editPartViewer){
		if (!this._operationStarted){ return false; }
		var widget = this.targetWidget;
		if(widget && widget.getTargetConnectionAnchor){
			var anchor = widget.getTargetConnectionAnchor(e.target);
			this.targetConnectionAnchor = anchor;
			this.ghostLine.setTargetAnchor(anchor);
		}else{
			var pos = dojo._abs(editPartViewer.domNode, false);
			var x = e.pageX - pos.x;
			var y = e.pageY - pos.y;
			this.targetConnectionAnchor = null;
			this.ghostLine.setTargetAnchor(null);
			this.ghostLine.setEnd({x:x, y:y});
		}
		this.sourceConnectionAnchor.anchorMoved();
		return true;
	},

	handleMouseOver: function(e, editPartViewer){
		if(this.sourceWidget == this.targetWidget){ return; }
		var dropTargetWidget = btp.getWidgetByElement(e.target);
		if(this.sourceWidget == dropTargetWidget){ return; }
		var dt = dropTargetWidget && dropTargetWidget.__dt;
		if(!dt){ return false; }
		var dropAcceptable = dt.accepts({type:"connection"}); // @TODO should not hard-code "connection"
		if(dropAcceptable){
			this.targetWidget = dropTargetWidget;
			dt.showFeedback();
		}else{
			this.targetWidget = null;
		}
		return true;
	},

	handleMouseOut: function(e, editPartViewer){
		if(!this.targetWidget || this.sourceWidget == this.targetWidget){ return; }
		this.targetWidget = null;
		var dropTargetWidget = btp.getWidgetByElement(e.target);
		var dt = dropTargetWidget && dropTargetWidget.__dt;
		if(!dt){ return false; }
		dt.hideFeedback();
		return true;
	}
});
