/*
	Copyright (c) 2007-2008, IBM Corp.
*/
dojo.provide("gdl.widget.tool.ConnectionDragCreationTool");

dojo.require("gdl.widget.tool.AbstractConnectionCreationTool");
dojo.require("btp.dnd.DragMoveSource");
dojo.require("btp.dnd.DragManager");

dojo.declare(
	"gdl.widget.tool.ConnectionDragCreationTool",
	gdl.widget.tool.AbstractConnectionCreationTool,
{
	_ds: null,
	_type: "connection",

	handleMouseDown: function(e, editPartViewer){
		this.setEditPartViewer(editPartViewer);
		if (!this.inherited("handleMouseDown", arguments)){ return false; }
		var widget = this.sourceWidget = btp.getWidgetByElement(e.target);
		if(!widget){ return false; }
		var moveTarget = editPartViewer.getMoveTarget();
		editPartViewer.domNode.appendChild(moveTarget);
		this._ds = new btp.dnd.DragMoveSource(e.target, "connection", widget); // @TODO should not hard-code "connection"
		this._ds.setDragTarget(moveTarget);
		this._ds.fixMouseDownInfo = function(ds){
			// See also btp.dnd.DragMoveSource#onDragMove
			ds.dragStartCssPosition.x += ds.dragOffset.x;
			ds.dragStartCssPosition.y += ds.dragOffset.y;
		}
		this._operationStarted = true;
		this.createGhostLine(e, editPartViewer);
		this.handleMouseMove(e, editPartViewer);
		
		this._conn = dojo.connect(dojo.doc, "onmouseup", dojo.hitch(this, "handleMouseUp", e, editPartViewer));
		return true;
	},

	// Updates ghost line
	handleMouseMove: function(e, editPartViewer){
		e.preventDefault(); // this disables selection
		if (!this._operationStarted){ return false; }
		var dt = btp.dnd.dragManager.currentDropTarget;
		var widget = this.targetWidget = dt && dt.data;
		if(widget && widget.getTargetConnectionAnchor){
			var anchor = widget.getTargetConnectionAnchor(e.target);
			this.targetConnectionAnchor = anchor;
			this.ghostLine.setTargetAnchor(anchor);
		}else{
			var pos = dojo._abs(editPartViewer.domNode, false);
			var x = e.pageX - pos.x + editPartViewer.domNode.scrollLeft - 2;
			var y = e.pageY - pos.y + editPartViewer.domNode.scrollTop;
			this.targetConnectionAnchor = null;
			this.ghostLine.setTargetAnchor(null);
			this.ghostLine.setEnd({x:x, y:y, dir:"left"});	//hardcoded temporalily
		}
		this.sourceConnectionAnchor.anchorMoved();
		return true;
	},

	handleMouseUp: function(e, editPartViewer){
		dojo.disconnect(this._conn);
		// Use setTime so that handleDrop is processed before finishCreateConnection.
		setTimeout(dojo.hitch(this, "finishCreateConnection", e, editPartViewer), 0);
	},

	handleDrop: function(e, editPartViewer){
		if(this._operationStarted) {
			this.finishCreateConnection(e, editPartViewer);
			var ret = this.handleCreateConnection(e, editPartViewer);
			this._operationStarted = false;
			return ret;			
		}
	}
});
