/*
	Copyright (c) 2007-2008, IBM Corp.
*/
dojo.provide("htc.widget.RoundCornerPane");

dojo.require("dijit.layout.ContentPane");
dojo.require("dijit._Templated");

dojo.declare(
	"htc.widget.RoundCornerPane",
	[dijit.layout.ContentPane, dijit._Templated, dijit._Container],
{
	title : "",
	top: '',
	left: '',
	borderStyle: "rich",
	bgColor: "white",

	templatePath: dojo.moduleUrl("htc.widget", "templates/RoundCornerPane/RoundCornerPane.html"),
//	templateCssPath: dojo.moduleUri("htc.widget", "templates/RoundCornerPane/RoundCornerPane.css"),

	postCreate: function(){
		htc.widget.RoundCornerPane.superclass.postCreate.apply(this, arguments);
		this.update();
	},
	
	update: function(){
		this.tableNode.className = this.borderStyle;
		this.tableNode.style.backgroundColor = this.bgColor;
		this.setTitle(this.title);
	},
	
// ======================= Setters/Getters =================================
	getTitle: function(){
		return this.title;
	},

	setTitle: function(title){
		this.title = title;
		this.titleNode.innerHTML = "";
		if(this.title){
			this.titleNode.appendChild(dojo.doc.createTextNode(this.title));
		}
	},

	getBorderStyle: function(){
		return this.borderStyle;
	},

	setBorderStyle: function(val){
		this.borderStyle = val;
		this.update();
	},

	getBgColor: function(){
		return this.bgColor;
	},

	setBgColor: function(val){
		this.bgColor = val;
		this.update();
	},

	getHeight: function(){
		return dojo.contentBox(this.domNode).h;
	},

	setHeight: function(/*int*/height){
		var tableH = dojo.contentBox(this.domNode).h;
		var containerH = dojo.contentBox(this.containerNode).h;
		this.containerNode.style.height = height - (tableH - containerH) + "px";
	}
});
