/*
	Copyright (c) 2007-2008, IBM Corp.
*/
dojo.provide("hub.pages.admin");
dojo.require("dojox.dtl.widget");
dojo.require("dojo.i18n");
dojo.requireLocalization("hub", "popups");
dojo.requireLocalization("hub", "links");
dojo.requireLocalization("hub", "panels");
dojo.requireLocalization("hub", "labels");
dojo.requireLocalization("hub", "messages");

/**
 * Page for adding, removing, or renaming categories. No server data to fetch.
 * Categories can be gotten from the global dijit named "hub.cats."
 */
dojo.declare('hub.pages.admin.Categories', hub.pages._Page, {
    // template to replace node with
    templatePath: dojo.moduleUrl("hub.pages", "templates/Categories.html"),

    /**
     * Imports required modules and build an object with properties matching 
     * fields in the template.
     */
    getContext: function() {
        // @todo
    }
});

/**
 * Page for reinitializing the database and sample data. No server data to 
 * fetch.
 */
dojo.declare('hub.pages.admin.Initialize', hub.pages._Page, {
    // template to replace node with
    templatePath: dojo.moduleUrl("hub.pages", "templates/Initialize.html"),

    /**
     * Imports required modules and build an object with properties matching 
     * fields in the template.
     */
    getContext: function() {
        // @todo
    }
});

/**
 * Page for reinitializing the database and sample data. No server data to 
 * fetch.
 */
dojo.declare('hub.pages.admin.AdminMigrateDatabase', hub.pages._Page, {
    // template to replace node with
    templatePath: dojo.moduleUrl("hub.pages", "templates/AdminMigrateDatabase.html"),

    /**
     * Imports required modules and build an object with properties matching 
     * fields in the template.
     */
    getContext: function() {
        // @todo
    }
});

/**
 * Page for assigning user permissions. Fetches existing permissions.
 */
dojo.declare('hub.pages.admin.Permissions', hub.pages._Page, {
    // template to replace node with
    templatePath: dojo.moduleUrl("hub.pages", "templates/Permissions.html"),

    /**
     * Builds an object with properties matching fields in the template. Merges
     * fetched server data with local data.
     *
     * @param server_data: JSON decoded object fetched from server URL
     */
    getContext: function(server_data) {
        // @todo
    },

    /**
     * Gets the RESTful URL to query for information required to complete the
     * rendering of the page.
     */
    getUrl: function() {
        return hub.urls.getAdminPermissionsPage();
    }
});

/**
 * Page for deleting arbitrary items. Fetches name, id, etc. of all items.
 */
dojo.declare('hub.pages.admin.AdminObjects', hub.pages._Page, {
    // template to replace node with
    templatePath: dojo.moduleUrl("hub.pages", "templates/AdminObjects.html"),
    widgetsInTemplate: true,
    /**
     * Builds an object with properties matching fields in the template. Merges
     * fetched server data with local data.
     *
     * @param server_data: JSON decoded object fetched from server URL
     */
    getContext: function(server_data) {
        if (!this.atomcatalogid) {
        	this.atomcatalogid = "atomcatalogid" + 11111;
        }
        console.log("this.atomcatalogid = " + this.atomcatalogid);
        return {"atomcatalogid": this.atomcatalogid};
    },

    /**
     * Gets the RESTful URL to query for information required to complete the
     * rendering of the page.
     */
    getUrl: function() {
        return hub.urls.getAdminDeletePage();
    }
});

/**
 * Page for banning or unbanning users. Fetches metadata about banned users.
 */
dojo.declare('hub.pages.admin.Ban', hub.pages._Page, {
    // template to replace node with
    templatePath: dojo.moduleUrl("hub.pages", "templates/Ban.html"),

    /**
     * Builds an object with properties matching fields in the template. Merges
     * fetched server data with local data.
     *
     * @param server_data: JSON decoded object fetched from server URL
     */
    getContext: function(server_data) {
        // @todo
    },

    /**
     * Gets the RESTful URL to query for information required to complete the
     * rendering of the page.
     */
    getUrl: function() {
        return hub.urls.getAdminBanPage();
    }
});

/**
 * Page for configuring email notification. Fetches the current config.
 */
dojo.declare('hub.pages.admin.Email', hub.pages._Page, {
    // template to replace node with
    templatePath: dojo.moduleUrl("hub.pages", "templates/Email.html"),

    /**
     * Builds an object with properties matching fields in the template. Merges
     * fetched server data with local data.
     *
     * @param server_data: JSON decoded object fetched from server URL
     */
    getContext: function(server_data) {
        // @todo
    },

    /**
     * Gets the RESTful URL to query for information required to complete the
     * rendering of the page.
     */
    getUrl: function() {
        return hub.urls.getAdminEmailPage();
    }
});

/**
 * Page for configuring tracking. Fetches the current config.
 */
dojo.declare('hub.pages.admin.EditTracking', hub.pages._Page, {
    // template to replace node with
    templatePath: dojo.moduleUrl("hub.pages", "templates/EditTracking.html"),

    /**
     * Builds an object with properties matching fields in the template. Merges
     * fetched server data with local data.
     *
     * @param server_data: JSON decoded object fetched from server URL
     */
    getContext: function(server_data) {
        // @todo
    },

    /**
     * Gets the RESTful URL to query for information required to complete the
     * rendering of the page.
     */
    getUrl: function() {
        return hub.urls.getAdminEditTrackingPage();
    }
});

/**
 * Page for view tracking data. Fetches tracked item info.
 */
dojo.declare('hub.pages.admin.ViewTracking', hub.pages._Page, {
    // template to replace node with
    templatePath: dojo.moduleUrl("hub.pages", "templates/ViewTracking.html"),

    /**
     * Builds an object with properties matching fields in the template. Merges
     * fetched server data with local data.
     *
     * @param server_data: JSON decoded object fetched from server URL
     */
    getContext: function(server_data) {
        // @todo
    },

    /**
     * Gets the RESTful URL to query for information required to complete the
     * rendering of the page.
     */
    getUrl: function() {
        return hub.urls.getAdminViewTrackingPage();
    }
});
