/*
	Copyright (c) 2007-2008, IBM Corp.
*/
dojo.provide("hub.pages.social");
dojo.require("dojox.dtl.widget");
dojo.require("dojo.i18n");
dojo.requireLocalization("hub", "popups");
dojo.requireLocalization("hub", "links");
dojo.requireLocalization("hub", "panels");
dojo.requireLocalization("hub", "labels");
dojo.requireLocalization("hub", "messages");

/**
 * Report abuse page. No server data to fetch.
 */
dojo.declare("hub.pages.social.Abuse", hub.pages._Page, {
    // template to replace node with
    templatePath: dojo.moduleUrl("hub.pages", "templates/Abuse.html"),

    /**
     * Imports required modules and build an object with properties matching 
     * fields in the template.
     */
    getContext: function() {
        // @todo
    }
});


/**
 * Profile page letting the user change name, password, etc. Fetches existing
 * user information from the server.
 */
dojo.declare('hub.pages.social.Profile', hub.pages._Page, {
    // template to replace node with
    templatePath: dojo.moduleUrl("hub.pages", "templates/Profile.html"),

    /**
     * Builds an object with properties matching fields in the template. Merges
     * fetched server data with local data.
     *
     * @param server_data: JSON decoded object fetched from server URL
     */
    getContext: function(server_data) {
        // @todo
    },

    /**
     * Gets the RESTful URL to query for information required to complete the
     * rendering of the page.
     */
    getUrl: function() {
        return hub.urls.getProfilePage();
    }
});
