/*
	Copyright (c) 2007-2008, IBM Corp.
*/
dojo.provide("hub.widgets.forms.SelectPlugin");
dojo.require("dijit._Templated"); 
dojo.require("dijit._Widget"); 
// our declared class
dojo.declare("hub.widgets.forms.SelectPlugin",
        // we inherit from this class, which in turn mixes
        // in _Templated and _Layout
        [dijit._Widget, dijit._Templated ],
        // class properties:
        {
        uniqueId: 0,
        inputSelectName: "pluginid",
        inputSelectSize: 15,
        href: '/plugin/editor/source/',
		widgetsInTemplate: true,
		templatePath: dojo.moduleUrl("hub","widgets/forms/templates/SelectPlugin.html"),
		init: 0,
		type: 'Feeds',
		labels: null,
		startup: function(){
			this.inputSelect.setAttribute('size', this.inputSelectSize);
			this.inputSelect.setAttribute('name', this.inputSelectName);
	        this.panels = dojo.i18n.getLocalization('hub', 'panels');
			
			this.inherited("startup", arguments);
		},
		
		postMixInProperties: function(){
	        this.panels = dojo.i18n.getLocalization('hub', 'panels');
			this.inherited("postMixInProperties", arguments);
		},
		
		setOptions: function(response/*, ioArgs*/){
//			console.debug('SelectPlugin: SetOptions');
			response = dojo.fromJson(response);
//			console.dir(response);
//			this.domNode.innerHTML = '';
			this.inputSelect.domNode = '';
			var optGroup = null;
			var option = null;
			
			if (this.init == 1) {
				this.inputSelect.removeAll();
			}
			
			if (this.type == 'Widgets') {
				this.feedBanner.style.display='none';
				this.widgetBanner.style.display='';
			} else {
				this.feedBanner.style.display='';
				this.widgetBanner.style.display='none';
			}
			
			var msgs = dojo.i18n.getLocalization('hub', 'messages');    
			for(category in response.payload){
				//console.debug('SelectPlugin: SetOptions: Category: ' + category);
				optGroup = dojo.doc.createElement('optgroup');
				
				optGroup.setAttribute('label', category);
				var items = response.payload[category];
//				console.debug('Items length: ' + items.length);
//				console.debug('Items[0]: ' + items[0]);
				for (i = 0; i < items.length; i++) { 
					var item = items[i];
					option = dojo.doc.createElement('option');
					option.setAttribute('value', item.pluginid);
					option.innerHTML = item.name;
					optGroup.appendChild(option);
				}
				this.inputSelect.appendChild(optGroup);
			}

			this.init = 1;
//			console.debug('SelectPlugin: End of SetOptions');
		},
		
		setType: function(type) {
//			console.debug('SelectPlugin: SetType');
			this.type = type;
			this.init = 0;
	    	var req = new hub.submit.Request(hub.config.base_url + this.href + this.type);
		    req._onLoad = dojo.hitch(this, this.setOptions);
	    	if(req.submit()){
	//	    	console.dir(req.response);
	    	}
/*			
			var kw = {
				url: hub.config.base_url + this.href + this.type,//hub.urls.postInstall(action),
				sync: true,
		        handleAs: 'json',
		        timeout: 120000, // 2 minutes in milliseconds
		        
		        error: dojo.hitch(this, function(response, args) {           
		            return response;
		        }),
		        
		        load: dojo.hitch(this, this.setOptions)//dojo.hitch(this, function(response, args) {
		    };
		   
		    // do the post
		    dojo.xhrPost(kw);
*/		    
//		    console.debug('SelectPlugin: End of SetType');
		}
});