/*
	Copyright (c) 2007-2008, IBM Corp.
*/
dojo.provide("mm.CatalogModel");

dojo.require("mm.model.CatalogCategory");
dojo.require("mm.model.CatalogEntry");
dojo.require("mm.model.CatalogFeedEntry");

dojo.declare("mm.CatalogModel", null, {
	
	XML_NS: {
		atom: "http://www.w3.org/2005/Atom",
		model: "http://www.ibm.com/xmlns/prod/lotus/mashups/v1.0/model-elements",
		base: "http://www.ibm.com/xmlns/prod/lotus/mashups/v1.0/base"
	},
	
	constructor: function(/*mm.Server*/server){
		this.server = server;
	},
	
	getCategories: function(/*function*/callback){
		var url = this.server.contentHandler + "?uri=catalog:collection&rep=full";
		var _this = this;
		this.server.GET(url, {}, function(xhr){
			if (xhr.status == 200) {
				var doc = mm.utils.createDocument(xhr.responseText);
				var categories = [];
				var entries = mm.xpath.evaluateXPath("atom:entry", doc.documentElement, _this.XML_NS);
				dojo.forEach(entries, function(entry){
					categories.push(new mm.model.CatalogCategory(entry));
				});
				callback(categories);
			} else {
				callback(xhr.responseText, {
					"status": xhr.status,
					"statusText": xhr.statusText
				});
			};
		});
	},
	
	addToCatalog: function(/*mm.model.CatalogEntry*/entry, callback){
		var url = this.server.contentHandler + "?uri=catalog:collection@" + mm.utils.encodeModelID4Uri("id:" + entry.category);
		this.server.POST(url, {"Content-Type" : "application/atom+xml"}, entry.toString(), function(xhr){
			if (xhr.status == 201) {
				callback(xhr.responseText);
			} else {
				callback(xhr.responseText, {
					"status": xhr.status,
					"statusText": xhr.statusText
				});
			}
		});
	}
});
