/*
	Copyright (c) 2007-2008, IBM Corp.
*/
dojo.provide("mm.FeedViewerConfig");

dojo.require("mm.model.FeedViewer");
dojo.require("mm.xpath");
dojo.require("mm.utils");

dojo.declare("mm.FeedViewerConfig", null, {
	
	constructor: function(/*mm.MashupMaker*/server){
		this.server = server;
	},
	
	load: function(/*function*/callback){
		var url = this.server.contextRootBuilder + "/conf/feedViewers.conf";
		var _this = this;
		this.server.GET(url, {},function(xhr){
			if (xhr.status == 200) {
				var doc = mm.utils.createDocument(xhr.responseText);
				var feedviewers = [];
				var entries = mm.xpath.evaluateXPath("entry", doc.documentElement);
				dojo.forEach(entries, function(entry){
					feedviewers.push(new mm.model.FeedViewer(entry, _this.server.serverUrl + _this.server.contextRootBuilder));
				});
				callback(feedviewers);
			} else {
				callback(xhr.responseText, {
					"status": xhr.status,
					"statusText": xhr.statusText
				});
			};
		});
	}
});
