/*
	Copyright (c) 2007-2008, IBM Corp.
*/
dojo.provide("mm.IWidgetDeployer");

dojo.require("mm.utils");
dojo.require("mm.xpath");

dojo.declare("mm.IWidgetDeployer", null, {
	
	packageUrl: "", //url to package
	category: "",
	title: "",
	description: "",
	
	constructor: function(/*mm.MashupMaker*/server){
		this.server = server;
	},
	
	deploy: function(/*function*/callback){
		//invoke generator plugin to deploy
		var url = this.packageUrl;
		url = url.substring(url.indexOf("://") + 3);
		url = url.substring(url.indexOf("/"));
		dojo.xhrPost({
			url: url,
			content: {
				deploy_service_url: this.server.serverUrl + this.server.contentHandler + "?uri=deploy:widget",
				username: this.server._username,
				password: this.server._password,
				title: this.title,
				description: this.description,
				category: this.category
			},
			error: dojo.hitch(this, function(response, args){
				callback(response, {
					"status": args.xhr.status,
					"statusText": args.xhr.statusText
				})
			}),
			load: dojo.hitch(this, function(response, args){
				response = dojo.fromJson(response);
				if (response.status == 201) {
					callback(response.responseText);
				}else{
					callback(response.responseText, response);
				}
			})
		});
	}
});
