/*
	Copyright (c) 2007-2008, IBM Corp.
*/
dojo.provide("mm.IconConfig");

dojo.require("mm.model.Icon");
dojo.require("mm.utils");
dojo.require("mm.xpath");

dojo.declare("mm.IconConfig", null, {
	
	constructor: function(/*mm.MashupMaker*/server){
		this.server = server;
	},
	
	load:function(/*function*/callback){
		var url = this.server.contextRootBuilder + "/conf/icons.conf";
		var _this = this;
		this.server.GET(url, {},function(xhr){
			if (xhr.status == 200) {
				var doc = mm.utils.createDocument(xhr.responseText);
				var icons = [];
				var entries = mm.xpath.evaluateXPath("entry", doc.documentElement);
				dojo.forEach(entries, function(entry){
					icons.push(new mm.model.Icon(entry, _this.server.serverUrl + _this.server.contextRootBuilder));
				});
				callback(icons);
			} else {
				callback(xhr.responseText, {
					"status": xhr.status,
					"statusText": xhr.statusText
				});
			};
		});
	}
});
