/*
	Copyright (c) 2007-2008, IBM Corp.
*/
dojo.provide("mm.main");
dojo.require("mm.utils");
dojo.require("mm.xhr");
dojo.require("mm.xpath");
dojo.require("mm.urls");
dojo.require("mm.HttpUrl");
dojo.require("mm.MashupMaker");
dojo.require("mm.CatalogModel");
dojo.require("mm.FeedViewerConfig");
dojo.require("mm.IconConfig");
dojo.require("mm.NavigationModel");
dojo.require("mm.IWidgetDeployer");
dojo.require("mm.MashupPageDeployer");

/**
 * create "Addtomashups" link in details page
 * @param {Object} details: details page's server data.
 */
mm.createAddToMashupsLink = function(/*object*/details){
	var type;
	//type of the object
	if (details.object.isFeed) {
		type = "feed";
	} else if (details.object.isMashup) {
		type = "mashup";
	} else if (details.object.objectType == "iwidget") {
		type = "iwidget";
	} else if (details.object.objectType == "mashuppage"){
		type = "mashuppage";
	}
	
	if (!type) return false;
	
	// if is package page
	if (type == "mashuppage" && details.pluginData.definitionUrl) {
		return false;
	}
	
	var serverUrl = hub.config.palette_url ? hub.config.palette_url : mm.getDefaultMMServerUrl();
	var templateName;
	
	//the template to show
	if (!hub.config.palette_url) {
		templateName = "SelectMashupsServer";
	} else if (details.object.isFeed || details.object.isMashup) {
		templateName = "AddFeedToMashups";
	} else if (details.object.objectType == 'iwidget') {
		templateName = "AddIWidgetToMashups";
	} else if (details.object.objectType == 'mashuppage'){
		templateName = "AddMashupPageToMashups";
	};
	
	var link = 'javascript:hub.showPage("' 
				+ details.object.title + '","' 
				+ templateName 
				+ '",{"object_id": "' + details.object.id 
				+ '", "object_title": "' + details.object.title 
				+ '", "server": "' + serverUrl 
				+ '", "type": "' + type + '"})';
	return link;
};

mm.getDefaultMMServerUrl = function(){
	var path = (window.location.port == "8443") ? "/mashupmaker" : "/mum";
	var url = new mm.HttpUrl(window.location.protocol + "//" + window.location.host + path);
	return url.getHttpUrl().toString();
};
