/*
	Copyright (c) 2007-2008, IBM Corp.
*/
dojo.provide("mm.model.CatalogCategory");
dojo.require("mm.utils");
dojo.require("mm.xpath");

dojo.declare("mm.model.CatalogCategory", null, {
	XML_NS: {
		atom: "http://www.w3.org/2005/Atom",
		model: "http://www.ibm.com/xmlns/prod/lotus/mashups/v1.0/model-elements",
		base: "http://www.ibm.com/xmlns/prod/lotus/mashups/v1.0/base"
	},
	
	id: "",
	name: "",
	title: "",
	description: "",
	
	constructor: function(/*Element*/entry){
		var id = mm.xpath.evaluateXPath("atom:id", entry, this.XML_NS)[0];
		//localization
		var titles = mm.xpath.evaluateXPath("atom:content/model:catalog-category/model:title/base:nls-string", entry, this.XML_NS);
		var title = titles ? mm.utils.getLocaleElement(titles) : null;
		
		var descriptions = mm.xpath.evaluateXPath("atom:content/model:catalog-category/model:description/base:nls-string", entry, this.XML_NS);
		var description = descriptions ? mm.utils.getLocaleElement(descriptions) : null;
		
		this.id = id ? id.textContent || id.text : "";
		this.title = title ? title.textContent || title.text : "";
		this.description = description ? description.textContent || description.text : "";
		
		if (this.id.indexOf("catalog:id:") == 0) {
			this.name = this.id.substring(11);
		}
	}
});
