/*
	Copyright (c) 2007-2008, IBM Corp.
*/
dojo.provide("mm.model.CatalogEntry");

dojo.require("mm.utils");

dojo.declare("mm.model.CatalogEntry", null, {
	
	id: "catalog:cid:test",
	category: "",
	title: "",
	description: "",
	definition:"",
	icon:"",
	content:"http://www.ibm.com",
	preview:"http://www.ibm.com",
	metadata: {},
	
	constructor: function(){
		this.metadata = {
			widgetParam:[],
			onNewWire:"",
			systemWidget: false,
			visible: true
		};
	},
	
	toString: function(){
		var entry = [
	  	'<?xml version="1.0" encoding="UTF-8"?>',
		'<atom:feed xmlns:atom="http://www.w3.org/2005/Atom">',
		'<atom:title>IBM MashupMaker Catalog Feed</atom:title>',
		'<atom:id>' + mm.utils.escapeXml(this.id) + '</atom:id>',
		'<atom:updated>' + mm.utils.escapeXml(mm.utils.getTimeStamp()) + '</atom:updated>',
		'<atom:author>IBM Mashup Hub</atom:author>',
		'<atom:entry>',
		'  <atom:id>' + mm.utils.escapeXml(this.id) + '</atom:id>',
		'  <atom:category term="' + mm.utils.escapeXml(this.category) + '"/>',
		'  <atom:content xmlns:model="http://www.ibm.com/xmlns/prod/lotus/mashups/v1.0/model-elements">',
		'    <model:catalog-entry>',
		'       <model:title>',
		'         <base:nls-string xmlns:base="http://www.ibm.com/xmlns/prod/lotus/mashups/v1.0/base" xml:lang="en">' + mm.utils.escapeXml(this.title) + '</base:nls-string>',	
		'       </model:title>',
		'       <model:description>',
		'         <base:nls-string xmlns:base="http://www.ibm.com/xmlns/prod/lotus/mashups/v1.0/base" xml:lang="en">' + mm.utils.escapeXml(this.description) + '</base:nls-string>',	
		'       </model:description>',
		'       <atom:link href="' + mm.utils.escapeXml(this.definition) + '" rel="definition"/>',
		'       <atom:link href="' + mm.utils.escapeXml(this.icon) + '" rel="icon"/>',
		'       <atom:link href="' + mm.utils.escapeXml(this.content) + '" rel="content"/>',
		'       <atom:link href="' + mm.utils.escapeXml(this.preview) + '" rel="preview"/>', 
		'    </model:catalog-entry>',
		'    <model:metadata name="widgetParam">'+mm.utils.escapeXml(dojo.toJson(this.metadata.widgetParam))+'</model:metadata>',
		'    <model:metadata name="onNewWire">' + mm.utils.escapeXml(this.metadata.onNewWire) + '</model:metadata>',
		'    <model:metadata name="systemWidget">' + mm.utils.escapeXml(this.metadata.systemWidget) + '</model:metadata>',
		'    <model:metadata name="visible">' + mm.utils.escapeXml(this.metadata.visible) + '</model:metadata>',
		'  </atom:content>',
		'</atom:entry>',
		'</atom:feed>'
		].join("\n");
		return entry;
	}
});


