/*
	Copyright (c) 2007-2008, IBM Corp.
*/
dojo.provide("mm.model.FeedViewer");

dojo.require("mm.utils");

dojo.declare("mm.model.FeedViewer", null, {
	displayName: "",
	definition: "",
	icon: "",
	content: "",
	preview: "",
	feedUrlItemName: "",
	metadata: {},
	types: [],
	
	constructor: function(/*Element*/entry, /*string*/contextRoot){
		this.metadata = {};
		this.types = [];
		var displayName = mm.xpath.evaluateXPath("displayName", entry)[0];
		var definition = mm.xpath.evaluateXPath("definition", entry)[0];
		var icon = mm.xpath.evaluateXPath("icon", entry)[0];
		var content = mm.xpath.evaluateXPath("content", entry)[0];
		var preview = mm.xpath.evaluateXPath("preview", entry)[0];
		var feedUrlItemName = mm.xpath.evaluateXPath("feedUrlItemName", entry)[0];
		
        var labels = dojo.i18n.getLocalization('hub', 'labels');
		this.displayName = this._text(displayName);
        if(this.displayName == "Feed Reader"){
            this.displayName = labels.ADDTOMASHUPS_FEEDVIEWER_FEEDREADER;
        }
        if(this.displayName == "Data Viewer"){
            this.displayName = labels.ADDTOMASHUPS_FEEDVIEWER_DATAVIEWER;
        }
		this.definition = contextRoot + this._text(definition);
		this.definition = this._applyContextRoot(this.definition, contextRoot);
		this.icon = this._text(icon);
		this.icon = this._applyContextRoot(this.icon, contextRoot);
		this.content = this._text(content);
		this.content = this._applyContextRoot(this.content, contextRoot);
		this.preview = this._text(preview);
		this.preview = this._applyContextRoot(this.preview, contextRoot);
		this.feedUrlItemName = this._text(feedUrlItemName);
		
		var metadatas = mm.xpath.evaluateXPath("metadata", entry);
		for(var i=0;i<metadatas.length;i++){
			var metadata = metadatas[i];
			this.metadata[metadata.getAttribute("name")] = this._text(metadata);
		}
		
		if(this.metadata.widgetParam){
			this.metadata.widgetParam = dojo.fromJson(this.metadata.widgetParam);
		}
		
		var types = mm.xpath.evaluateXPath("type", entry);
		for(var i=0;i<types.length;i++){
			var type = types[i];
			this.types.push(this._text(type));
		}
	},
	
	_text: function(/*Element*/element){
		var text = element ? element.textContent || element.text : "";
		return text ? text : "";
	},
	
	_applyContextRoot: function(url, contextRoot){
		if((url.indexOf("http://") != 0) && (url.indexOf("https://") != 0) && contextRoot){
			return contextRoot + url; 
		}else{
			return url;
		}
	}
});
