/*
	Copyright (c) 2007-2008, IBM Corp.
*/
dojo.provide("mm.model.NavigationNode");
dojo.require("mm.utils");
dojo.require("mm.xpath");

dojo.declare("mm.model.NavigationNode", null, {
	XML_NS: {
		atom: "http://www.w3.org/2005/Atom",
		nm: "http://www.ibm.com/xmlns/prod/lotus/remix/v1.0/navigation-model",
		xhtml: "http://www.w3.org/1999/xhtml",
		thr: "http://purl.org/syndication/thread/1.0",
		app: "http://www.w3.org/2007/app",
		model: "http://www.ibm.com/xmlns/prod/lotus/mashups/v1.0/model-elements",
		base: "http://www.ibm.com/xmlns/prod/lotus/mashups/v1.0/base"
	},
	id: "",
	title: "",
	type: "stub",	// stub: not loaded; node: loaded; root: root(for query)
	parentId: "",
	
	constructor: function(/*Element*/entry, /*string*/rootId) {
		var idNode = mm.xpath.evaluateXPath("atom:id", entry, this.XML_NS)[0];
		this.id = idNode ? idNode.textContent || idNode.text : "";
		this.id = this.parseId(this.id);
		
		var titles = mm.xpath.evaluateXPath("atom:content/model:navigation-node/model:title/base:nls-string", entry, this.XML_NS);
		var title = titles ? mm.utils.getLocaleElement(titles) : null;
		if (title === null) {
			title = mm.xpath.evaluateXPath("atom:title", entry, this.XML_NS)[0];
		}
		this.title = title ? title.textContent || title.text : "";
		
		var countNode = mm.xpath.evaluateXPath("atom:link/@thr:count", entry, this.XML_NS)[0];
		if (countNode) {
			var hasChild = countNode.nodeValue > 1;
			if (!hasChild) {
				this.type = "node";
			} else {
				this.children = [];
			}
		}
		
		var parentNode = mm.xpath.evaluateXPath("thr:in-reply-to/@ref", entry, this.XML_NS)[0];
		if (parentNode) {
			var parentStr = parentNode.nodeValue;
			if (parentStr) {
				this.parentId = this.parseId(parentStr);
			} else {
				this.type = "root";
				this.title = "";
			}
		} else {
			this.type = "root";
			this.title = "";
		}
	},
	
	addChild: function(navigationNode) {
		if (navigationNode && navigationNode.id && navigationNode.title) {
			this.children.push(navigationNode);
		}
	},
	
	parseId: function(/*string*/id) {
		// get rid of "nm:oid:"
		if (dojo.isString(id) && id.indexOf("nm:oid:") == 0) {
			return id.substring(7);
		}
        if (dojo.isString(id) && id.indexOf("nm:id:") == 0) {
			return id.substring(6);
		}
		return id;
	}
});
