/*
	Copyright (c) 2007-2008, IBM Corp.
*/
dojo.provide("mm.pages.FinishedAddToMashups");

dojo.require("hub.main");
dojo.require("hub.pages");

dojo.declare("mm.pages.FinishedAddToMashups", hub.pages._Page, {
	// template to replace node with
	templatePath: dojo.moduleUrl("mm.pages", "templates/FinishedAddToMashups.html"),
	
	object_title: "",
	object_id: "",
	type: "",
	
	// Page
	navigationPath: [],
	
	
	/**
	 * Builds an object with properties matching fields in the template. Merges
	 * fetched server data with local data.
	 *
	 * @param server_data: JSON decoded object fetched from server URL
	 */
	getContext: function(server_data){
		var panels = dojo.i18n.getLocalization('hub', 'panels');
		var obj = {
			object_id: this.object_id,
			object_title: this.object_title,
			title: dojo.string.substitute(panels.ADD_TO_MASHUPS_LANDING_TITLE, [this.object_title]),
			subtitle: dojo.string.substitute(panels.ADD_TO_MASHUPS_LANDING_SUBTITLE, [this.object_title]),
			navigation_path: this.navigationPath.join(" > "),
			taskDetails: dojo.string.substitute(panels.LANDING_TASK_DETAILS, [this.type]),
			//page
			isFeed: this.type == "feed",
			isWidget: this.type == "iwidget",
			isPage: this.type == "mashuppage",
			isMashup: this.type == "mashup",
			// messages
			labels: dojo.i18n.getLocalization('hub', 'labels'),
			messages: dojo.i18n.getLocalization('hub', 'messages'),
			panels: panels,
			//icons
			icon_feed: hub.urls.getImage('feedLarge.gif'),
			icon_widget: hub.urls.getImage('widgetLarge.gif'),
			icon_page: hub.urls.getImage('pageLarge.gif'),
			icon_mashup: hub.urls.getImage('mashupLarge.gif')
		};
		return obj;
	}
});
