/*
	Copyright (c) 2007-2008, IBM Corp.
*/
dojo.provide("mm.utils");

mm.utils.encodeModelID4Uri = function(uri){
    // encode uri part correctly
    var pos = uri.indexOf(":");
    if (pos!=-1) {
        var start = uri.slice(0,pos+1);
        var end = uri.slice(pos+1);
        uri = start+encodeURIComponent(end);
    }
    uri = encodeURIComponent(uri);
    return uri;
};

mm.utils.getDefaultMMServerUrl = function(){
	var path = (window.location.port == "8443") ? "/mashupmaker" : "/mum"; 
	return window.location.protocol + "//" + window.location.host + path;
};

// converse String - > XMLDOM
mm.utils.createDocument = function (/*String*/response){
	if(window.ActiveXObject){
		var xmlDom=new ActiveXObject("Microsoft.XMLDOM");
		xmlDom.loadXML(response);
		return xmlDom;
	}else return new DOMParser().parseFromString(response, "text/xml");
};
mm.utils.getTimeStamp = function(/*Date*/time){
	if(!time)time = new Date();
	var timezone = time.getTimezoneOffset() / 60;
	return [time.getFullYear(), "-", time.getMonth(), "-", time.getDay(), "T", time.getHours(), ":", time.getMinutes(), ":", time.getSeconds(), timezone, ":00"].join("");
};
// escape  Xml
mm.utils.escapeXml = function(/*String*/str) {
	if(typeof str == "undefined")return "";
	return str.toString().replace(/&/gm, "&amp;")
			.replace(/</gm, "&lt;")
			.replace(/>/gm, "&gt;")
			.replace(/"/gm, "&quot;")
			.replace(/'/gm, "&#39;")
			.replace(/\[/gm, "&#91;")
			.replace(/\]/gm, "&#93;");
};

// get locale message	
mm.utils.getLocaleElement = function(/*Element[]*/elements){
	var locale = dojo.locale.toLowerCase().replace("-", "_");
    var country = (locale.indexOf("_") > 0) ? locale.split("_")[0] : locale;
	var result = null;
    var en_result = null;//by default, return english
    var first_result = null;//first result
	for(var i=0;i<elements.length;i++){
		var lang = elements[i].getAttribute("xml:lang");
		if(lang == locale){
			result = elements[i];
			break;
		}else if(lang == country && !result){
            result = elements[i];
        }else if(lang == "en"){
			en_result = elements[i];
		}else if(i === 0){
			first_result = elements[i];
		}
	}
	return result || (en_result || first_result);
};

mm.utils.summary = function(/*string*/str, /*number*/len){
// summary:
//	Truncates 'str' after 'len' characters and appends periods as necessary so that it ends with "..."

	if(!len || str.length <= len){
		return str; // string
	}

	return str.substring(0, len).replace(/\.+$/, "") + "..."; // string
}