<!--  Licensed Materials - Property of IBM 5724-V06 Copyright IBM Corp. 2008  All Rights Reserved. -->
<%@page import="com.ibm.mashuphub.plugin.ldap.LDAPViewBean, com.ibm.mashuphub.model.table.ParametersTable, java.util.*" %>
<%
LDAPViewBean viewBean = new LDAPViewBean();
LDAPViewBean ldapViewBean = (LDAPViewBean) viewBean.getViewBeanFromRequest(request);
ResourceBundle i18n = ResourceBundle.getBundle(ldapViewBean.getI18NProperties(), request.getLocale());
String objectId = ldapViewBean.getEntry().getObjectId();
List<Map<String, String>> list = (new ParametersTable()).getAllParameters(objectId);

// Display each parameter for this object
for (int i=0; i<list.size(); i++) {
	Map<String, String> map = list.get(i);
	
	// Display asterisk if required
	String required = "";
	if (com.ibm.mashuphub.model.dataobject.Parameter.FALSE.equals(map.get(ParametersTable.OPTIONAL_COLUMN))) {
		required = "<span class='required'>*</span>";
	}
	
	// Check prompt checkbox?
	String checked = "";
	if (com.ibm.mashuphub.model.dataobject.Parameter.TRUE.equals(map.get(ParametersTable.PROMPT_COLUMN))) {
		checked = "CHECKED";
	}
	
	// Read default value
	String value = "";
	if (map.get(ParametersTable.DEFAULTVALUE_COLUMN) != null) {
		value = map.get(ParametersTable.DEFAULTVALUE_COLUMN);
	}
	
	// Check for password type
	String type = "TEXT";
	String checkDisabled = "";
	if ("password".equalsIgnoreCase(map.get(ParametersTable.PARAMETERTYPE_COLUMN))) {
		type = "PASSWORD";
		checked = "";
		checkDisabled = "disabled";
	}			
%>
<br/>
<label for='parm<%=i%>'><%=required%><%=map.get(ParametersTable.DISPLAYNAME_COLUMN)%></label>
<div class="rightCol">
<input id='<%=map.get(ParametersTable.PARAMETERNAME_COLUMN)%>' name='parm<%=i%>' value='<%=value%>' maxlength='2048' type=<%=type%> title="<%=map.get(ParametersTable.HELPTEXT_COLUMN)%>" />
<input name='prompt<%=i%>' type=CHECKBOX title='<%=i18n.getString("form.checkbox.prompt")%>' <%=checked%> <%=checkDisabled%> />
</div>
<% } %>
<br/><br/>

<script type='text/javascript'>

// Add condition
function addCondition(divId) {
    var topRoot = document.getElementById(divId);
    var nextFreeInt = document.getElementById('nextFreeInt');
    var num = parseInt(nextFreeInt.value);

    var newDiv = document.createElement('div');
    newDiv.setAttribute('id', 'sDiv' + num);
    newDiv.innerHTML =
        '<br/>\n' +
        '<%=i18n.getString("filter.helper.label.field")%> <input id="field' + num + '" value=\'sn\' maxlength=\'2048\' type=TEXT/>\n' +
        '\n' +
        '<select onchange="document.getElementById(\'field' + num + '\').value=this.value">\n' +
        '<option value ="sn"><%=i18n.getString("ldap.example.sn")%></option>\n' +
        '<option value ="dn"><%=i18n.getString("ldap.example.dn")%></option>\n' +
        '<option value ="cn"><%=i18n.getString("ldap.example.cn")%></option>\n' +
        '<option value ="c"><%=i18n.getString("ldap.example.c")%></option>\n' +
        '<option value ="ou"><%=i18n.getString("ldap.example.ou")%></option>\n' +
        '<option value ="name"><%=i18n.getString("ldap.example.name")%></option>\n' +
        '<option value ="company"><%=i18n.getString("ldap.example.company")%></option>\n' +
        '<option value ="dept"><%=i18n.getString("ldap.example.dept")%></option>\n' +
        '<option value ="department"><%=i18n.getString("ldap.example.department")%></option>\n' +
        '<option value ="description"><%=i18n.getString("ldap.example.description")%></option>\n' +
        '<option value ="phone"><%=i18n.getString("ldap.example.phone")%></option>\n' +
        '<option value ="telephone"><%=i18n.getString("ldap.example.telephone")%></option>\n' +
        '<option value ="homephone"><%=i18n.getString("ldap.example.homephone")%></option>\n' +
        '<option value ="email"><%=i18n.getString("ldap.example.email")%></option>\n' +
        '<option value ="mail"><%=i18n.getString("ldap.example.mail")%></option>\n' +
        '<option value ="emailAddress"><%=i18n.getString("ldap.example.emailAddress")%></option>\n' +
        '</select>\n' +
        '\n' +
        '<select id="operation' + num + '">\n' +
        '<option value ="start"><%=i18n.getString("filter.helper.operation.startswith")%></option>\n' +
        '<option value ="contain"><%=i18n.getString("filter.helper.operation.contains")%></option>\n' +
        '<option value ="end"><%=i18n.getString("filter.helper.operation.endswith")%></option>\n' +
        '</select>\n' +
        '\n' +
        '<input id="val' + num + '" maxlength="2048" type=TEXT/>\n' +
        '\n' +
        '<input onclick="removeElement(\'sDiv' + num + '\');" value="<%=i18n.getString("form.button.removecondition")%>" type=BUTTON>\n';

    topRoot.appendChild(newDiv);
    nextFreeInt.value = num + 1;  // Increment value in hidden field for next time
    
    // Increment param count
    var paramCount = document.getElementById('paramCount');
    var count = parseInt(paramCount.value);
    paramCount.value = count + 1;
}

// Calculate
function calc(divId) {

    // Read values
    var num = parseInt(document.getElementById('nextFreeInt').value);
    var count = parseInt(document.getElementById('paramCount').value);

    // Handle empty conditions
    if (count < 1) {
        document.getElementById('workingCopy').value = '';
        return;
    }

    // Build up a string
    var s = '';
    for (var i=0; i<num; i++) {

        // Read values
        if (document.getElementById('field' + i) != null) {
	        field = document.getElementById('field' + i).value;
	        operation = document.getElementById('operation' + i).value;
	        val = document.getElementById('val' + i).value;
	
	        // Starting wildcard
	        startWild = '*';
	        if (operation == 'start') {
	            startWild = '';
	        }
	
	        // Ending wildcard
	        endWild = '*';
	        if (operation == 'end') {
	            endWild = '';
	        }
	
	        // Append this node to string
	        s = s + '(' + field + '=' + startWild + val + endWild + ')';
	    }
    }

    // Finish string with operation if more than one
    if (count > 1) {
        s = '(' + document.getElementById('op').value + s + ')';
    }

    // Fill into working copy field
    document.getElementById('workingCopy').value = s;
}

// Clear helper fields
function clearFields() {
    if (!confirm("<%=i18n.getString("form.clear.confirm")%>")) {
        return;
    }

    document.getElementById('workingCopy').value = '';
    document.getElementById('nextFreeInt').value = '0';
    document.getElementById('paramCount').value = '0';
    removeChildrenFromNode(document.getElementById('topRoot'));
}

// Remove element
function removeElement(divId) {
    var t = document.getElementById(divId);
    t.parentNode.removeChild(t);
    
    // Decrement param count
    var paramCount = document.getElementById('paramCount');
    var count = parseInt(paramCount.value);
    paramCount.value = count - 1;
}

// Remove children nodes
function removeChildrenFromNode(node) {
    if (node == null) {
        return;
    }

    var len = node.childNodes.length;
    while (node.hasChildNodes()) {
        node.removeChild(node.firstChild);
    }
}
</script>
<fieldset>
<legend><%=i18n.getString("filter.helper.title")%></legend>
<%=i18n.getString("filter.helper.workingcopy")%>
<input id='workingCopy' name='' value='' type=TEXT maxlength='2048' >
<input onclick="calc('topRoot');" value='<%=i18n.getString("form.button.recalculate")%>' type=BUTTON>
<input onclick="document.getElementById('ldapSearchFilter').value=document.getElementById('workingCopy').value" value='<%=i18n.getString("form.button.copyup")%>' type=BUTTON>
<input onclick="clearFields();" value='<%=i18n.getString("form.button.clear")%>' type=BUTTON>
<br/><br/>

<select id='op'>
  <option value ="&"><%=i18n.getString("filter.helper.choice.all")%></option>
  <option value ="|"><%=i18n.getString("filter.helper.choice.any")%></option>
</select><%=i18n.getString("filter.helper.choice.text")%>
<br/>
<input onclick="addCondition('topRoot');" value='<%=i18n.getString("form.button.addcondition")%>' type=BUTTON />
<div id='topRoot'>
</div>

<input type=HIDDEN value='0' id='nextFreeInt' />
<input type=HIDDEN value='0' id='paramCount' />
</fieldset>