<!--  Licensed Materials - Property of IBM 5724-V06 Copyright IBM Corp. 2008  All Rights Reserved. -->
<%@page import="com.ibm.mashuphub.plugin.sap.SAPViewBean, com.ibm.mashuphub.model.table.ParametersTable, java.util.*" %>
<%
SAPViewBean viewBean = new SAPViewBean();
SAPViewBean sapViewBean = (SAPViewBean) viewBean.getViewBeanFromRequest(request);
ResourceBundle i18n = ResourceBundle.getBundle(sapViewBean.getI18NProperties(), request.getLocale());
String objectId = sapViewBean.getEntry().getObjectId();
List<Map<String, String>> list = (new ParametersTable()).getAllParameters(objectId);
%>
<script type='text/javascript'>

// Add parameter
function addParam() {
  var newParams = document.getElementById('newParams');
  var nextParam = document.getElementById('nextParam');
  
  // Increment nextParam
  var num = parseInt(nextParam.value) + 1;
  nextParam.value = num;

  var newDiv = document.createElement('div');
  var divId = 'sDiv' + num;
  newDiv.setAttribute('id', divId);
  newDiv.innerHTML =
	'<br/>\n' +
	'<label for=\'sName' + num + '\'><%=i18n.getString("form.rfc.param.name")%></label>\n' +
	'<div class=\'rightCol\'>\n' +
	'<input name=\'sName' + num + '\' maxlength=\'2048\' type=TEXT title=\'<%=i18n.getString("form.rfc.param.name.infopop")%>\' />\n' +
	'<input name=\'prompt' + num + '\' type=CHECKBOX title=\'<%=i18n.getString("form.checkbox.prompt")%>\' />\n' +
	'</div>\n' +
	'<label for=\'parm' + num + '\'><%=i18n.getString("form.rfc.param.value")%></label>\n' +
	'<div class=\'rightCol\'>\n' +
	'<input name=\'parm' + num + '\' maxlength=\'2048\' type=TEXT title=\'<%=i18n.getString("form.rfc.param.value.infopop")%>\' /> &nbsp; \n' +
	'<input type=BUTTON onclick="removeElement(\'' + divId + '\');" value=\'<%=i18n.getString("form.button.removeparam")%>\' />\n' +
	'</div>\n';
  newParams.appendChild(newDiv);
}

// Remove element
function removeElement(divId) {
  var t = document.getElementById(divId);
  t.parentNode.removeChild(t);
}
</script>
<%
// Holder for SAP params
Hashtable<String, Map<String, String>> sapList = new Hashtable<String, Map<String, String>>();

// Display each parameter for this object
for (int i=0; i<list.size(); i++) {
	Map<String, String> map = list.get(i);
	
	// Check for SAP param
	if (map.get(ParametersTable.PARAMETERNAME_COLUMN).startsWith("sap")) {
		sapList.put(Integer.toString(i), map);
	} else {
	
		// Display asterisk if required
		String required = "";
		if (com.ibm.mashuphub.model.dataobject.Parameter.FALSE.equals(map.get(ParametersTable.OPTIONAL_COLUMN))) {
			required = "<span class='required'>*</span>";
		}
		
		// Check prompt checkbox?
		String checked = "";
		if (com.ibm.mashuphub.model.dataobject.Parameter.TRUE.equals(map.get(ParametersTable.PROMPT_COLUMN))) {
			checked = "CHECKED";
		}
		
		// Read default value
		String value = "";
		if (map.get(ParametersTable.DEFAULTVALUE_COLUMN) != null) {
			value = map.get(ParametersTable.DEFAULTVALUE_COLUMN);
		}
		
		// Check for password type
		String type = "TEXT";
		String checkDisabled = "";
		if ("password".equalsIgnoreCase(map.get(ParametersTable.PARAMETERTYPE_COLUMN))) {
			type = "PASSWORD";
			checked = "";
			checkDisabled = "disabled";
		}
%>
<br/>
<label for='parm<%=i%>'><%=required%><%=map.get(ParametersTable.DISPLAYNAME_COLUMN)%></label>
<div class="rightCol">
<input name='parm<%=i%>' value='<%=value%>' maxlength='2048' type=<%=type%> title="<%=map.get(ParametersTable.HELPTEXT_COLUMN)%>" />
<input name='prompt<%=i%>' type=CHECKBOX title='<%=i18n.getString("form.checkbox.prompt")%>' <%=checked%> <%=checkDisabled%> />
</div>
<%
	}
}
%>
<input type=HIDDEN value='<%=list.size()%>' id='nextParam' />
<div id="newParams">
<%
// Display each SAP param
Enumeration<String> keys = sapList.keys();
while (keys.hasMoreElements()) {
	String count = (String) keys.nextElement();
	Map<String, String> map = sapList.get(count);
	
	// Check prompt checkbox?
	String checked = "";
	if (com.ibm.mashuphub.model.dataobject.Parameter.TRUE.equals(map.get(ParametersTable.PROMPT_COLUMN))) {
		checked = "CHECKED";
	}
	
	// Read default value
	String value = "";
	if (map.get(ParametersTable.DEFAULTVALUE_COLUMN) != null) {
		value = map.get(ParametersTable.DEFAULTVALUE_COLUMN);
	}
	
	// Trim "sap" from param name
	String paramName = map.get(ParametersTable.PARAMETERNAME_COLUMN).substring("sap".length());
	
%>
<div id='sDiv<%=count%>'>
<br/>
<label for='sName<%=count%>'><%=paramName%></label>
<div class='rightCol'>
<input name='sName<%=count%>' value='<%=paramName%>' maxlength='2048' type=TEXT title='<%=i18n.getString("form.rfc.param.name.infopop")%>' />
<input name='prompt<%=count%>' type=CHECKBOX title='<%=i18n.getString("form.checkbox.prompt")%>' <%=checked%> />
</div>
<label for='parm<%=count%>'><%=i18n.getString("form.rfc.param.value")%></label>
<div class='rightCol'>
<input name='parm<%=count%>' value='<%=value%>' maxlength='2048' type=TEXT title='<%=i18n.getString("form.rfc.param.value.infopop")%>' /> &nbsp;
<input type=BUTTON onclick="removeElement('sDiv<%=count%>');" value='<%=i18n.getString("form.button.removeparam")%>' />
</div>
</div>
<%
}
%>
</div>
<input type=BUTTON onclick='addParam();' value='<%=i18n.getString("form.button.addparam")%>' />