<%-- Copyright IBM Corp. 2008  All Rights Reserved.                    --%>
<%!
private static Object configService;
private static Class configConstantsClass;
private static Class configServiceClass;
private static java.lang.reflect.Method getPrefValueMethod;
static{
	try{
		configServiceClass = Class.forName( "com.ibm.mm.ConfigService" );
		configConstantsClass = Class.forName("com.ibm.mm.ConfigConstants");
		getPrefValueMethod = configServiceClass.getMethod("getPreferenceValue", new Class[] {String.class, String.class});
		configService = configServiceClass.getMethod("getInstance", new Class[0] ).invoke( null, new Object[0] );
	}catch( Throwable t ){
	}
}
String getConfigServiceValue(String key, String defaultValue){
	if ( configService == null ){
		return defaultValue;
	}
	try{
		return (String)getPrefValueMethod.invoke( configService, new Object[] {key, defaultValue} );
	}catch( Throwable t ){
		return defaultValue;
	}
}

String getConfigConstants( String field ){
	if ( configServiceClass == null ){
		return field;
	}
	try{
		return (String)configConstantsClass.getDeclaredField( field ).get( null );
	}catch(Throwable t){
		return field;
	}
}

%>

<%
java.util.ResourceBundle bundle=java.util.ResourceBundle.getBundle("resources.bootstrap",request.getLocale());
String enablerContext = getConfigServiceValue( getConfigConstants("CONTEXT_ROOT_ENABLER"), "/mashupmaker"); 
String builderContext = getConfigServiceValue( getConfigConstants("CONTEXT_ROOT_BUILDER"), "/mm");
String themeContext = getConfigServiceValue( getConfigConstants("CONTEXT_ROOT_THEME_TEMP"), "/themes");
String mainContext = getConfigServiceValue( getConfigConstants("CONTEXT_ROOT_MAIN"), "/mm.webapp");
String hubUrl = "/mashuphub";
String currentLocale=request.getLocale().toString().replace('_', '-').toLowerCase();
%>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html lang="en">
<head>
	<title><%=bundle.getString("login.title")%></title><%--
    <link rel="shortcut icon" href="<%=builderContext%>/images/favicon.ico" type="image/x-icon">
    <link rel="icon" href="<%=builderContext%>/images/favicon.ico" type="image/x-icon">--%> 			
	<link rel="stylesheet" href="<%=builderContext%>/_combined.css" type="text/css">
	<link rel="stylesheet" href="<%=enablerContext%>/js/bluedojo/dijit/themes/tundra/tundra.css" type="text/css"><%
	if(currentLocale.startsWith("zh-tw")||currentLocale.startsWith("ja")||currentLocale.startsWith("ko")){%>
	<link rel="stylesheet" href="<%=builderContext%>/dbcs.css" type="text/css">
	<%}%>
	<script language="JavaScript" type="text/javascript">
		var _href  = window.location.href;
		if(_href.indexOf("?pid=")>0){
			var _newLocation = _href.replace("?pid=", "#pid=")
			location = _newLocation
		}
		if(_href.indexOf("&pid=")>0){
			var pid = '<%=request.getParameter("pid")%>'
			var _newLocation = _href.replace("&pid=" + pid, "")
			location = _newLocation + "#pid=" + pid
		}
		ibmConfig = {
			sessionId: "<%=request.getRequestedSessionId()%>",		
			isDebug: false,
			allowPublishLogging:true,
			allowPublishTracing:false,
			portalURI: "<%=enablerContext%>/enabler",
            proxyURL: "<%=mainContext%>/proxy/",
            contextRoot: "<%=mainContext%>",
            contextRootThemeTemp: "<%=themeContext%>",
            contextRootEnabler: "<%=enablerContext%>",
            contextRootBuilder: "<%=builderContext%>",
            hubURL: "<%=hubUrl%>",
            TUNNELMODE: <%=getConfigServiceValue( getConfigConstants("TUNNEL_MODE"), "false")%>,
			pageSourceReadOnly:true,
			defaultThemeId: "defaultTheme",
			autoAcceptSharedGroupName: "default",
            locale:"<%=currentLocale%>",
            loadServices:false,
            availableLocales:"<%=getConfigServiceValue( getConfigConstants("AVAILABLE_LOCALES"), "de,en,es,fr,it,ja,ko,pt-br,zh,zh-tw,ROOT")%>"
		};
        djConfig={isDebug:false,popup:false,locale:ibmConfig.locale};
	</script>
	<script type="text/javascript" src='<%=enablerContext%>/js/bluedojo/dojo/dojo.js'></script> 
   	<script language="JavaScript" type="text/javascript">
		dojo.registerModulePath("com.ibm.enabler","<%=enablerContext%>/js/com/ibm/enabler")
        dojo.registerModulePath("com.ibm.mm.builder","<%=builderContext%>/js/com/ibm/mm/builder")
		dojo.registerModulePath("com.ibm.mm.transform","<%=builderContext%>/js/com/ibm/mm/transform")
		dojo.registerModulePath("com.ibm.mm.catalog","<%=builderContext%>/js/com/ibm/mm/catalog")
	</script>
	<script type="text/javascript" src="<%=enablerContext%>/js/com/ibm/enabler/enabler.js"></script>
	<script type="text/javascript" src="<%=enablerContext%>/js/semtag/semanticTagService.js"></script>
	<script type="text/javascript" src="<%=enablerContext%>/js/tagservices/tagservice.js"></script>
		<script language="JavaScript" type="text/javascript">
		dojo.require("com.ibm.mm.builder.builderpre");
	</script>
	<script type="text/javascript" src="<%=builderContext%>/js/com/ibm/mm/builder/builder.js"></script>
	<script language="JavaScript" type="text/javascript">
		dojo.require("com.ibm.mm.builder.main");
		mainPage=new com.ibm.mm.builder.KickerPage()
		dojo.addOnLoad(function(){
			mainPage.locale = '<%=request.getLocale()%>'
			mainPage.initPage()
		});
	</script>
</head>
<body class="tundra"></body>
</html>
