/* Copyright IBM Corp. 2008  All Rights Reserved.                    */
/**
 * This is the JS file semantic tagging with people
 */
	dojo.require("com.ibm.enabler.utilities");
    dojo.require("com.ibm.enabler.debug");
    dojo.require("com.ibm.enabler.aggregation.javascript");


       
var SemTagFragment = {

	init: function () {
		// SemTagSvc.setCallback('hcard',SemTagPeron.hcardsAdded);
		// SemTagSvc.setCallback('mailto',SemTagPerson.mailtosAdded);
		// SemTagPerson.processHcards(SemTagSvc.getNodes('hcard'));
		// SemTagPerson.processMailtos(SemTagSvc.getNodes('mailto'));

		SemTagSvc.setCallback("fragment", SemTagFragment.fragmentsAdded);
		SemTagFragment.processFragments(SemTagSvc.getNodes('fragment'));

		// SemTagSvc.watchEvent(window, 'load', SemTagPerson.clearInternalData, false);
	},

	clearInternalData: function() {
		var leids = SemTagPerson.activeElems;
		while (0 < leids.length) {
			leids.pop();
		}
	},
	processFragments: function(fragments) {
        com.ibm.enabler.debug.entry("semanticTagFragment.processFragments","fragments length:"+fragments.length);
		if (!fragments || fragments.length==0) return;
//		var startTime = new Date().getTime(); //HMperf
		for (var i=0; i<fragments.length; i++) {
			var fragment = fragments[i];
            com.ibm.enabler.debug.log("semanticTagFragment.processFragments","fragment:"+fragment.getAttribute("widget"));

            var status = fragment.getAttribute("loaded");
			if (!status )
            {
                var widget = fragment.getAttribute("widget");
                if (widget && (widget=="fragment" || widget=="gadget"||widget=="feed")) {
                    SemTagFragment._loadFragment(fragment);
                }
                else{
                    com.ibm.enabler.debug.log("semanticTagFragment.processFragments","fragment:process IWidget");

                    var iWidget = iWidgetContainer.createWidget(fragment);
                    if(iWidget) iWidgetContainer.renderWidget(iWidget);
                }
            }
		}
	},
	fragmentsAdded: function() {
        com.ibm.enabler.debug.entry("semanticTagFragment.fragmentsAdded");

		SemTagFragment.processFragments(SemTagSvc.getNodes('fragment'));
	},
	clearFragment: function(/*DOMElement*/node) {
		if (node.hasAttribute("widgetStatus"))
			node.removeAttribute("widgetStatus");
		
		node.innerHTML = node.getAttribute("oldContent");
		
		node.removeAttribute("oldContent");
	},
	_loadFragment: function(/*DOMElement*/widgetSpan) {
		if (widgetSpan.hasAttribute("widgetStatus"))
			return;
		
		widgetSpan.setAttribute("widgetStatus", "loading");
			
		var request;
		try {
            request = dojo._xhrObj();   
		} catch(e) {
			 com.ibm.enabler.debug.error("sementicTagFragment._loadFragment","error getting request: " + e);
		}
		
		try {

		request.onreadystatechange = function() {
			if (request.readyState == 4 & request.status == 200) {
				this._displayWidget(widgetSpan, request);
			}
		}
		} catch(e) {    
            com.ibm.enabler.debug.error("sementicTagFragment._loadFragment","error: " + e);
		}

		var contentURL = widgetSpan.getAttribute("contentURL");
		var widget = widgetSpan.getAttribute("widget");
		// first get the type of the fragment and generate the url regarding of the selected 
		if (widget == 'fragment') {
			if (contentURL.indexOf("http") == 0)
				contentURL = com.ibm.enabler.utilities.rewriteURL(contentURL);
			else
				contentURL = "/mum/mycontenthandler?uri=" + url;
		}
		else if (widget == 'feed')
			contentURL = "/mum/feedreader?url=" + escape(contentURL)+"&title=DummyTitle";
		else if (widget == 'gadget')
			contentURL = "/mum/gadgethandler?url=" + escape(contentURL);
		
		request.open('GET', contentURL, true);
		request.send('');
		
	},
	_jsHandler: com.ibm.enabler.aggregation.javascript.JAVASCRIPT_HANDLER,
	_displayWidget: function(/*DOMElement*/ container, /*XPR*/ portletRequest) {
		container.setAttribute("widgetStatus", "loaded");
		container.setAttribute("oldContent", container.innerHTML); // todo: add an hidden child would be better !!!
		container.innerHTML = portletRequest.responseText;
		
		var scriptElems = container.getElementsByTagName( "script" );
		if ( scriptElems != null ) {
			// iterate over script elements and attach an id attribute
			for ( var i = 0; i < scriptElems.length; i++ ) {
				var scriptElem = scriptElems[i];
				// include an id if there is none so far
				// (needed to lookup script in original DOM later on)
				var id = scriptElem.getAttribute( "id" );
				if (id == null || id == "" ) {
					scriptElem.setAttribute( "id", "_scr#" + i );
				}
			}
		}
			
		// execute the scripts
		if ( scriptElems != null ) {
			for ( var i = 0; i < scriptElems.length; i++ ) {
				this._jsHandler.handle( scriptElems[i] );
			}
		}	
	}
}

SemTagFragment.init();
