/* Copyright IBM Corp. 2008  All Rights Reserved.                    */
/**
 * This is the JS file semantic tagging with people
 */
dojo.require("com.ibm.enabler.utilities");
dojo.require("com.ibm.enabler.debug");
dojo.require("com.ibm.enabler.aggregation.javascript");    
dojo.require("dojox.uuid.Uuid"); 
dojo.require("dojox.uuid.generateTimeBasedUuid");


       
var SemTagPopup = {

	init: function () {
		
		SemTagSvc.setCallback("popup", SemTagPopup.popupsAdded);
		SemTagPopup.processPopups(SemTagSvc.getNodes('popup'));

        SemTagSvc.watchEvent(window, 'load', SemTagPopup.clearInternalData, false);
	},

	clearInternalData: function() {

	},
	processPopups: function(popups) {
        com.ibm.enabler.debug.entry("SemanticTagPopup.processPopups",popups.length);
		if (!popups || popups.length==0) return;
//		var startTime = new Date().getTime(); //HMperf
		for (var i=0; i<popups.length; i++) {
			var popup = popups[i];
			// For all the popups create an underline TODO and onHover popup functionality
			SemTagUtil.setNodeClassValue(popup, "clickable");
            SemTagSvc.watchEvent(popup, 'click', SemTagPopup.showPopup, false);   
		}
	},
	popupsAdded: function() {
		SemTagPopup.processPopups(SemTagSvc.getNodes('popup'));
	},
	/*showHover: function(event) {
		if (SemTagSvc.trace) SemTagUtil.log("Popup.showHover");
		//var insideInline = SemTagUtil.getHcardAttributeValue("X-person-inside-inline", SemTagSvc.getLiveElementFromEvent(event));
		//var label = insideInline? null: "Click for details";
		var label = "Popup Markup";
		SemTagSvc.showHover(event, SemTagPopup.showMenu, label);
		return false;
	},*/

	/*showMenu: function(event) {
		var elem = SemTagSvc.getLiveElementFromEvent(event);
		
		SemTagPopup.showPopup(event);
		//alert("test");
		return false;
	},*/

	showPopup: function (event) {
		var oPop = document.getElementById("VEPopUp"); 
		var oPoint; 
		if (oPop == null) { 
			// create a popUp object for the first time 
			oPop = document.createElement("div"); 
			oPop.id= "VEPopUp";
            oPop.className = "VEPopUp";
			oPop.style.position = "absolute"; 
            //oPop.style.width = "100%"; 
			var htm = "<img src='js/semtag/ui/point.gif' style='position:relative;display:block;top:1px;z-index:1'>"; 
			//htm += "<div style='position:relative;'><div class='VEShadow'></div><div style='position:relative;border: solid #203050 1px; padding: 4px; background-image:url(js/semtag/ui/buttonbackpushed.png);background-color:#eaeef7; background-position:top;background-repeat:repeat-x;'></div></div>"; 
			htm += "<div style='position:relative;'><div class='VEShadow'><div style='position:relative;border: solid #203050 1px; padding: 4px; background-color:#eaeef7; background-position:top;background-repeat:repeat-x;'></div></div></div>"; 
			oPop.innerHTML = htm; 
			document.body.appendChild(oPop); 
		} // if 
		var obj = SemTagSvc.getLiveElementFromEvent(event);
		var pos = SemTagPopup._absolutePosition(obj); 
		// adjust the position and choose the right point gif file 
		oPoint = oPop.firstChild; // point gif file 
		oPop.style.display="block"; 
		oPop.style.top = (pos.top + pos.height) + "px"; 
		var leftPos = pos.left + pos.width/2 - 40;
		 if (leftPos < 8) { 
			oPop.style.left = "8px"; 
			oPoint.src = String(oPoint.src).replace(/pointleft.gif/i, "point.gif"); 
			oPoint.style.marginLeft = "12px"; 
		} else if (leftPos + 240 < document.documentElement.clientWidth) { 
			oPop.style.left = leftPos + "px"; 
			oPoint.src = String(oPoint.src).replace(/pointleft.gif/i, "point.gif"); 
			oPoint.style.marginLeft = "40px"; 
		} else { 
			leftPos = pos.left + pos.width/2 - 200; 
			if (leftPos + 250 > document.documentElement.clientWidth) leftPos = document.documentElement.clientWidth - 250; 
			oPop.style.left = leftPos + "px"; 
			oPoint.src = String(oPoint.src).replace(/point.gif/i, "pointleft.gif"); 
			oPoint.style.marginLeft = "180px"; 
		} // if // adjust the shadow object 
		var b = oPop.firstChild.nextSibling.firstChild; // shadow object 
		var c = b.firstChild;
        var random = dojox.uuid.generateTimeBasedUuid().replace(/\-/g,"");
        c.setAttribute("id",random);

		if (obj.getAttribute("type")=="link") {
			SemTagPopup.requestLink(obj , c);
		} else if (obj.getAttribute("type")=="widget") {
			c.setAttribute("widget",obj.getAttribute("widget"));
			c.removeAttribute("widgetStatus");
			c.innerHTML = obj.innerHTML;
			var iWidget = iWidgetContainer.createWidget(c);
                  if(iWidget) iWidgetContainer.renderWidget(iWidget);
			
		} else {
			b.nextSibling.innerHTML = obj.innerHTML; 
		}
		b.style.height = b.firstChild.offsetHeight + "px"; 

        SemTagSvc.watchEvent(document, 'click', SemTagPopup.click, false);   
        			
        return false;
	},

	_absolutePosition: function(obj) { 
		var pos = null; 
		if (obj != null) { 
			pos = new Object(); 
			pos.top = obj.offsetTop; pos.left = obj.offsetLeft; pos.width = obj.offsetWidth; pos.height= obj.offsetHeight; 
			obj = obj.offsetParent; 
			while (obj != null) { 
				pos.top += obj.offsetTop; 
				pos.left += obj.offsetLeft; 
				obj = obj.offsetParent; 
			} // while 
		} 
		return(pos); 
	}, // _absolutePosition 
	requestLink: function(obj, mmPopup) {
		var request;
		try {
            request = dojo._xhrObj();   
		} catch(e) {
			alert("error: " + e);
		}
	
		request.onreadystatechange = function() {
			try {
			if (request.readyState == 4 & request.status == 200) {
				mmPopup.innerHTML = request.responseText;
			}
			} catch(e) {
			}
		}
		
		var contentURL = obj.getAttribute("href");
		if (contentURL.indexOf("www") == 0) {
			contentURL = "http://localhost:8080/mum/proxy/http/" + contentURL + "/";
		}
		
		
		request.open('GET', contentURL, true);
		request.send('');

	},

	clearPopup: function(/*DOMElement*/event) {
		var obj=document.getElementById("VEPopUp");
		SemTagSvc.clearEventWatch(document, 'click', SemTagPopup.clearPopup, false); 
		obj.style.display = "none"; 
	},
    click:function(event){
         var srcElement = SemTagSvc.getElementFromEvent(event);
         var container = SemTagSvc.getParentByClassName("VEPopUp", srcElement);
         if (!container) container = SemTagSvc.getParentByClassName("clickable",srcElement); 
         if (!container) {
             SemTagPopup.clearPopup(event);
         }
         return false;
    }
}

SemTagPopup.init();
