<%@ page language="java" contentType="application/x-javascript;charset=UTF-8" %>
<%-- Copyright IBM Corp. 2008  All Rights Reserved.                    --%>

<%!
private static String escapeJsText(String origStr) {
	StringBuffer buf = new StringBuffer( origStr.length() * 4 );
	for ( int idx=0; idx<origStr.length(); idx++ ) {
		char c = origStr.charAt( idx );
		if ( c < 0x0080 ) {
			if ( c == '"' ) buf.append( "\\\"" );
			else buf.append( c ); //NEEDSWORK is this good enough?  how about special chars like '\t' (TAB) ?
		}
		else {
			buf.append( "\\u" );
			String hexStr = Integer.toHexString( (int)c );
			for ( int cnt=0; cnt<4-hexStr.length(); cnt++ ) buf.append( '0' );
			buf.append( hexStr );
		}
	}
	return buf.toString();
}
private static String escapeHtmlEntities(String origStr) {
	StringBuffer buf = new StringBuffer( origStr.length() * 2 );
	for ( int idx=0; idx<origStr.length(); idx++ ) {
		char c = origStr.charAt( idx );
		if ( c == '"' ) buf.append( "&quot;" );
		else if ( c == '\'' ) buf.append( "&apos;" );
		else if ( c == '<' ) buf.append( "&lt;" );
		else if ( c == '>' ) buf.append( "&gt;" );
		else if ( c == '&' ) buf.append( "&amp;" );
		else buf.append( c );
	}
	return buf.toString();
}
%>

nls: {
<%
	java.util.ResourceBundle rb = null;
	java.util.Locale loc = pageContext.getRequest().getLocale(); //NEEDSWORK correct locale?

	String localeStr = request.getParameter("language");
	if ( localeStr != null ) {
		int p1 = localeStr.indexOf('_');
		if ( p1 == -1 ) {
			loc = new java.util.Locale( localeStr );
		}
		else {
			String lng = (p1==0)? "": localeStr.substring(0, p1);
			int p2 = localeStr.indexOf('_', p1+1);
			String rgn = (p2==-1)? localeStr.substring(p1+1): localeStr.substring(p1+1, p2);
			loc = new java.util.Locale( lng, rgn );
		}
	}

	String section = request.getParameter("section");
	if (section.equals("person")) {
		try {
			rb = java.util.ResourceBundle.getBundle("nls/person",loc);
		}
		catch (java.util.MissingResourceException e) {
			try {
				rb = java.util.ResourceBundle.getBundle("nls/person",java.util.Locale.ENGLISH);
			}
			catch (java.util.MissingResourceException e2) {
				java.util.logging.Logger logger = java.util.logging.Logger.getLogger("com.ibm.wps.semtag");
				//logger.log(java.util.logging.Level.SEVERE, "Live Object Framework: no ResourceBundle found (person)");
			}
		}
		if (rb != null) {
%>

	"start_chat": "<%= escapeJsText( (rb!=null)? rb.getString("start.chat"): "" ) %>",
	"add_to_contact": "<%= escapeJsText( (rb!=null)? rb.getString("add.to.contacts"): "" ) %>",
	"send_email": "<%= escapeJsText( (rb!=null)? rb.getString("send.email"): "" ) %>",
	"view_person": "<%= escapeJsText( (rb!=null)? rb.getString("view.person"): "" ) %>",
	"hover_label": "<%= escapeJsText( (rb!=null)? rb.getString("hover.label"): "" ) %>",
	"work_location": "<%= escapeJsText( (rb!=null)? rb.getString("work.location"): "" ) %>"

<%
		}
	}
	else if (section.equals("core")) {
		try {
			rb = java.util.ResourceBundle.getBundle("nls/clif",loc);
		}
		catch (java.util.MissingResourceException e) {
			try {
				rb = java.util.ResourceBundle.getBundle("nls/clif",java.util.Locale.ENGLISH);
			}
			catch (java.util.MissingResourceException e2) {
				java.util.logging.Logger logger = java.util.logging.Logger.getLogger("com.ibm.wps.semtag");
				//logger.log(java.util.logging.Level.SEVERE, "Live Object Framework: no ResourceBundle found (clif)");
			}
		}
		if (rb != null) {
%>

	"hover_label": "<%= escapeJsText( (rb!=null)? rb.getString("clif.hover.label"): "" ) %>",
	"a11y_hover": "<%= escapeJsText( escapeHtmlEntities( (rb!=null)? rb.getString("a11y.hover"): "" ) ) %>",
	"a11y_photo": "<%= escapeJsText( escapeHtmlEntities( (rb!=null)? rb.getString("a11y.photo"): "" ) ) %>",
	"a11y_close": "<%= escapeJsText( (rb!=null)? rb.getString("a11y.close"): "" ) %>"

<%
		}
	}
%>
},
