/* (C) Copyright IBM Corp. 2007  All Rights Reserved.                */
//dojo.require("dojo.dnd.*");
dojo.require("com.ibm.enabler.debug");
dojo.declare("attrTest",null,{

    // TODO: test objects, not just strings
    // TODO: test read-only

	onLoad: function () {
        com.ibm.enabler.debug.log("test.onLoad ",this.iContext.getRootElement().getAttribute("id"));
        this.attributes = this.iContext.getiWidgetAttributes();
        this.attrRows = {url:0, dbname:0, level:0, font:0, color:0, size:0};
        var name;
        this.numAttrRows = 0;
        for (name in this.attrRows)
            this.attrRows[name] = ++this.numAttrRows;
        this.tableNode = this.iContext.getElementById("tableBody");
        this.populateTable();
        this.onSetMode(this.attributes._internal()._getMode());
    },

    onReloadAttributes: function() {
        this.attributes._internal().reload();
        this.reloadTable();
    },

    onSaveAttributes: function() {
        this.attributes.save();
        this.reloadTable();
    },
    
    onSetMode: function(mode) {
        if (mode == "xml" || mode == "microformat")
            mode = "com.ibm." + mode;

        if (mode == "com.ibm.microformat") {
            this.columnDisable("microformat", false);
            this.columnDisable("xml", true);
            this.columnDisable("configure", true);
            this.columnDisable("edit_default", true);
            this.columnDisable("edit", true);
        } else if (mode == "configure") {
            this.columnDisable("configure", false);
            this.columnDisable("edit_default", true);
            this.columnDisable("edit", true);
        } else if (mode == "edit_default") {
            this.columnDisable("edit_default", false);
            this.columnDisable("configure", true);
            this.columnDisable("edit", true);
        } else {
            this.columnDisable("edit", false);
            this.columnDisable("configure", true);
            this.columnDisable("edit_default", true);
        }
        this.attributes._internal()._setMode(mode);
        this.updateValues();
        this.updateNames();
    },
    
    columnDisable: function(mode, isDisabled)
    {
        dojo.query("." + mode, this.tableNode).forEach("item.disabled = " + isDisabled);
    },
    
    updateValues: function(){
        var row;
        var nameCell;
        var valueCell;
        var i;
        
        var rows = dojo.query("tr", this.tableNode);
        
        for (i = 1; i < rows.length; i++) {
            row = rows[i];
            nameCell = dojo.query("td.name", row)[0];

            valueCell = dojo.query("td.value", row)[0];
            valueCell.innerHTML = this.format(this.attributes.getItemValue(nameCell.innerHTML));
        }
    },
    
    updateNames: function(){
        var nameCells;
        var i;
        var rowNum;
        
        var nameCells = dojo.query("td.name", this.tableNode);
        nameCells.style("color", "#bbb");
        names = this.attributes.getAllNames();
        if (!names)
            return;
        
        for (i = 0; i < names.length; i++) {
            rowNum = this.attrRows[names[i]];
            if (rowNum)
                nameCells[rowNum - 1].setAttribute("style", "color: black;");
        }        
    },

    populateTable:function(){
        var prototypeRowNode = this.iContext.getElementById("prototypeRow");
        var row;
        var name;
        var nameCell;
        var valueCell;
        var i = 0;
        
        for (name in this.attrRows) {
            i++;

            if (i < this.numAttrRows){
                row = prototypeRowNode.cloneNode(true);
                this.tableNode.insertBefore(row, prototypeRowNode);
            }
            else {
                row = prototypeRowNode;
            }
            row.id = name;
            nameCell = dojo.query("td.name", row)[0];
            nameCell.innerHTML = name;
            this.getAttrCell(row, name, "xml")            
            this.getAttrCell(row, name, "configure")            
            this.getAttrCell(row, name, "microformat")
            this.getAttrCell(row, name, "edit_default")            
            this.getAttrCell(row, name, "edit")            
        }
    },
    
    reloadTable:function(){
        var row;
        var nameCell;
        var name;
        var valueCell;
        var i;
        
        var rows = dojo.query("tr", this.tableNode);
        
        for (i = 1; i < rows.length; i++) {
            row = rows[i];
            nameCell = dojo.query("td.name", row)[0];
            name = nameCell.innerHTML;
            this.getAttrCell(row, name, "xml")            
            this.getAttrCell(row, name, "configure")            
            this.getAttrCell(row, name, "microformat")
            this.getAttrCell(row, name, "edit_default")            
            this.getAttrCell(row, name, "edit")            

            valueCell = dojo.query("td.value", row)[0];
            valueCell.innerHTML = this.format(this.attributes.getItemValue(name));
        }
    },

    getAttrCell:function(row, name, mode){
        var inputNode = dojo.query("input." + mode, row)[0];
        
        if (mode == "xml" || mode == "microformat")
            mode = "com.ibm." + mode;
        
        inputNode.value = this.format(this.attributes._internal().getItemValue(name, mode, false));
    },    

    onChangeAttribute: function(textInputNode) {
        var row = textInputNode.parentNode.parentNode;
        var nameCell = dojo.query("td.name", row)[0];
        var valueCell = dojo.query("td.value", row)[0];
        var name = nameCell.innerHTML;
        var value = textInputNode.value;
        var readOnly = (name == "color");
        if (value)  // TODO: strip white space
        {
            this.attributes.setItemValue(name, value, readOnly);
        }
        else {
            this.attributes.removeItem(name);
        }

        textInputNode.value = this.format(this.attributes._internal().getItemValue(name, null, false));
        valueCell.innerHTML = this.format(this.attributes.getItemValue(name));
        if (valueCell.innerHTML)
            nameCell.setAttribute("style", "color: black");
        else
            nameCell.setAttribute("style", "color: #bbb");
    },
    
    format: function(value) {
        return value ? value : ""; 
    }
});
