/* (C) Copyright IBM Corp. 2007  All Rights Reserved.                */
dojo.declare("explorer",null,null,{	
	onLoad: function () {
        console.log("this is onLoad "+this.iContext.getRootElement().getAttribute("id"));
        //set wires and widget combo box size
        var attributesItemSet = this.iContext.getiWidgetAttributes();
        var size = attributesItemSet.getItemValue("comboSize");

        if (typeof size != "undefined" && size != null) {
            this.comboSize = size;
        }
        else 
            this.comboSize = 2;


    },
    initEvents:function (){

         var swCombo = this.iContext.getElementById("sourceWidget");
         var twCombo = this.iContext.getElementById("targetWidget");
         var seCombo = this.iContext.getElementById("sourceEvent");
         var teCombo = this.iContext.getElementById("targetEvent");

         swCombo.options.length = 0;
         twCombo.options.length = 0;
         seCombo.options.length = 0;
         teCombo.options.length = 0;

         var i=0;
         swCombo.options[i] = new Option("--- select a sourceWidget ---", "");
         twCombo.options[i] = new Option("--- select a targetWidget ---", "");
           
         var widgets = iWidgetContainer.widgetArr;
         var aWidget;
         i++;
         for ( var j in widgets) {
               aWidget = widgets[j];
               var wId = aWidget.id;
               swCombo.options[i] = new Option(wId,wId);
               twCombo.options[i] = new Option(wId,wId);
               i++;
         }
    },
    getWires:function(){
         this.initEvents();
         var wires = serviceManager.getService("eventService").wires;  

         var arr = [];
         var aWire={};
         
         var sourceWidget;
         var sourceEvent;
         var targetWidget;
         var targetEvent;
         for (sourceWidget in wires) {
             var temp1 = wires[sourceWidget];
             for (sourceEvent in temp1 ) {
                 var temp2 = temp1[sourceEvent];
                 for (targetWidget in temp2) {
                     var eventArr = temp2[targetWidget];
                     for (targetEvent in eventArr) {
                         aWire.sw = sourceWidget;
                         aWire.se = sourceEvent;
                         aWire.tw = targetWidget;
                         aWire.te = eventArr[targetEvent];
                         arr.push(dojo.toJson(aWire));
                     }
                 }
             }
         }

         var wiresCombo = this.iContext.getElementById("wiresCombo");
         wiresCombo.options.length = 0;
         var i=0;
         wiresCombo.options[i++] = new Option("--- select a wire ---", "");
         // iterate through the children
         for (var j in arr ) {
               var node = arr[j];
               var escapedNode = escape(node);
               wiresCombo.options[i++] = new Option(node, escapedNode);
         } 
         wiresCombo.size = this.comboSize;
    },
    addWire:function(){

         var swCombo = this.iContext.getElementById("sourceWidget");
         var twCombo = this.iContext.getElementById("targetWidget");
         var seCombo = this.iContext.getElementById("sourceEvent");
         var teCombo = this.iContext.getElementById("targetEvent");

         var sourceWidget = swCombo.options[swCombo.selectedIndex].value;
         var targetWidget = twCombo.options[twCombo.selectedIndex].value;
         var sourceEvent = seCombo.options[seCombo.selectedIndex].value;
         var targetEvent = teCombo.options[teCombo.selectedIndex].value;
         
         serviceManager.getService("eventService").addWire(sourceWidget,sourceEvent,targetWidget,targetEvent);
         this.getWires();
    },
    removeWire:function(){
        
         var wiresCombo = this.iContext.getElementById("wiresCombo");
         var temp = wiresCombo.options[wiresCombo.selectedIndex].value;
         var selectedWire = unescape(temp);
         console.log("removeWire : "+selectedWire);
         if (typeof selectedWire != 'undefined' && selectedWire != null) {
             var aWire = dojo.fromJson(selectedWire);
         }   
         console.log("removeWire "+aWire.sw+","+aWire.se+","+aWire.tw+","+aWire.te);
         serviceManager.getService("eventService").removeWire(aWire.sw,aWire.se,aWire.tw,aWire.te);
         this.getWires();
    },
    reset:function(){
        this.iContext.getElementById("sourceWidget").options.length = 0;
        this.iContext.getElementById("targetWidget").options.length = 0;
        this.iContext.getElementById("sourceEvent").options.length = 0;
        this.iContext.getElementById("targetEvent").options.length = 0; 
    },
    selectSW:function(){
        var swCombo = this.iContext.getElementById("sourceWidget");
        var sourceWidgetId = swCombo.options[swCombo.selectedIndex].value;

        var seCombo = this.iContext.getElementById("sourceEvent");
        seCombo.options.length = 0;
        seCombo.options[0] = new Option("--- select a sourceEvent ---", "");

        var events;
        var sourceWidget = serviceManager.getService("queryService").getWidgetById(sourceWidgetId);
        if (typeof sourceWidget != 'undefined' && sourceWidget != null) {
            events = sourceWidget.getPublishedEventsNames();
        }

        if (typeof events != 'undefined' && events != null ) {
            for (var i in events) {
                var aEvent = events[i];
                seCombo.options[i+1] = new Option(aEvent,aEvent);
            }
        } 
    }, 
    selectTW:function(){
        var twCombo = this.iContext.getElementById("targetWidget");
        var targetWidgetId = twCombo.options[twCombo.selectedIndex].value;

        var teCombo = this.iContext.getElementById("targetEvent");
        teCombo.options.length = 0;
        teCombo.options[0] = new Option("--- select a targetEvent ---", "");

        var events;
        var targetWidget = serviceManager.getService("queryService").getWidgetById(targetWidgetId);
        if (typeof targetWidget != 'undefined' && targetWidget != null) {
            events = targetWidget.getHandledEventsNames();
        }

        if (typeof events != 'undefined' && events != null ) {
            for (var i in events) {
                var aEvent = events[i];
                teCombo.options[i+1] = new Option(aEvent,aEvent);
            }
        } 
    },
    selectWidget:function(){  
         var twCombo = this.iContext.getElementById("widget");
         var targetWidgetId = twCombo.options[twCombo.selectedIndex].value;
         var buf ="";

         var payloadTypeContent = this.iContext.getElementById("payloadTypeContent");
         payloadTypeContent.value = "";
         
         var targetWidget = serviceManager.getService("queryService").getWidgetById(targetWidgetId);
         if (typeof targetWidget != 'undefined' && targetWidget != null) {
             var payloadDefNames = targetWidget.getPayloadDefNames();
             for (var i in payloadDefNames) {
                 var payloadDefName = payloadDefNames[i];
                 var payloadDef = targetWidget.getPayloadDef(payloadDefName);
                 buf = buf.concat(this.writePayloadDef(payloadDef,0));
             }
         }  
         payloadTypeContent.value = buf;
    },
    writePayloadDef:function(payloadDef,i){
         var temp = "";
         var spaces="";
         for (var j=0;j<i;j++) {
             var spaces = spaces.concat('\t\t');
         }
         temp = temp.concat(spaces);
         temp = temp.concat('<iw:payloadDef name="'+payloadDef.getName()+' " type="'+payloadDef.getType()+'" > \n');
         i++;
         var children = payloadDef.getChildren();
         for (var p in children) {
             temp = temp.concat(this.writePayloadDef(children[p],i));
         }
         temp = temp.concat(spaces);
         temp = temp.concat('</iw:payloadDef>\n');
         return temp;
    },
    getWidgets:function(){  

         var twCombo = this.iContext.getElementById("widget");
         var widgets = iWidgetContainer.widgetArr;
         var aWidget;
         var i=1;
         twCombo.options[0] = new Option("--- select a Widget ---", "");

         for ( var j in widgets) {
               aWidget = widgets[j];
               var wId = aWidget.id;
               twCombo.options[i] = new Option(wId,wId);
               i++;
         }  
    }
});

                        

