/* (C) Copyright IBM Corp. 2007  All Rights Reserved.                */
/**
 * This is the JS file semantic tagging with addresses
 */
var SemTagAddr = {

	// self-boot
	init: function () {
		SemTagSvc.setCallback('adr',SemTagAddr.adrsAdded);
		SemTagAddr.processAdrs(SemTagSvc.getNodes('adr'));
	},

	<%
		String template = request.getParameter("template");
		if (template == null) template = "address.jsp2";
		pageContext.include("/ui/templates/" + template);
	%>
	
	// callback for reparse
	adrsAdded: function() {
		SemTagAddr.processAdrs(SemTagSvc.getNodes('adr'));
	},
	
	// main tag processing method
	processAdrs: function(adrs) {
		while (adrs.length > 0) {
			var adrElem = SemTagAddr.getAddressElement(adrs.pop());
			SemTagSvc.addHover(adrElem, SemTagAddr.showHover, SemTagAddr.showMenu);
		}
	},
	
	// mouseover handler -- just receive the event and call the Svc method
	showHover: function(event) {
		SemTagSvc.showHover(event, SemTagAddr.showMenu);
	},

	// click handler -- prepare the menu items and call the Svc method
	showMenu: function(event) {
		if (SemTagMenu.staticHover) {
			var srcElem = event.target? event.target: event.srcElement;
			SemTagAddr.currentElem = SemTagAddr.getAddressElement(srcElem);
		}
		else {
			SemTagAddr.currentElem = SemTagMenu.getCurrentElement();
		}

        SemTagAddr.currentAddress = SemTagPerson.getAddressJson(SemTagAddr.currentElem); // for extenders

        var miJsons = new Array();

		var items = SemTagSvc.getActions("address");
		if (items) {
			for (var i=0; i<items.length; i++) {
				var label = items[i].label;
				if (label.match(/nls\.[a-z]/)) label = eval(label);
				var href = items[i].url.replace( /@@@ARGS@@@/g, "SemTagAddr.currentAddress" );
				miJsons.push(SemTagSvc.getMenuItemJson(label, href, items[i].order));
			}
		}

		SemTagSvc.setMenuData(event, miJsons);
	},

    // finds the DOM element to make 'live'
    getAddressElement: function (elem) {
        if (elem.className!="adr") elem = SemTagSvc.getParentByClassName('adr',elem);
        var elems = SemTagSvc.getElementsByClassName("street-address", elem, 1);
        if (0<elems.length) return elems[0];
        elems = SemTagSvc.getElementsByClassName("locality", elem, 1);
        if (0<elems.length) return elems[0];
        return elem;
    }
}

SemTagAddr.init();
