/* (C) Copyright IBM Corp. 2007  All Rights Reserved.                */
<%@ page language="java" contentType="application/x-javascript;charset=UTF-8" %>
<%
	String preferredImIds = "[\"X-imn\",\"email\",\"uid\",\"fn\"]"; //NEEDSATTN
	java.util.Properties props = new java.util.Properties();
	try {
		java.io.InputStream is = this.getClass().getClassLoader().getResourceAsStream( "config/persontag.properties" ); //NEEDSATTN
		if ( is != null ) {
			props.load( is );
			String tmp = props.getProperty( "stNamePref" ); //NEEDSATTN
			if ( tmp != null && 0 < tmp.length() ) {
				StringBuffer buf = new StringBuffer( "[\"" );
				buf.append( tmp.replaceAll( ";", "\",\"" ) );
				buf.append( "\"]" );
				preferredImIds = buf.toString();
			}
		}
	}
	catch (Exception e) {
		e.printStackTrace();
	}
%>

/**
 * This is the JS file semantic tagging for awareness
 */
var SemTagAwrns = {

    SVCNAME: "sametime",
    hcards: new Array(),
	activeElems: new Array(),
    hasApplet: false,
    imIds: <%= preferredImIds %>,

	init: function () {
		SemTagSvc.setCallback(SemTagAwrns.SVCNAME,SemTagAwrns.hcardsAdded);
		SemTagAwrns.processHcards(SemTagSvc.getNodes(SemTagAwrns.SVCNAME));
	},

	hcardsAdded: function() {
		SemTagAwrns.processHcards(SemTagSvc.getNodes(SemTagAwrns.SVCNAME));
	},
	
	processHcards: function(hcards) {
		if (typeof(prepareSametimeLink)=='undefined') return; // somehow stlinks.js isn't loaded...

		for (var i=0; i<hcards.length; i++) {
			var hcard = hcards[i];
			if (SemTagAwrns.disabled(hcard)) continue;

			SemTagAwrns.hcards.push(hcard);

			var fnElem = SemTagSvc.findNameElementInHcard(hcard);
			if (!fnElem) continue;
			var leid = fnElem.getAttribute(SemTagSvc.liveElemPrefix + "id");
			if (leid && SemTagAwrns.activeElems[leid]) continue;

			var imId = SemTagAwrns.getSametimeId(hcard);
			var resolve = SemTagUtil.getHcardAttributeValue("X-sametime-resolve", hcard)
			var st = prepareSametimeLink(imId, "", resolve, "text:no;");
			var status = document.createElement("span");
			status.style.verticalAlign = "text-top"; //NEEDSWORK try placing the ST icon at the middle of the line...
			status.innerHTML = st;
			fnElem.parentNode.insertBefore(status,fnElem);

			if (leid) SemTagAwrns.activeElems[leid] = true;
		}
	},

	disabled: function (hcard) {
		return SemTagUtil.getHcardAttributeValue("X-no-awareness", hcard); //NEEDSATTN
	},

	getSametimeId: function(hcard) {
		var imId = null;
		for (var i=0; i<SemTagAwrns.imIds.length; i++) {
			var elem = SemTagSvc.findElementByNameInHcard(hcard, SemTagAwrns.imIds[i]);
			if (elem) {
				imId = SemTagSvc.getTextValue(elem);
				if (0 < imId.length) break;
			}
		}
		return imId;
	},

    updateST: function (eventArg) {
        var split = eventArg.split(";");
        var name = split[0];
        var status = split[1];
        
        for (var i=0; i < SemTagAwrns.hcards.length; i++) {
            var vc = SemTagAwrns.hcards[i];
            var watchedUser = SemTagAwrns.getSametimeId(vc);
            if ( watchedUser == name ) {
                var fnElem = SemTagSvc.findNameElementInHcard(vc);
                if (fnElem) fnElem.setAttribute("semtag_ststatus", status); //NEEDSATTN
            }
        }
    },

    openChat: function(imId) {
        if (SemTagSvc.debug) alert( "Opening chat with: " + imId );
       	STLinksCreateIM(imId);
    }
}

function STLinksUserStatusChanged(userId, displayName, status, statusMessage, groupName) {
    var val = "";
    switch(status) {
        //case 0: val = "offline"; break;
        case (32||64||554): val = "online"; break;
        case (96||608): val = "away"; break;
        case 128: val = "donotdisturb"; break;
        default : val = "offline"; break;
    }
    var arg = userId + ";" + val;
    SemTagAwrns.updateST(arg);
}

function STLinksAppletStarted() {
    if (SemTagSvc.debug) alert( "Applet Started!" ); 
    SemTagAwrns.hasApplet = true;
}

function STLinksLoggedIn(id,name) {
	if (SemTagSvc.debug) alert( "Logged In: " + id + ", " + name ); 
}

SemTagAwrns.init();
