/* (C) Copyright IBM Corp. 2007  All Rights Reserved.                */
/**
 * This is the JS file semantic tagging with people
 */
<%@ page language="java" contentType="application/x-javascript;charset=UTF-8" %>
<%
	javax.servlet.ServletRequest req = pageContext.getRequest();
	String serverUrl = req.getScheme() + "://" + req.getServerName() + ":" + req.getServerPort();
	String baseUrl = serverUrl + request.getContextPath();
%>

var SemTagPerson = {

	INLINE: "X-person-display-inline",
	activeElems: new Array(),
	requestor: new SemTagUtil.crossDomainRequest(),
	servletUrl: "<%= baseUrl %>/getPersonTag?action=ptag_menu&email=@@@EMAIL@@@",
	reqMethod: eval("getTagFromServer"),
	photoUrl: "<%= baseUrl %>/ui/no_photo_avail.gif",
//	servletUrl: "<%= serverUrl %>/wps/um/secure/users/profiles?expandRefs=true&includeAttributes=displayName,cn,ibm-primaryEmail,uid,ibm-jobTitle,telephoneNumber,roomNumber,localityName,stateOrProvinceName,countryName&searchAttributes=@@@QUERY@@@",
//	reqMethod: eval("callUserProfileServlet"),
//	photoUrl: "<%= serverUrl %>/lwp/imageServlet/ImageServlet?email=@@@EMAIL@@@",

	init: function () {
		SemTagSvc.setCallback('hcard',SemTagPerson.hcardsAdded);
		SemTagSvc.setCallback('mailto',SemTagPerson.mailtosAdded);
		SemTagPerson.processHcards(SemTagSvc.getNodes('hcard'));
		SemTagPerson.processMailtos(SemTagSvc.getNodes('mailto'));
		
		SemTagSvc.watchEvent(window, 'load', SemTagPerson.clearInternalData, false);
	},

	clearInternalData: function() {
		var leids = SemTagPerson.activeElems;
		while (0 < leids.length) {
			leids.pop();
		}
	},

	<%
		String language = request.getParameter("language");
		if (language == null) language = pageContext.getRequest().getLocale().toString();
		pageContext.include("/ui/resourceLoader.jsp2?section=person&language=" + language);

		String template = request.getParameter("template");
		if (template == null) template = "person.jsp2";
		pageContext.include("/ui/templates/" + template);
	%>
	
	out: function () {
		this.buffer = "";
		this.write = function (str) {
			this.buffer += str;
		}
	},

	processHcards: function(hcards) {
		if (!hcards || hcards.length==0) return;
//		var startTime = new Date().getTime(); //HMperf
		for (var i=0; i<hcards.length; i++) {
			var hcard = hcards[i];
            var fnElem = SemTagPerson.getNameElement(hcard);
            if (!fnElem) continue;
            var email = SemTagUtil.getHcardAttributeValue("email", hcard);
            if (!email.internet) {
            	var uid = SemTagUtil.getHcardAttributeValue("uid", hcard);
            	if (!uid) continue;
            }
            var leid = fnElem.getAttribute(SemTagSvc.liveElemPrefix + "id");
            if (leid) {
            	if (SemTagPerson.activeElems[leid]) continue;
            		else {
            			if (SemTagSvc.trace) SemTagUtil.log("Person.leid=" + leid + " being processed again!");
            			continue; //NEEDSWORK figure out why this happens
            		}
            }

			if (SemTagPerson.isInline(hcard)) {
				var event = {"target": fnElem}; // I need an event
				SemTagPerson.requestPersonInfo(event);
			}
			else {
				var alttext = SemTagSvc.getTextValue(fnElem) + " " + SemTagMenu.nls.a11y_hover; //A11Y
				SemTagSvc.addHover(fnElem, SemTagPerson.showHover, SemTagPerson.showMenu, alttext);
            	leid = fnElem.getAttribute(SemTagSvc.liveElemPrefix + "id");
				if (leid) SemTagPerson.activeElems[leid] = true;
			}
		}
//		var endTime = new Date().getTime(); //HMperf
//		alert("processHcards: " + (endTime-startTime)); //HMperf
	},
	
	isInline: function (hcard) {
		return SemTagUtil.getHcardAttributeValue(SemTagPerson.INLINE, hcard);
	},
	
	processMailtos: function(mailtos) {
		if (!mailtos || mailtos.length==0) return;
		while (mailtos.length > 0) {
			var mailto = mailtos.pop();
//NEEDSWORK I don't get this...why do we want to show inline for each mailto?
//			if (SemTagPerson.isInline(mailto)) {
//				//SemTagPerson.currentElem = mailto;
//				var event = {"target": mailto}; // I need an event
//				SemTagPerson.requestPersonInfo(event);
//				continue;
//			}
			SemTagSvc.watchEvent(mailto, 'mouseover', SemTagPerson.tagMouseover, false);
		}
	},
	
	hcardsAdded: function() {
		if (SemTagSvc.trace) SemTagUtil.log("hcardsAdded");
		SemTagPerson.processHcards(SemTagSvc.getNodes('hcard'));
	},
	
	mailtosAdded: function() {
		SemTagPerson.processMailtos(SemTagSvc.getNodes('mailto'));
	},
	
//	loadHcardPerson: function (srcElement) {
//		var person = new Object();
//		var parentVcard = SemTagSvc.getParentByClassName("vcard", srcElement);
//		var vcardElems = parentVcard.getElementsByTagName("*");
//		for (i=0; i<vcardElems.length; i++) {
//			var curElem = vcardElems[i];
//			if (curElem.className) {
//				var classes = curElem.className.split(' ');
//				for (j=0; j<classes.length; j++) {
//					var c = classes[j];
//					var attr = SemTagUtil.getHcardAttributeValue(c, parentVcard);
//					if (attr) person[c] = attr;
//				}
//			}
//		}
//		return person;
//	},

	showHover: function(event) {
		if (SemTagSvc.trace) SemTagUtil.log("Person.showHover");
		var insideInline = SemTagUtil.getHcardAttributeValue("X-person-inside-inline", SemTagSvc.getLiveElementFromEvent(event));
		var label = insideInline? null: SemTagPerson.nls.hover_label;
		SemTagSvc.showHover(event, SemTagPerson.showMenu, label);
		return false;
	},

	showMenu: function(event) {
		if (SemTagSvc.trace) SemTagUtil.log("Person.showMenu");
		SemTagMenu.waitCursor(); // I need a server roundtrip...
		SemTagMenu.stopEvent(event); //NEEDSWORK we need this when calling my servlet??
		SemTagPerson.requestPersonInfo(event);
		return false;
	},

	requestPersonInfo: function(event) {
		SemTagPerson.reqMethod.call(SemTagPerson, event);
	},

	dispatch: function (data) {
		var reqid = (data.email && data.email.internet)? data.email.internet: null;
		if (reqid) SemTagPerson.requestor.dispatch(reqid.toLowerCase(), data);
	},
	
	requestReturn: function (success, retval, event) {
		if (SemTagSvc.trace) SemTagUtil.log("Person.requestReturn: " + retval + " (" + (success? "success": "fail") + ")");
		var person = success? retval: SemTagPerson.emptyPerson();
		if (person) {
			var currElem = SemTagSvc.getLiveElementFromEvent(event);
			SemTagPerson.fillPersonJsonMoreFromDom(person, currElem);
			SemTagPerson.update(person, currElem, event);
		}
		else SemTagMenu.defaultCursor();
	},

	fillPersonJsonMoreFromDom: function(person, currElem) {
		if (SemTagSvc.debug) window.status = "Person.fillPersonJsonMoreFromDom";

		var nameElem = SemTagSvc.findNameElementInHcard(currElem);
		if (nameElem) person.fn = SemTagSvc.getTextValue(nameElem);

		var email = SemTagPerson.getElementEmail(currElem);
		if (email) person.email = {"internet": email};

		var uid = SemTagUtil.getHcardAttributeValue("uid", currElem);
		if (uid) person.uid = uid;

		if (!person.photo) {
			var tmp = (person.email && person.email.internet)? person.email.internet: email;
			if (!tmp) tmp = "NOTFOUND"; //NEEDSATTN
			person.photo = SemTagPerson.photoUrl.replace(/@@@EMAIL@@@/, tmp);
		}

		if (!person.tel || !person.tel.voice) {
			var telElem = SemTagSvc.findElementByNameInHcard(currElem, "tel");
			if (telElem) {
				var tels = SemTagSvc.getTypedValue(telElem, "voice");
				person.tel = {"voice": tels["voice"]};
			}
		}

		var addrElem = SemTagSvc.findElementByNameInHcard(currElem, "adr");
		var addrJson = {};
		if (addrElem) {
			addrJson = SemTagPerson.getAddressJson(addrElem);
			person.adr = addrJson;
		}

		if (typeof(person.adr)!='undefined' && (person.adr.locality || person.adr.countryname)) {
			if (!person.X) person.X = {};
			var temp = eval(SemTagPerson.nls.work_location);
			if ( temp ){
				person.X.worklocation = temp.replace(/undefined/g, "");
			}else{
				person.X.worklocation = "";
			}
		}
		
		if (typeof(SemTagAwrns)!='undefined') {
			if (!person.X) person.X = {};
			person.X.imn = SemTagAwrns.getSametimeId(currElem);
			person.X.ststatus = nameElem.getAttribute("semtag_ststatus");
		}
	},

	emptyPerson: function() {
		return {"fn": "", "email": {"internet": ""}}; //NEEDSATTN
	},

	// you can pass in an element to place the contents in...else it ends up in the regular container
	update: function (person, currElem, event) {
		if (SemTagSvc.trace) SemTagUtil.log("Person.update");
		
        SemTagPerson.currentPerson = person; // for extenders to access

		var parentVcard = SemTagSvc.getParentByClassName("vcard", currElem);

		var headerOnly = SemTagUtil.getHcardAttributeValue("X-person-header-only", parentVcard);
		if (headerOnly) person._headeronly = true;
		SemTagPerson.readHcardContext(parentVcard, person);
		
		if (SemTagPerson.isInline(parentVcard)) {
			var out = new SemTagPerson.out();
			SemTagPerson.getInlineMarkup(person, SemTagSvc.bidi, out);
			parentVcard.innerHTML = out.buffer;
			//var dom = SemTagPerson.getInlineMarkup2(person, SemTagSvc.bidi, out);
			//parentVcard.appendChild(dom);

			var classAttrs = SemTagUtil.getNodeClassValue(parentVcard);
			SemTagUtil.setNodeClassValue(parentVcard, classAttrs.replace(/vcard/, "vcard-done"));
			if (headerOnly) {
				var inner = SemTagSvc.getElementsByClassName("vcard", parentVcard, 1);
				if (inner) SemTagPerson.processHcards( inner );
			}
		}
		else {
        	var menuitemJsons = new Array();
        	var cssSelector = "personMenuActions";
			var headerHtml = new SemTagPerson.out();
			var footerHtml = new SemTagPerson.out();

			SemTagPerson.getMarkup(person, SemTagSvc.bidi, menuitemJsons, cssSelector, headerHtml, footerHtml);

			SemTagSvc.setMenuData(event, menuitemJsons, cssSelector, SemTagSvc.getMenuHeaderJson(headerHtml.buffer, "text/html", -100), SemTagSvc.getMenuFooterJson(footerHtml.buffer, "text/html", -100));
		}
    },
	
    readHcardContext: function(elem, person) {
		var inlineDisplay = SemTagUtil.getHcardAttributeValue("X-person-inside-inline", elem);
		if (inlineDisplay) person._inline = true;

		var insideProfile = SemTagUtil.getHcardAttributeValue("X-person-inside-profile", elem);
		if (insideProfile) person._inprofile = true;

		var inPlace = SemTagUtil.getHcardAttributeValue("X-person-profile-inplace", elem);
		if (inPlace) person._profileinplace = true;
    },

	getElementEmail: function (elem) {
		if (!elem) {
			alert("getElementEmail called with: " + elem);
		}
		var email;
		var srcVcard = SemTagSvc.getParentByClassName('vcard',elem);
		if (srcVcard) {
			email = SemTagUtil.getHcardAttributeValue("email", srcVcard);
			email = email.internet;
		}
		else if (elem.tagName == 'A' && elem.href.match(/^mailto:/)) {
			email = elem.href.replace(/^mailto:/,"");
		}
		return email;
	},

    getNameElement: function(elem) {
		try {
			if (elem.className!="vcard") elem = SemTagSvc.getParentByClassName('vcard',elem);
			var nameElem = SemTagSvc.getElementsByClassName("fn", elem, 1)[0];
			if (!nameElem) {
				nameElem = SemTagSvc.getElementsByClassName("n", elem, 1)[0];
			}
			return nameElem;
		}
		catch (e) {
			if (SemTagSvc.debug) alert(e);
		}
		return null;
    },

	// returns a JSON object that represents this address
	getAddressJson: function (elem) {
		var fulladr = {"postofficebox": "", "streetaddress": "", "locality": "", "region": "", "postalcode": "", "countryname": ""}
		var adrElem = elem;
		if (adrElem.className!="adr") adrElem = SemTagSvc.getParentByClassName('adr',elem);
		if (adrElem) {
            var nodes = adrElem.childNodes;
            for (var i=0; i<nodes.length; i++) {
                SemTagPerson.readAddressInfo(nodes[i],fulladr);
            }
		}
		else { //NEEDSWORK
            fulladr.streetaddress = "5 Technology Park Drive";
            fulladr.locality = "Westford";
            fulladr.region = "MA";
            fulladr.postalcode = "01886";
            fulladr.countryname = "USA";
		}
		return fulladr;
	},

	// recursive method to read the 'adr' DOM structure
	readAddressInfo: function(node,addr) {
		var children = node.childNodes;
		if (children) {
			for (var i=0; i<children.length; i++) {
				SemTagPerson.readAddressInfo(children[i],addr);
			}
		}
		if (node.className!=null) {
			var cn = node.className;
			if (cn.match(/(^|\s)post-office-box(\s|$)/i)) addr.postofficebox = SemTagSvc.getTextValue(node);
			else if (cn.match(/(^|\s)extenodeed-address(\s|$)/i)) addr.extenodeedaddress = SemTagSvc.getTextValue(node);
			else if (cn.match(/(^|\s)street-address(\s|$)/i)) addr.streetaddress = SemTagSvc.getTextValue(node);
			else if (cn.match(/(^|\s)locality(\s|$)/i)) addr.locality= SemTagSvc.getTextValue(node);
			else if (cn.match(/(^|\s)region(\s|$)/i)) addr.region= SemTagSvc.getTextValue(node);
			else if (cn.match(/(^|\s)postal-code(\s|$)/i)) addr.postalcode= SemTagSvc.getTextValue(node);
			else if (cn.match(/(^|\s)country-name(\s|$)/i)) addr.countryname= SemTagSvc.getTextValue(node);
		}
	}
}

function getTagFromServer(event) { // works with the Person Servlet in cross-domain fashion
	var elem = SemTagSvc.getLiveElementFromEvent(event);
	var email = SemTagPerson.getElementEmail(elem);
	if (email) {
		email = email.toLowerCase();
		var src = SemTagPerson.servletUrl.replace(/@@@EMAIL@@@/, email);
		if (SemTagSvc.debug) window.status = "Person.getTagFromServer sending request for: " + email + ")";
		SemTagPerson.requestor.request(src, 6000, SemTagPerson.requestReturn, elem, email);
	}
	else {
		if (SemTagSvc.debug) alert("getTagFromServer couldn't find the e-mail");
		var evt = {"target": elem}; // I need a fake event
		SemTagPerson.requestReturn(false, null, evt);
	}
}

function callUserProfileServlet(event) { // works with the User Profile Servlet of WAS/WP
	if (SemTagSvc.trace) SemTagUtil.log("callUserProfileServlet");

	var currElem = SemTagSvc.getLiveElementFromEvent(event);
	var query = ""; {
		var email = SemTagPerson.getElementEmail(currElem);
		if (email) {
			query = "ibm-primaryEmail=" + email; //NEEDSATTN
		}
		else {
			var uid = SemTagUtil.getHcardAttributeValue("uid", currElem);
			if (uid) query = "uid=" + uid; //NEEDSATTN
		}
	}
	if (0 < query.length) {
		var xml = null;
		try {
			xml = ibm.portal.xml.loadXml(SemTagPerson.servletUrl.replace(/@@@QUERY@@@/, query));
		}
		catch (e) {
			if (SemTagSvc.debug) alert("Person.callUserProfileServlet caught: " + e);
		}

		if (xml) {
			var xsl = ibm.portal.xml.loadXsl(SemTagSvc.baseUrl + "/xsl/UserAtomToPersonJson.xsl");
			var xformed = ibm.portal.xml.transform( xml, xsl, null, null, true );
			if (SemTagSvc.trace) SemTagUtil.log(xformed);

			var person = eval(xformed)[0];
			if (!person || !person.fn) person = SemTagPerson.emptyPerson();
			SemTagPerson.fillPersonJsonMoreFromDom(person, currElem);
			SemTagPerson.update(person, currElem, event);
			return;
		}
		else if (SemTagSvc.trace) SemTagUtil.log("bad XML");
	}

	// well, we are here, and that means something failed, let's popup something with the info already found in the page
	var evt = {"target": currElem}; // I need a fake event
	SemTagPerson.requestReturn(false, null, evt);
}

//function readReqIdFromJson(retval) {
//	return (retval.email && retval.email.internet)? retval.email.internet: null;
//}
//
//function noConversion(retval) {
//	return retval;
//}
//
//function readReqIdFromAtom(retval) {
//	alert("readReqIdFromAtom: " + retval); //HMdebug
//	var xml = ibm.portal.xml.loadXmlString(retval);
//	var xsl = ibm.portal.xml.loadXsl(SemTagSvc.baseUrl + "/xsl/UserAtomToPersonJson.xsl");
//	var json = ibm.portal.xml.transform( xml, xsl, null, null, true );
//	return (json.email && json.email.internet)? json.email.internet: null;
//}
//
//function convertAtom(retval) {
//	//NEEDSWORK how come I have to do the XSLT twice?!
//	var xml = ibm.portal.xml.loadXmlString(retval);
//	var xsl = ibm.portal.xml.loadXsl(SemTagSvc.baseUrl + "/xsl/UserAtomToPersonJson.xsl");
//	var json = ibm.portal.xml.transform( xml, xsl, null, null, true );
//	return json;
//}

<% pageContext.include("/javascript/xslt.js"); %>

SemTagPerson.init();
