<%-- Copyright IBM Corp. 2008  All Rights Reserved.                    --%>
getMarkup: function(person, bidi, menuItems, selector, header, footer) {
	var email = person.email.internet;
	if (email.match(/\.ibm\.com$/) != null) {
		if (!person._inprofile) menuItems.push(SemTagSvc.getMenuItemJson(SemTagPerson.nls.view_person, "javascript:SemTagPerson.openBluePages()", -100));
		menuItems.push(SemTagSvc.getMenuItemJson("Go to Blog...", "javascript:SemTagPerson.openBlogCentral()", -20));
	}
	if (email) menuItems.push(SemTagSvc.getMenuItemJson(SemTagPerson.nls.send_email, "mailto:" + email, -90));

	// process the extra menu items available
	var items = SemTagSvc.getActions("person");
	if (items) {
		for (i=0; i<items.length; i++) {
			var showif = items[i].showif;
			var show = true;
			if (showif) {
				var showifMethod = eval(showif);
				show = showifMethod.call(null,SemTagPerson.currentPerson);
			}
			if (show) {
				var label = items[i].label;
				if (label.match(/nls\.[a-z]/)) label = eval(label);
				var href = items[i].url.replace( /@@@ARGS@@@/g, "SemTagPerson.currentPerson" );
				menuItems.push(SemTagSvc.getMenuItemJson(label, href, items[i].order));
			}
		}
	}
	if (person.adr) {
		items = SemTagSvc.getActions("address");
		if (items) {
			for (i=0; i<items.length; i++) {
				var label = items[i].label;
				if (label.match(/nls\.[a-z]/)) label = eval(label);
				var href = items[i].url.replace( /@@@ARGS@@@/g, "SemTagPerson.currentPerson" );
				menuItems.push(SemTagSvc.getMenuItemJson(label, href, items[i].order));
			}
		}
	}

	if (!person._inline) {
		var float_p = (bidi=='rtl')? "right": "left";
		header.write("<span class='photoCard' style='float:" + float_p + ";'><img src='" + person.photo + "' alt=''/>");
		var float_b = (bidi=='rtl')? "left": "right";
		header.write("</span><div class='businessCard' style='float:" + float_b + ";'><ul dir='" + bidi + "'>");
		header.write("<li class='cardName'>" + person.fn + "</li>");
		header.write("<li>" + person.email.internet + "</li>");
		if (person.title) header.write("<li>" + person.title + "</li>");
		if (person.tel && person.tel.voice) header.write("<li>" + person.tel.voice + "</li>");
		header.write("</ul></div>");
	}
}, 

getInlineMarkup: function (person, bidi, buffer) {
	var email = person.email.internet;
	buffer.write("<div class='personMenu'>");
	buffer.write("<div class='photoCard'><img src='" + person.photo + "' alt=''/></div>");
	buffer.write("<div class='businessCard' dir='" + bidi + "'>");
	var classAttr = (person._headeronly? "class='vcard X-person-inside-inline'": "");
	buffer.write("<ul " + classAttr + " dir='" + bidi + "'>");
	buffer.write("<li class='cardName'><span class='fn'>" + person.fn + "</span></li>");
	buffer.write("<li class='email'><span class='type' style='display:none;'>internet</span><span class='value'>" + email + "</span></li>");
	if (person.title) buffer.write("<li>" + person.title + "</li>");
	if (person.tel && person.tel.voice) buffer.write("<li>" + person.tel.voice + "</li>");
	buffer.write("</ul>");
	buffer.write("</div>");
	if (person._headeronly) {
		buffer.write("<div style='clear:both;'>");
	}
	else {
		buffer.write("<div class='personMenuActions' dir='" + bidi + "'>");
		buffer.write("<ul>");
		if (email.match(/ibm\.com$/)!=null) buffer.write("<li><a href='http://w3.ibm.com/bluepages/simpleSearch.wss?location=All+locations&task=viewrecord&searchBy=Internet+address&searchFor=" + email + "'>" + SemTagPerson.nls.view_person + "</a></li>");
		buffer.write("<li><a href='http://blogs.webahead.ibm.com/pilot/weblogs/page/" + email + "'>Go to Blog...</a></li>");
		buffer.write("<li><a href='mailto:" + email + "'>" + SemTagPerson.nls.send_email + "</a></li>");
		buffer.write("</ul>");
	}
	buffer.write("</div>");
	buffer.write("</div>");
},
//getInlineMarkup2: function (person, bidi, buffer) {
//	var email = person.email.internet;
//	var dom = document.createElement("div");
//	SemTagUtil.setNodeClassValue(dom, "personMenu");
//	var photo = document.createElement("div"); {
//		SemTagUtil.setNodeClassValue(photo, "photoCard");
//		var img = document.createElement("img");
//		img.setAttribute("src", person.photo);
//		photo.appendChild(img);
//	}
//	dom.appendChild(photo);
//	var bizcard = document.createElement("div"); {
//		SemTagUtil.setNodeClassValue(bizcard, "businessCard");
//		var ul = document.createElement("ul"); {
//			if (person._headeronly) SemTagUtil.setNodeClassValue(ul, "vcard X-person-inside-inline");
//			var l1 = document.createElement("li"); {
//				SemTagUtil.setNodeClassValue(l1, "cardName");
//				var fn = document.createElement("span");
//				SemTagUtil.setNodeClassValue(fn, "fn");
//				fn.appendChild(document.createTextNode(person.fn));
//				l1.appendChild(fn);
//			}
//			ul.appendChild(l1);
//			var l2 = document.createElement("li"); {
//				SemTagUtil.setNodeClassValue(l2, "email");
//				var type = document.createElement("span");
//				SemTagUtil.setNodeClassValue(type, "type");
//				type.style.display = "none";
//				type.appendChild(document.createTextNode("internet"));
//				var value = document.createElement("span");
//				SemTagUtil.setNodeClassValue(value, "value");
//				value.appendChild(document.createTextNode(email));
//				l2.appendChild(type);
//				l2.appendChild(value);
//					}
//					ul.appendChild(l2);
//			if (person.title) {
//				var li = document.createElement("li");
//				li.appendChild(document.createTextNode(person.title));
//				ul.appendChild(li);
//			}
//			if (person.tel && person.tel.voice) {
//				var li = document.createElement("li");
//				li.appendChild(document.createTextNode(person.tel.voice));
//				ul.appendChild(li);
//			}
//		}
//		bizcard.appendChild(ul);
//	}
//	dom.appendChild(bizcard);
//	var menu = document.createElement("div"); {
//		if (person._headeronly) {
//			menu.style.clear="both"; // don't know why, but without this, the businesscard section won't have the proper border...
//		}
//		else {
//			SemTagUtil.setNodeClassValue(menu, "personMenuActions");
//			var ul = document.createElement("ul"); {
//				if (email.match(/ibm\.com$/)!=null) {
//					var l1 = document.createElement("li"); {
//						var a1 = document.createElement("a");
//						a1.setAttribute("href", "http://w3.ibm.com/bluepages/simpleSearch.wss?location=All+locations&task=viewrecord&searchBy=Internet+address&searchFor=" + email);
//						a1.appendChild(document.createTextNode(SemTagPerson.nls.view_person));
//						l1.appendChild(a1);
//					}
//					ul.appendChild(l1);
//					var l2 = document.createElement("li"); {
//						var a2 = document.createElement("a");
//						a2.setAttribute("href", "http://blogs.webahead.ibm.com/pilot/weblogs/page/" + email );
//						a2.appendChild(document.createTextNode("Go to Blog..."));
//						l2.appendChild(a2);
//					}
//					ul.appendChild(l2);
//				}
//				var l3 = document.createElement("li"); {
//					var a3 = document.createElement("a");
//					a3.setAttribute("href", "mailto:" + email );
//					a3.appendChild(document.createTextNode(SemTagPerson.nls.send_email));
//					l3.appendChild(a3);
//				}
//				ul.appendChild(l3);
//			}
//			menu.appendChild(ul);
//		}
//	}
//	dom.appendChild(menu);
//	return dom;
//},

openBluePages: function() {
	var email = SemTagPerson.currentPerson.email.internet;
	window.open("http://w3.ibm.com/bluepages/simpleSearch.wss?location=All+locations&task=viewrecord&searchBy=Internet+address&searchFor=" + email, null, "height=600,width=900,resizable=yes,status=yes,toolbar=no,menubar=no,location=no,scrollbars=yes");
},

openBlogCentral: function() {
	var email = SemTagPerson.currentPerson.email.internet;
	window.open("http://blogs.webahead.ibm.com/pilot/weblogs/page/" + email, null, "height=600,width=900,resizable=yes,status=yes,toolbar=no,menubar=no,location=no,scrollbars=yes");
},
