<?xml version="1.0" encoding="ISO-8859-1"?>
<!-- (C) Copyright IBM Corp. 2007  All Rights Reserved.                -->
<xsl:stylesheet version="1.0"
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
	xmlns:atom="http://www.w3.org/2005/Atom"
	xmlns:userprof="http://www.ibm.com/xmlns/prod/websphere/um.xsd">
<xsl:output method='text' version='1.0' encoding='UTF-8' indent='yes'/>

<xsl:template match="/">
	{
		users: [ <xsl:apply-templates select="/atom:feed/atom:entry/atom:content/userprof:profile"/> {} ]
	}
</xsl:template>

<xsl:template match="userprof:profile">
	{
		<xsl:for-each select="./userprof:attribute">
			<xsl:if test="@name='cn'">fn: "<xsl:value-of select='userprof:attributeValue'/>", </xsl:if>
			<xsl:if test="@name='description'">note: "<xsl:value-of select='userprof:attributeValue'/>", </xsl:if>
			<xsl:if test="@name='displayName'">fn: "<xsl:value-of select='userprof:attributeValue'/>", </xsl:if>
			<xsl:if test="@name='ibm-jobTitle'">title: "<xsl:value-of select='userprof:attributeValue'/>", </xsl:if>
			<xsl:if test="@name='ibm-primaryEmail'">email: {internet: "<xsl:value-of select='userprof:attributeValue'/>"}, </xsl:if>
			<xsl:if test="@name='ibm-timeZone'">tz: "<xsl:value-of select='userprof:attributeValue'/>", </xsl:if>
			<xsl:if test="@name='jpegPhoto'">photo: "<xsl:value-of select='userprof:attributeValue'/>", </xsl:if>
			<xsl:if test="@name='uid'">uid: "<xsl:value-of select='userprof:attributeValue'/>", </xsl:if>
			<xsl:if test="@name='seeAlso'">url: "<xsl:value-of select='userprof:attributeValue'/>", </xsl:if>
		</xsl:for-each>
		adr: {
			<xsl:for-each select="./userprof:attribute">
				<xsl:if test="@name='countryName'">countryname: "<xsl:value-of select='userprof:attributeValue'/>", </xsl:if>
				<xsl:if test="@name='localityName'">locality: "<xsl:value-of select='userprof:attributeValue'/>", </xsl:if>
				<xsl:if test="@name='postalCode'">postalcode: "<xsl:value-of select='userprof:attributeValue'/>", </xsl:if>
				<xsl:if test="@name='roomNumber'">extendedaddress: "<xsl:value-of select='userprof:attributeValue'/>", </xsl:if>
				<xsl:if test="@name='stateOrProvinceName'">region: "<xsl:value-of select='userprof:attributeValue'/>", </xsl:if>
				<xsl:if test="@name='street'">streetaddress: "<xsl:value-of select='userprof:attributeValue'/>", </xsl:if>
			</xsl:for-each>
			dummy: ""
		}, 
		n: {
			<xsl:for-each select="./userprof:attribute">
				<xsl:if test="@name='givenName'">givenname: "<xsl:value-of select='userprof:attributeValue'/>", </xsl:if>
				<xsl:if test="@name='ibm-generationQualifier'">honorificsuffix: "<xsl:value-of select='userprof:attributeValue'/>", </xsl:if>
				<xsl:if test="@name='ibm-middleName'">additionalname: "<xsl:value-of select='userprof:attributeValue'/>", </xsl:if>
				<xsl:if test="@name='ibm-personalTitle'">honorificprefix: "<xsl:value-of select='userprof:attributeValue'/>", </xsl:if>
				<xsl:if test="@name='sn'">familyname: "<xsl:value-of select='userprof:attributeValue'/>", </xsl:if>
			</xsl:for-each>
			dummy: ""
		}, 
		org: {
			<xsl:for-each select="./userprof:attribute">
				<xsl:if test="@name='o'">name: "<xsl:value-of select='userprof:attributeValue'/>", </xsl:if>
				<xsl:if test="@name='ou'">unit: "<xsl:value-of select='userprof:attributeValue'/>", </xsl:if>
			</xsl:for-each>
			dummy: ""
		}, 
		tel: {
			<xsl:for-each select="./userprof:attribute">
				<xsl:if test="@name='facsimileTelephoneNumber'">fax: "<xsl:value-of select='userprof:attributeValue'/>", </xsl:if>
				<xsl:if test="@name='mobile'">cell: "<xsl:value-of select='userprof:attributeValue'/>", </xsl:if>
				<xsl:if test="@name='pager'">pager: "<xsl:value-of select='userprof:attributeValue'/>", </xsl:if>
				<xsl:if test="@name='telephoneNumber'">voice: "<xsl:value-of select='userprof:attributeValue'/>", </xsl:if>
			</xsl:for-each>
			dummy: ""
		}, 
		X: {
			<xsl:for-each select="./userprof:attribute">
				<xsl:if test="@name='departmentNumber'">departmentnumber: "<xsl:value-of select='userprof:attributeValue'/>", </xsl:if>
				<xsl:if test="@name='employeeNumber'">employeenumber: "<xsl:value-of select='userprof:attributeValue'/>", </xsl:if>
			</xsl:for-each>
			dummy: ""
		}
	},
</xsl:template>

</xsl:stylesheet>
